package jp.riken.brain.ni.samuraigraph.application;

import java.awt.Frame;
import java.awt.MediaTracker;
import java.awt.event.ActionEvent;
import java.util.HashMap;

import javax.swing.AbstractButton;
import javax.swing.ButtonGroup;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JOptionPane;

import jp.riken.brain.ni.samuraigraph.base.SGUtility;
import jp.riken.brain.ni.samuraigraph.base.SGUtilityText;
import jp.riken.brain.ni.samuraigraph.data.SGDataTypeConstants;

/**
 * A wizard dialog to select data type of array data.
 * 
 */
public class SGArrayDataTypeSelectionWizardDialog extends
        SGDataTypeSelectionWizardDialog {

    /**
     * Serial Version UID
     */
    private static final long serialVersionUID = -9169068127709202582L;

    /**
     * The default constructor.
     */
    public SGArrayDataTypeSelectionWizardDialog() {
        super();
        this.initComponents();
        this.initProperty();
    }

    /**
     * Builds this dialog with.
     * @param owner
     *              the owner of this dialog
     * @param modal
     *              modal if true
     */
    public SGArrayDataTypeSelectionWizardDialog(final Frame owner,
            final boolean modal) {
        super(owner, modal);
        this.initComponents();
        this.initProperty();
    }

   
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        mButtonPanel = new javax.swing.JPanel();
        mPreviousButton = new jp.riken.brain.ni.samuraigraph.base.SGButton();
        mNextButton = new jp.riken.brain.ni.samuraigraph.base.SGButton();
        mOKButton = new jp.riken.brain.ni.samuraigraph.base.SGButton();
        mCancelButton = new jp.riken.brain.ni.samuraigraph.base.SGButton();
        mPanel = new javax.swing.JPanel();
        mSXYPanel = new javax.swing.JPanel();
        mSXYButtonPanel = new javax.swing.JPanel();
        mMultipleLabel = new javax.swing.JLabel();
        mSingleLabel = new javax.swing.JLabel();
        mSingleButton = new javax.swing.JToggleButton();
        mMultipleButton = new javax.swing.JToggleButton();
        mSamplingPanel = new javax.swing.JPanel();
        mSamplingRateCheckBox = new jp.riken.brain.ni.samuraigraph.base.SGCheckBox();
        mSamplingRateField = new jp.riken.brain.ni.samuraigraph.base.SGTextField();
        mSamplingUnitLabel = new javax.swing.JLabel();
        mVXYPanel = new javax.swing.JPanel();
        mVXYButtonPanel = new javax.swing.JPanel();
        mOrthogonalLabel = new javax.swing.JLabel();
        mPolarLabel = new javax.swing.JLabel();
        mOrthogonalButton = new javax.swing.JToggleButton();
        mPolarButton = new javax.swing.JToggleButton();
        mSXYZPanel = new javax.swing.JPanel();
        mSXYZButtonPanel = new javax.swing.JPanel();
        mPseudocolorMapLabel = new javax.swing.JLabel();
        mPseudocolorMapButton = new javax.swing.JToggleButton();

        getContentPane().setLayout(new java.awt.GridBagLayout());

        mPreviousButton.setText("<Prev");
        mPreviousButton.setFont(new java.awt.Font("Dialog", 1, 12));
        mButtonPanel.add(mPreviousButton);

        mNextButton.setText("Next>");
        mNextButton.setFont(new java.awt.Font("Dialog", 1, 12));
        mButtonPanel.add(mNextButton);

        mOKButton.setText("OK");
        mOKButton.setFont(new java.awt.Font("Dialog", 1, 12));
        mButtonPanel.add(mOKButton);

        mCancelButton.setText("Cancel");
        mCancelButton.setFont(new java.awt.Font("Dialog", 1, 12));
        mButtonPanel.add(mCancelButton);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        getContentPane().add(mButtonPanel, gridBagConstraints);

        mPanel.setLayout(new java.awt.GridBagLayout());

        mSXYPanel.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Scalar", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 0, 12))); // NOI18N
        mSXYPanel.setFont(new java.awt.Font("Dialog", 0, 12));
        mSXYPanel.setLayout(new java.awt.GridBagLayout());

        mSXYButtonPanel.setLayout(new java.awt.GridBagLayout());

        mMultipleLabel.setText("Multiple");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.insets = new java.awt.Insets(0, 1, 0, 0);
        mSXYButtonPanel.add(mMultipleLabel, gridBagConstraints);

        mSingleLabel.setText("Single");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 1);
        mSXYButtonPanel.add(mSingleLabel, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        mSXYButtonPanel.add(mSingleButton, gridBagConstraints);
        mSXYButtonPanel.add(mMultipleButton, new java.awt.GridBagConstraints());

        mSXYPanel.add(mSXYButtonPanel, new java.awt.GridBagConstraints());

        mSamplingPanel.setLayout(new java.awt.GridBagLayout());

        mSamplingRateCheckBox.setText("Use Sampling Rate");
        mSamplingRateCheckBox.setFont(new java.awt.Font("Dialog", 0, 12));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(2, 5, 2, 10);
        mSamplingPanel.add(mSamplingRateCheckBox, gridBagConstraints);

        mSamplingRateField.setColumns(3);
        mSamplingRateField.setFont(new java.awt.Font("Dialog", 0, 12));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 10);
        mSamplingPanel.add(mSamplingRateField, gridBagConstraints);

        mSamplingUnitLabel.setFont(new java.awt.Font("Dialog", 0, 12));
        mSamplingUnitLabel.setText("Hz");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 10);
        mSamplingPanel.add(mSamplingUnitLabel, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 5, 5);
        mSXYPanel.add(mSamplingPanel, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 4);
        mPanel.add(mSXYPanel, gridBagConstraints);

        mVXYPanel.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Vector", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 0, 12))); // NOI18N
        mVXYPanel.setLayout(new java.awt.GridBagLayout());

        mVXYButtonPanel.setLayout(new java.awt.GridBagLayout());

        mOrthogonalLabel.setText("Orthogonal");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 1);
        mVXYButtonPanel.add(mOrthogonalLabel, gridBagConstraints);

        mPolarLabel.setText("Polar");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.insets = new java.awt.Insets(0, 1, 0, 0);
        mVXYButtonPanel.add(mPolarLabel, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        mVXYButtonPanel.add(mOrthogonalButton, gridBagConstraints);
        mVXYButtonPanel.add(mPolarButton, new java.awt.GridBagConstraints());

        mVXYPanel.add(mVXYButtonPanel, new java.awt.GridBagConstraints());

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 4);
        mPanel.add(mVXYPanel, gridBagConstraints);

        mSXYZPanel.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Other", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 0, 12))); // NOI18N
        mSXYZPanel.setLayout(new java.awt.GridBagLayout());

        mSXYZButtonPanel.setLayout(new java.awt.GridBagLayout());

        mPseudocolorMapLabel.setText("Pseudocolor Map");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        mSXYZButtonPanel.add(mPseudocolorMapLabel, gridBagConstraints);
        mSXYZButtonPanel.add(mPseudocolorMapButton, new java.awt.GridBagConstraints());

        mSXYZPanel.add(mSXYZButtonPanel, new java.awt.GridBagConstraints());

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 4);
        mPanel.add(mSXYZPanel, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(10, 10, 0, 10);
        getContentPane().add(mPanel, gridBagConstraints);

        pack();
    }// </editor-fold>//GEN-END:initComponents
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel mButtonPanel;
    protected jp.riken.brain.ni.samuraigraph.base.SGButton mCancelButton;
    private javax.swing.JToggleButton mMultipleButton;
    private javax.swing.JLabel mMultipleLabel;
    protected jp.riken.brain.ni.samuraigraph.base.SGButton mNextButton;
    protected jp.riken.brain.ni.samuraigraph.base.SGButton mOKButton;
    private javax.swing.JToggleButton mOrthogonalButton;
    private javax.swing.JLabel mOrthogonalLabel;
    private javax.swing.JPanel mPanel;
    private javax.swing.JToggleButton mPolarButton;
    private javax.swing.JLabel mPolarLabel;
    protected jp.riken.brain.ni.samuraigraph.base.SGButton mPreviousButton;
    private javax.swing.JToggleButton mPseudocolorMapButton;
    private javax.swing.JLabel mPseudocolorMapLabel;
    private javax.swing.JPanel mSXYButtonPanel;
    private javax.swing.JPanel mSXYPanel;
    private javax.swing.JPanel mSXYZButtonPanel;
    private javax.swing.JPanel mSXYZPanel;
    private javax.swing.JPanel mSamplingPanel;
    jp.riken.brain.ni.samuraigraph.base.SGCheckBox mSamplingRateCheckBox;
    private jp.riken.brain.ni.samuraigraph.base.SGTextField mSamplingRateField;
    private javax.swing.JLabel mSamplingUnitLabel;
    private javax.swing.JToggleButton mSingleButton;
    private javax.swing.JLabel mSingleLabel;
    private javax.swing.JPanel mVXYButtonPanel;
    private javax.swing.JPanel mVXYPanel;
    // End of variables declaration//GEN-END:variables

    /**
     * Initialization method.
     */
    private boolean initProperty() {
        // set the title
        this.setTitle(SGDataTypeSelectionWizardDialog.TITLE);

        // create icon array
        final String[] filenameArray = ICON_FILENAME_ARRAY;
        final int num = filenameArray.length;
        ImageIcon[] icons = new ImageIcon[num];
        for (int ii = 0; ii < num; ii++) {
            icons[ii] = this.createIcon(filenameArray[ii]);
        }
        MediaTracker mt = new MediaTracker(this);
        for (int ii = 0; ii < num; ii++) {
            mt.addImage(icons[ii].getImage(), ii);
        }
        try {
            mt.waitForAll();
        } catch (InterruptedException e) {
        }

        // a map of file name and icon
        HashMap<String, ImageIcon> iconMap = new HashMap<String, ImageIcon>();
        for (int ii = 0; ii < num; ii++) {
            iconMap.put(filenameArray[ii], icons[ii]);
        }

        // set icons
        this.setupButton(this.mSingleButton, iconMap, SINGLE_XY_ICON_FILENAME, SINGLE_SXY);
        this.setupButton(this.mMultipleButton, iconMap, MULTIPLE_XY_ICON_FILENAME, MULTIPLE_SXY);
        this.setupButton(this.mOrthogonalButton, iconMap, ORTHOGONAL_ICON_FILENAME, ORTHOGONAL_VXY);
        this.setupButton(this.mPolarButton, iconMap, POLAR_ICON_FILENAME, POLAR_VXY);
        this.setupButton(this.mPseudocolorMapButton, iconMap, PSEUDOCOLOR_MAP_ICON_FILENAME, PSEUDOCOLOR_MAP);
        this.pack();

        // create a button-group
        ButtonGroup group = new ButtonGroup();
        group.add(this.mSingleButton);
        group.add(this.mMultipleButton);
        group.add(this.mOrthogonalButton);
        group.add(this.mPolarButton);
        group.add(this.mPseudocolorMapButton);

        // initialize components
        this.mSamplingRateField.setEnabled(false);
        this.mSamplingRateField.setText(Double.toString(1.0));
        this.mSingleButton.setSelected(true);
        this.mSingleButton.requestFocusInWindow();

        // add itself as an action lister
        this.mSingleButton.addActionListener(this);
        this.mMultipleButton.addActionListener(this);
        this.mOrthogonalButton.addActionListener(this);
        this.mPolarButton.addActionListener(this);
        this.mPseudocolorMapButton.addActionListener(this);
        this.mSamplingRateCheckBox.addActionListener(this);
        this.mSamplingRateField.addActionListener(this);

        // setup button array
        this.mDataTypeButtonArray = new DataTypeButton[5];
        this.mDataTypeButtonArray[0] = new DataTypeButton(
        	SGDataTypeConstants.SXY_DATA, this.mSingleButton);
        this.mDataTypeButtonArray[1] = new DataTypeButton(
        	SGDataTypeConstants.SXY_DATA, this.mMultipleButton);
        this.mDataTypeButtonArray[2] = new DataTypeButton(
        	SGDataTypeConstants.VXY_DATA, this.mOrthogonalButton);
        this.mDataTypeButtonArray[3] = new DataTypeButton(
        	SGDataTypeConstants.VXY_DATA, this.mPolarButton);
        this.mDataTypeButtonArray[4] = new DataTypeButton(
            	SGDataTypeConstants.SXYZ_DATA, this.mPseudocolorMapButton);

        return true;
    }

    protected JButton getPreviousButton() {
        return this.mPreviousButton;
    }

    protected JButton getNextButton() {
        return this.mNextButton;
    }

    protected JButton getOKButton() {
        return this.mOKButton;
    }

    protected JButton getCancelButton() {
        return this.mCancelButton;
    }
    
    /**
     * Returns the button to select the single scalar type graph.
     *
     * @return the button to select the single scalar type graph
     */
    protected AbstractButton getSingleSXYGraphButton() {
        return this.mSingleButton;
    }

    /**
     * Returns the button to select the multiple scalar type graph.
     *
     * @return the button to select the multiple scalar type graph
     */
    protected AbstractButton getMultipleSXYGraphButton() {
        return this.mMultipleButton;
    }

    /**
     * Returns the button to select the orthogonal vector graph.
     *
     * @return the button to select the orthogonal vector graph
     */
    protected AbstractButton getOrthogonalVectorGraphButton() {
        return this.mOrthogonalButton;
    }

    /**
     * Returns the button to select the polar vector graph.
     *
     * @return the button to select the polar vector graph
     */
    protected AbstractButton getPolarVectorGraphButton() {
        return this.mPolarButton;
    }

    /**
     * Returns the button to select the pseudocolor map.
     *
     * @return the button to select the pseudocolor map
     */
    protected AbstractButton getPseudocolorMapButton() {
        return this.mPseudocolorMapButton;
    }
    
    /**
     * Returns the sampling rate.
     *
     * @return Sampling rate. If input value is illegal, returns null.
     */
    public Double getSamplingRate() {
    	if (this.mSamplingRateCheckBox.isSelected() == false) {
    		return null;
    	}
        String str = this.mSamplingRateField.getText();
        return SGUtilityText.getDouble(str);
    }

    /**
     * Update the components.
     *
     */
    protected void updateComponents() {
        super.updateComponents();
        final boolean samplingEnabled = this.mSingleButton.isSelected()
                || this.mMultipleButton.isSelected();
        this.mSamplingRateCheckBox.setEnabled(samplingEnabled);
        this.mSamplingRateField.setEnabled(samplingEnabled
                && this.mSamplingRateCheckBox.isSelected());
    }

    /**
     * Overrode to check validity of the input value.
     */
    protected boolean onOK() {

        // check the sampling rate
    	if (this.mSamplingRateCheckBox.isSelected()) {
            boolean ok = true;
            final Double d = this.getSamplingRate();
            if (d == null) {
                ok = false;
            } else {
                final double rate = d.doubleValue();
                if (rate <= 0.0) {
                    ok = false;
                }
            }
            if (!ok) {
                SGUtility.showMessageDialog(this, MSG_INVALID_INPUT_VALUE,
                        TITLE_ERROR, JOptionPane.ERROR_MESSAGE);
                return false;
            }
        }

        return super.onOK();
    }

    /**
     * Overrode to set availability of the text field.
     */
    public void actionPerformed(final ActionEvent e) {

        Object source = e.getSource();
        if (source.equals(this.mSamplingRateField)) {
            this.onOK();
            return;
        }

        // calls the method of the super class
        super.actionPerformed(e);
    }
    
    public void setSamplingRateSelected(final boolean b) {
    	this.mSamplingRateCheckBox.setSelected(b);
    }
}
