package jp.riken.brain.ni.samuraigraph.application;

/**
 * Constants used in this application.
 * 
 */
public interface SGIApplicationConstants {

    /**
     * Application resource directory
     */
    public static final String APPLICATION_RESOURCE_DIRECTORY = "resources";

    /**
     * Application property File
     */
    public static final String APPLICATION_PROPERTY_FILENAME = "samurai-graph.properties";

    /**
     * Version string in property file
     */
    public static final String VERSION_PROPERTY_NAME = "samurai-graph.version";

    /**
     * File type constant for general type data file, that is interpreted as a text file.
     */
    public static final int FILETYPE_DATA = 0;

    /**
     * File type constant for a property file.
     */
    public static final int FILETYPE_PROPERTY = 1;

    /**
     * File type constant for a data set file.
     */
    public static final int FILETYPE_DATASET = 2;

    /**
     * File type constant for an image file.
     */
    public static final int FILETYPE_IMAGE = 3;

    /**
     * File type constant for a netCDF type data file.
     */
    public static final int FILETYPE_NETCDF = 4;
    
    /**
     * File type constant for a script file.
     */
    public static final int FILETYPE_SCRIPT = 5;
    
    /**
     * File type constant for a output data file.
     */
    public static final int FILETYPE_OUTPUT_DATA = 6;
    
    /**
     * A constant that represents that the file type is not selected.
     */
    public static final int FILETYPE_NONE = -1;
    
    /**
     * Application plugin directory
     */
    public static final String APPLICATION_PLUGIN_DIRECTORY = "plugins";

}
