package jp.riken.brain.ni.samuraigraph.application;

/**
 * Constants for the archive file.
 */
public interface SGIArchiveFileConstants {

    /**
     * File extension of the archive files.
     */
    public static final String ARCHIVE_FILE_EXTENSION = "sga";

    /**
     * Description of the archive files.
     */
    public static final String ARCHIVE_FILE_DESCRIPTION = "Samurai Graph Archive File";
    
    /**
     * File type name of the archive files.
     */
    public static final String ARCHIVE_FILETYPE_SGA = "sga";

    /**
     * Default name of the archive file.
     */
    public static final String DEFAULT_ARCHIVE_FILE_NAME = "dataset";

    /**
     * Description of the archive files for older version.
     */
    public static final String ARCHIVE_FILE_DESCRIPTION_OLDER = "Samurai Graph Archive File 1.0.7";
    
    /**
     * File type name of the archive files for older version.
     */
    public static final String ARCHIVE_FILETYPE_SGA107 = "sga107";
    
    /**
     * File extension of the netCDF archive files.
     */
    public static final String ARCHIVE_FILE_NETCDF_EXTENSION = "nc";
    
    /**
     * Description of the netCDF archive files.
     */
    public static final String ARCHIVE_FILE_DESCRIPTION_NETCDF = "Samurai Graph netCDF Archive File";
    
    /**
     * File type name of the netCDF archive files.
     */
    public static final String ARCHIVE_FILETYPE_NETCDF = "netCDF";
    
    /**
     * Image name in an archive file.
     */
    public static final String ARCHIVE_IMAGE_NAME = "img";
}
