/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * SGNetCDFDataSetupWizardDialog.java
 *
 * Created on 2009/08/12, 14:12:54
 */

package jp.riken.brain.ni.samuraigraph.application;

import java.awt.event.ActionEvent;
import java.awt.event.ComponentEvent;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.util.Map;

import javax.swing.JButton;
import javax.swing.JOptionPane;
import javax.swing.SwingUtilities;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;

import jp.riken.brain.ni.samuraigraph.base.SGDataColumnInfoSet;
import jp.riken.brain.ni.samuraigraph.base.SGUtility;
import jp.riken.brain.ni.samuraigraph.base.SGUtilityText;
import jp.riken.brain.ni.samuraigraph.data.SGDataUtility;
import jp.riken.brain.ni.samuraigraph.data.SGIDataColumnTypeConstants;
import jp.riken.brain.ni.samuraigraph.data.SGNetCDFData;
import jp.riken.brain.ni.samuraigraph.data.SGNetCDFFile;

/**
 * A wizard dialog to setup netCDF data when it is added.
 * 
 */
public class SGNetCDFDataSetupWizardDialog extends SGWizardDialog 
    implements PropertyChangeListener, DocumentListener, SGIDataColumnTypeConstants,
        SGIApplicationTextConstants {

    /**
     * Serial Version UID
     */
    private static final long serialVersionUID = 9030133791210821567L;
    
    /**
     * The title of this dialog.
     */
    public static final String TITLE = "Setup netCDF data";

    /** Creates new form SGNetCDFDataSetupWizardDialog */
    public SGNetCDFDataSetupWizardDialog(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
        this.initProperty();
    }

    /** Creates new form SGNetCDFDataSetupWizardDialog */
    public SGNetCDFDataSetupWizardDialog(java.awt.Dialog parent, boolean modal) {
        super(parent, modal);
        initComponents();
        this.initProperty();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        mButtonPanel = new javax.swing.JPanel();
        mPreviousButton = new jp.riken.brain.ni.samuraigraph.base.SGButton();
        mNextButton = new jp.riken.brain.ni.samuraigraph.base.SGButton();
        mOKButton = new jp.riken.brain.ni.samuraigraph.base.SGButton();
        mCancelButton = new jp.riken.brain.ni.samuraigraph.base.SGButton();
        mNetCDFDataSetupPanel = new jp.riken.brain.ni.samuraigraph.data.SGNetCDFDataSetupPanel();
        mDataNamePanel = new javax.swing.JPanel();
        mDataNameLabel = new javax.swing.JLabel();
        mDataNameTextField = new jp.riken.brain.ni.samuraigraph.base.SGTextField();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        getContentPane().setLayout(new java.awt.GridBagLayout());

        mPreviousButton.setText("<Prev");
        mPreviousButton.setFont(new java.awt.Font("Dialog", 1, 12));
        mButtonPanel.add(mPreviousButton);

        mNextButton.setText("Next>");
        mNextButton.setFont(new java.awt.Font("Dialog", 1, 12));
        mButtonPanel.add(mNextButton);

        mOKButton.setText("OK");
        mOKButton.setFont(new java.awt.Font("Dialog", 1, 12));
        mButtonPanel.add(mOKButton);

        mCancelButton.setText("Cancel");
        mCancelButton.setFont(new java.awt.Font("Dialog", 1, 12));
        mButtonPanel.add(mCancelButton);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        getContentPane().add(mButtonPanel, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 4);
        getContentPane().add(mNetCDFDataSetupPanel, gridBagConstraints);

        mDataNamePanel.setLayout(new java.awt.GridBagLayout());

        mDataNameLabel.setFont(new java.awt.Font("Dialog", 1, 12));
        mDataNameLabel.setText("Data Name");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 4);
        mDataNamePanel.add(mDataNameLabel, gridBagConstraints);

        mDataNameTextField.setColumns(20);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 4);
        mDataNamePanel.add(mDataNameTextField, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.VERTICAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 4);
        getContentPane().add(mDataNamePanel, gridBagConstraints);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel mButtonPanel;
    private jp.riken.brain.ni.samuraigraph.base.SGButton mCancelButton;
    private javax.swing.JLabel mDataNameLabel;
    private javax.swing.JPanel mDataNamePanel;
    private jp.riken.brain.ni.samuraigraph.base.SGTextField mDataNameTextField;
    private jp.riken.brain.ni.samuraigraph.data.SGNetCDFDataSetupPanel mNetCDFDataSetupPanel;
    private jp.riken.brain.ni.samuraigraph.base.SGButton mNextButton;
    private jp.riken.brain.ni.samuraigraph.base.SGButton mOKButton;
    private jp.riken.brain.ni.samuraigraph.base.SGButton mPreviousButton;
    // End of variables declaration//GEN-END:variables
    
    
    /**
     * Initialize this dialog.
     */
    private boolean initProperty() {
        // set the title
        this.setTitle(TITLE);
        
        // add this dialog as an action event listener of the buttons
        this.mNetCDFDataSetupPanel.getClearButton().addActionListener(this);
        this.mNetCDFDataSetupPanel.getRestoreButton().addActionListener(this);
        this.mNetCDFDataSetupPanel.getComplementButton().addActionListener(this);

        // add this dialog as a property change event listener of the table
        this.mNetCDFDataSetupPanel.getTable().addPropertyChangeListener(this);
        
        // add this dialog as an action event listener
        this.mDataNameTextField.addActionListener(this);
        this.mNetCDFDataSetupPanel.getMultipleDimensionStartField().getDocument().addDocumentListener(this);
        this.mNetCDFDataSetupPanel.getMultipleDimensionEndField().getDocument().addDocumentListener(this);
        this.mNetCDFDataSetupPanel.getMultipleDimensionStepField().getDocument().addDocumentListener(this);
        
        this.mNetCDFDataSetupPanel.setPopupDialogOwner(this);

        return true;
    }
    
    protected JButton getCancelButton() {
        return this.mCancelButton;
    }

    protected JButton getNextButton() {
        return this.mNextButton;
    }

    protected JButton getOKButton() {
        return this.mOKButton;
    }

    protected JButton getPreviousButton() {
        return this.mPreviousButton;
    }

    /**
     * Clear all data.
     */
    public void clear() {
        this.mNetCDFDataSetupPanel.clear();
    }

    /**
     * Returns data column information
     * 
     * @return data column information
     */
    public SGDataColumnInfoSet getDataColumnInfoSet() {
        return this.mNetCDFDataSetupPanel.getDataColumnInfoSet();
    }

    /**
     * Called when the component is resized.
     *
     * @param e
     *            a component event
     */
    public void componentResized(ComponentEvent e) {
        super.componentResized(e);
        this.updateTable();
    }

    /**
     * Called when the component is shown.
     *
     * @param e
     *            a component event
     */
    public void componentShown(ComponentEvent e) {
        super.componentShown(e);
        this.updateTable();
    }
    
    /**
     * Update the table.
     */
    private void updateTable() {
        this.mNetCDFDataSetupPanel.updateTable();
    }

    /**
     * Sets the netCDF data.
     * 
     * @param ncFile
     *           the netCDF data
     * @param dataType
     *            type of data
     * @param colInfoSet
     *            data columns
     * @param infoMap
     *            a map of information
     * @param showDefault
     *            a flag whether to show default column type
     * @return true if succeeded
     */
    public boolean setData(SGNetCDFFile ncFile, String dataType,
            SGDataColumnInfoSet colInfoSet,
            Map<String, Object> infoMap, final boolean showDefault) {
        
        if (this.mNetCDFDataSetupPanel.setData(ncFile, dataType, colInfoSet,
        		infoMap, showDefault) == false) {
            return false;
        }
        
        // set data name
        String name = (String) infoMap.get(KEY_DATA_NAME);
        this.setDataName(name);

        // set visible of next button
        if (SGDataUtility.isSXYTypeData(dataType)) {
            this.getNextButton().setVisible(true);
        } else {
            this.getNextButton().setVisible(false);
        }
        
        // enable the OK button
        this.getOKButton().setEnabled(true);
        this.getNextButton().setEnabled(true);

        return true;
    }

    /**
     * Set information of data columns.
     * 
     * @param data
     *            netCDF data
     * @param colInfoSet
     *            data columns
     * @param infoMap
     *            a map of information
     * @param showDefault
     *            a flag whether to show default column type
     * @return true if succeeded
     */
    public boolean setData(SGNetCDFData data, 
            SGDataColumnInfoSet colInfoSet,
            Map<String, Object> infoMap, final boolean showDefault) {
        
        if (this.mNetCDFDataSetupPanel.setData(data, colInfoSet, infoMap, showDefault) == false) {
            return false;
        }
        
        // set data name
        String name = (String) infoMap.get(KEY_DATA_NAME);
        this.setDataName(name);
        
        // enable the OK button
        this.getOKButton().setEnabled(true);
        this.getNextButton().setEnabled(true);

        return true;
    }
    
    /**
     * Called when an action event is generated.
     * @param e
     *         an action event
     */
    public void actionPerformed(ActionEvent e) {
        super.actionPerformed(e);
        Object source = e.getSource();
        if (source.equals(this.mNetCDFDataSetupPanel.getClearButton())) {
            this.getOKButton().setEnabled(false);
            this.getNextButton().setEnabled(false);
        } else if (source.equals(this.mNetCDFDataSetupPanel.getRestoreButton())) {
            this.getOKButton().setEnabled(true);
            this.getNextButton().setEnabled(true);
        } else if (source.equals(this.mNetCDFDataSetupPanel.getComplementButton())) {
            this.getOKButton().setEnabled(true);
            this.getNextButton().setEnabled(true);
        } else if (source.equals(this.mDataNameTextField)) {
            this.onOK();
        }
    }
    
    /**
     * Called when the table is changed.
     * 
     * @param evt
     *            an event that the property changes
     */
    public void propertyChange(PropertyChangeEvent evt) {
        Object source = evt.getSource();
        if (source.equals(this.mNetCDFDataSetupPanel.getTable())) {
            String name = evt.getPropertyName();
            if ("tableCellEditor".equals(name)) {
                SwingUtilities.invokeLater(new InputObserver());
            }
        }
    }
    
    /**
     * An observer to set enabled / disabled the OK button with input values.
     *
     */
    class InputObserver extends Thread {
    	InputObserver() {
    		super();
    	}
    	
    	public void run() {
            final boolean b = mNetCDFDataSetupPanel.checkSelectedItems();
            getOKButton().setEnabled(b);
            getNextButton().setEnabled(b);
        }
    }

    /**
     * Returns a text string input to the text field for the data name.
     * 
     * @return a text string input to the text field for the data name
     */
    public String getDataName() {
        return this.mDataNameTextField.getText();
    }
    
    /**
     * Sets a text string to the text field for the data name.
     * 
     * @param name
     *           a text string set to the text field for the data name
     */
    public void setDataName(final String name) {
        this.mDataNameTextField.setText(name);
    }

    /**
     * Overrode to check validity of the input value.
     */
    protected boolean onOK() {
        // check the data name
        boolean ok = true;
        String name = this.getDataName();
        if (!SGUtilityText.isValidString(name)) {
            ok = false;
        }
        if (!ok) {
            SGUtility.showMessageDialog(this, MSG_INVALID_INPUT_VALUE,
                    TITLE_ERROR, JOptionPane.ERROR_MESSAGE);
            return false;
        }
        return super.onOK();
    }
    
    public Integer getMultipleDimensionStart() {
    	return this.mNetCDFDataSetupPanel.getMultipleDimensionStart();
    }
    
    public Integer getMultipleDimensionEnd() {
        return this.mNetCDFDataSetupPanel.getMultipleDimensionEnd();
    }
    
    public Integer getMultipleDimensionStep() {
    	return this.mNetCDFDataSetupPanel.getMultipleDimensionStep();
    }
    
    public Boolean isVariableDataType() {
        return this.mNetCDFDataSetupPanel.isVariableDataType();
    }

    /**
     * Called when a text string is inserted.
     */
	public void insertUpdate(DocumentEvent e) {
        SwingUtilities.invokeLater(new InputObserver());
	}

    /**
     * Called when a text string is removed.
     */
	public void removeUpdate(DocumentEvent e) {
        SwingUtilities.invokeLater(new InputObserver());
	}

    /**
     * Called when a text string is changed.
     */
	public void changedUpdate(DocumentEvent e) {
        SwingUtilities.invokeLater(new InputObserver());
	}

}
