package jp.riken.brain.ni.samuraigraph.base;

/**
 * An interface for the data source of the animation.
 * 
 * @author kuromaru
 * 
 */
public interface SGIAnimation {

    /**
     * Returns the number of frames.
     * 
     * @return the number of frames
     */
    public int getFrameNumber();

    /**
     * Returns the current frame index.
     * 
     * @return the current frame index
     */
    public int getCurrentFrameIndex();

    /**
     * Sets the current frame index.
     * 
     * @param index the frame index to be set
     */
    public void setCurrentFrameIndex(int index);

}
