package jp.riken.brain.ni.samuraigraph.base;

import java.util.List;


/**
 * @author okumura
 */
public interface SGIChildObject extends SGIVisible {
    
    /**
     * Returns the ID.
     * 
     * @return the ID
     */
    public int getID();

    /**
     * Sets the ID.
     * 
     * @param id
     *           the number to set to ID
     * @return true if succeeded
     */
    public boolean setID(final int id);
    
    /**
     * Sets the magnification.
     * 
     * @param mag
     *           the magnification to set
     * @return true if succeeded
     */
    public boolean setMagnification(final float mag);
    
    /**
     * Sets the properties directly.
     * 
     * @param map
     *           a map of properties
     * @return the result of setting properties
     */
    public SGPropertyResults setProperties(SGPropertyMap map);

}