package jp.riken.brain.ni.samuraigraph.base;

/**
 * An interface which provides the definition for the data objects.
 * 
 */
public interface SGIData extends SGIDisposable {

    /**
     * Returns the data type.
     * 
     * @return the data type
     */
    public String getDataType();

    /**
     * Returns the data type for given type.
     * 
     * @param type
     *           the type of use
     * @return the data type
     */
    public String getDataType(final int type);

    /**
     * Returns the data source.
     * 
     * @return the data source
     */
    public SGIDataSource getDataSource();
}
