/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * SGDataColumnSelectionDialog.java
 *
 * Created on 2009/07/08, 9:24:33
 */

package jp.riken.brain.ni.samuraigraph.data;

import java.awt.Dialog;
import java.awt.Frame;
import java.beans.PropertyChangeEvent;
import java.util.Map;

import javax.swing.JButton;
import javax.swing.SwingUtilities;

import jp.riken.brain.ni.samuraigraph.base.SGDataColumnInfoSet;

/**
 * 
 * @author kuromaru
 */
public class SGArrayDataColumnSelectionDialog extends SGDataSetupDialog implements
        SGIDataColumnTypeConstants {

    /**
     * Serial Version UID
     */
    private static final long serialVersionUID = -6874865640705737852L;

    /**
     * The title of this dialog.
     */
    public static final String TITLE = "Select the Data Columns";

    /**
     * Builds this dialog.
     * 
     * @param owner
     *           the owner of this dialog
     * @param modal
     *           true for modal dialog
     */
    public SGArrayDataColumnSelectionDialog(Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
        this.initProperty();
    }

    /**
     * Builds this dialog.
     * 
     * @param owner
     *           the owner of this dialog
     * @param modal
     *           true for modal dialog
     */
    public SGArrayDataColumnSelectionDialog(Dialog parent, boolean modal) {
        super(parent, modal);
        initComponents();
        this.initProperty();
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */

    // <editor-fold defaultstate="collapsed" desc="Generated
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        mButtonPanel = new javax.swing.JPanel();
        mOKButton = new jp.riken.brain.ni.samuraigraph.base.SGButton();
        mCancelButton = new jp.riken.brain.ni.samuraigraph.base.SGButton();
        mDataColumnSelectionPanel = new jp.riken.brain.ni.samuraigraph.data.SGArrayDataColumnSelectionPanel();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        getContentPane().setLayout(new java.awt.GridBagLayout());

        mOKButton.setText("OK");
        mOKButton.setFont(new java.awt.Font("Dialog", 1, 12));
        mButtonPanel.add(mOKButton);

        mCancelButton.setText("Cancel");
        mCancelButton.setFont(new java.awt.Font("Dialog", 1, 12));
        mButtonPanel.add(mCancelButton);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        getContentPane().add(mButtonPanel, gridBagConstraints);
        getContentPane().add(mDataColumnSelectionPanel, new java.awt.GridBagConstraints());

        pack();
    }// </editor-fold>//GEN-END:initComponents

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel mButtonPanel;
    private jp.riken.brain.ni.samuraigraph.base.SGButton mCancelButton;
    private jp.riken.brain.ni.samuraigraph.data.SGArrayDataColumnSelectionPanel mDataColumnSelectionPanel;
    private jp.riken.brain.ni.samuraigraph.base.SGButton mOKButton;
    // End of variables declaration//GEN-END:variables

    /**
     * Initialize this dialog.
     */
    private boolean initProperty() {
        
        // set the title
        this.setTitle(TITLE);

        // add this dialog as an action event listener of the buttons
        this.getOKButton().addActionListener(this);
        this.getCancelButton().addActionListener(this);
        this.mDataColumnSelectionPanel.getRestoreButton().addActionListener(this);
        this.mDataColumnSelectionPanel.getClearButton().addActionListener(this);
        this.mDataColumnSelectionPanel.getComplementButton().addActionListener(this);

        // add this dialog as a property change event listener of the table
        this.mDataColumnSelectionPanel.getTable().addPropertyChangeListener(this);

        return true;
    }

    /**
     * Returns the OK button of this dialog.
     * 
     * @return the OK button
     */
    protected JButton getOKButton() {
        return this.mOKButton;
    }

    /**
     * Returns the Cancel button of this dialog.
     * 
     * @return the Cancel button
     */
    protected JButton getCancelButton() {
        return this.mCancelButton;
    }

    /**
     * Returns an object that has a table to setup data.
     * 
     * @return an object that has a table to setup data
     */
    protected SGIDataSetupTableHolder getTableHolder() {
        return this.mDataColumnSelectionPanel;
    }

    /**
     * Set information of data columns.
     * 
     * @param dataType
     *            type of data
     * @param colInfoSet
     *            data columns
     * @param infoMap
     *            a map of information
     * @param showDefault
     *            a flag whether to show default column type
     * @return true if succeeded
     */
    public boolean setData(String dataType, SGDataColumnInfoSet colInfoSet,
    		Map<String, Object> infoMap, 
    		final boolean showDefault) {
        return this.mDataColumnSelectionPanel.setData(dataType, colInfoSet,
        		infoMap, showDefault);
    }

    /**
     * Called when the table is changed.
     * 
     * @param evt
     *            an event that the property changes
     */
    public void propertyChange(PropertyChangeEvent evt) {
    	super.propertyChange(evt);
        Object source = evt.getSource();
        if (source.equals(this.getTableHolder().getTable())) {
            String name = evt.getPropertyName();
            if ("tableCellEditor".equals(name)) {
                SwingUtilities.invokeLater(new Runnable(){
                    public void run() {
                    	mDataColumnSelectionPanel.updateSelectedItems();
                    }
                });
            }
        }
    }

}
