/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * SGAnimationSetupDialog.java
 *
 * Created on 2009/11/02, 10:06:28
 */

package jp.riken.brain.ni.samuraigraph.data;

import java.awt.Component;
import java.awt.MediaTracker;
import java.awt.event.ActionEvent;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.WindowEvent;
import java.net.URL;

import javax.swing.BoundedRangeModel;
import javax.swing.DefaultBoundedRangeModel;
import javax.swing.DefaultListCellRenderer;
import javax.swing.ImageIcon;
import javax.swing.JList;
import javax.swing.ListCellRenderer;
import javax.swing.SwingUtilities;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import jp.riken.brain.ni.samuraigraph.base.SGAnimationThread;
import jp.riken.brain.ni.samuraigraph.base.SGDialog;
import jp.riken.brain.ni.samuraigraph.base.SGIAnimationConstants;
import jp.riken.brain.ni.samuraigraph.base.SGIConstants;
import jp.riken.brain.ni.samuraigraph.base.SGAnimationThread.AnimationThreadObserver;

/**
 * A dialog to set configuration of animation of data object.
 * 
 * @author kuromaru
 */
public class SGDataAnimationConfigurationDialog extends SGDialog
        implements SGIAnimationConstants, ItemListener, ChangeListener, 
        AnimationThreadObserver, MouseListener {

    /**
     * Serial Version UID
     */
    private static final long serialVersionUID = -422924558519688171L;
    
    /**
     * The title of this dialog.
     */
    public static final String TITLE = "Setup the Animation";

    /**
     * Builds a new dialog.
     * 
     * @param parent
     *           the parent of this dialog
     * @param modal
     *           true to create a modal dialog
     */
    public SGDataAnimationConfigurationDialog(java.awt.Frame parent, final boolean modal) {
        super(parent, modal);
        initComponents();
        this.initProperty();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        mLoopPlaybackCheckBox = new jp.riken.brain.ni.samuraigraph.base.SGCheckBox();
        mTimeIntervalLabel = new javax.swing.JLabel();
        mSlider = new javax.swing.JSlider();
        mPlayerButtonPanel = new javax.swing.JPanel();
        mPlayButton = new jp.riken.brain.ni.samuraigraph.base.SGButton();
        mStopButton = new jp.riken.brain.ni.samuraigraph.base.SGButton();
        mPauseButton = new jp.riken.brain.ni.samuraigraph.base.SGButton();
        mPreviousButton = new jp.riken.brain.ni.samuraigraph.base.SGButton();
        mNextButton = new jp.riken.brain.ni.samuraigraph.base.SGButton();
        mBeginningButton = new jp.riken.brain.ni.samuraigraph.base.SGButton();
        mEndingButton = new jp.riken.brain.ni.samuraigraph.base.SGButton();
        mButtonPanel = new javax.swing.JPanel();
        mRestoreButton = new jp.riken.brain.ni.samuraigraph.base.SGButton();
        mCloseButton = new jp.riken.brain.ni.samuraigraph.base.SGButton();
        mTimeIntervalComboBox = new jp.riken.brain.ni.samuraigraph.base.SGComboBox();
        mVariablePanel = new javax.swing.JPanel();
        mNameLabel = new javax.swing.JLabel();
        mValueTextField = new jp.riken.brain.ni.samuraigraph.base.SGTextField();
        mUnitLabel = new javax.swing.JLabel();
        mEqualLabel = new javax.swing.JLabel();
        mSecondLabel = new javax.swing.JLabel();

        getContentPane().setLayout(new java.awt.GridBagLayout());

        mLoopPlaybackCheckBox.setText("Loop Playback");
        mLoopPlaybackCheckBox.setFont(new java.awt.Font("Dialog", 0, 12));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        getContentPane().add(mLoopPlaybackCheckBox, gridBagConstraints);

        mTimeIntervalLabel.setFont(new java.awt.Font("Dialog", 0, 12));
        mTimeIntervalLabel.setText("Time Interval");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 10, 5, 5);
        getContentPane().add(mTimeIntervalLabel, gridBagConstraints);

        mSlider.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        getContentPane().add(mSlider, gridBagConstraints);

        mPlayerButtonPanel.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        mPlayerButtonPanel.setLayout(new java.awt.GridBagLayout());

        mPlayButton.setPreferredSize(new java.awt.Dimension(24, 24));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 1);
        mPlayerButtonPanel.add(mPlayButton, gridBagConstraints);

        mStopButton.setPreferredSize(new java.awt.Dimension(24, 24));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.insets = new java.awt.Insets(5, 1, 5, 5);
        mPlayerButtonPanel.add(mStopButton, gridBagConstraints);

        mPauseButton.setPreferredSize(new java.awt.Dimension(24, 24));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.insets = new java.awt.Insets(5, 1, 5, 1);
        mPlayerButtonPanel.add(mPauseButton, gridBagConstraints);

        mPreviousButton.setPreferredSize(new java.awt.Dimension(24, 24));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 4;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.insets = new java.awt.Insets(5, 1, 5, 1);
        mPlayerButtonPanel.add(mPreviousButton, gridBagConstraints);

        mNextButton.setPreferredSize(new java.awt.Dimension(24, 24));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 5;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.insets = new java.awt.Insets(5, 1, 5, 1);
        mPlayerButtonPanel.add(mNextButton, gridBagConstraints);

        mBeginningButton.setPreferredSize(new java.awt.Dimension(24, 24));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 1);
        mPlayerButtonPanel.add(mBeginningButton, gridBagConstraints);

        mEndingButton.setPreferredSize(new java.awt.Dimension(24, 24));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 6;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.insets = new java.awt.Insets(5, 1, 5, 5);
        mPlayerButtonPanel.add(mEndingButton, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridwidth = 4;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        getContentPane().add(mPlayerButtonPanel, gridBagConstraints);

        mRestoreButton.setText("Restore");
        mRestoreButton.setFont(new java.awt.Font("Dialog", 1, 12));
        mButtonPanel.add(mRestoreButton);

        mCloseButton.setText("Close");
        mCloseButton.setFont(new java.awt.Font("Dialog", 1, 12));
        mButtonPanel.add(mCloseButton);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.gridwidth = 4;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        getContentPane().add(mButtonPanel, gridBagConstraints);

        mTimeIntervalComboBox.setFont(new java.awt.Font("Dialog", 0, 12));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        getContentPane().add(mTimeIntervalComboBox, gridBagConstraints);

        mVariablePanel.setLayout(new java.awt.GridBagLayout());

        mNameLabel.setFont(new java.awt.Font("Dialog", 0, 12));
        mNameLabel.setText("Name");
        mNameLabel.setPreferredSize(new java.awt.Dimension(40, 16));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 0);
        mVariablePanel.add(mNameLabel, gridBagConstraints);

        mValueTextField.setColumns(6);
        mValueTextField.setEditable(false);
        mValueTextField.setText("Value");
        mValueTextField.setFont(new java.awt.Font("Dialog", 0, 12));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 2, 5, 0);
        mVariablePanel.add(mValueTextField, gridBagConstraints);

        mUnitLabel.setFont(new java.awt.Font("Dialog", 0, 12));
        mUnitLabel.setText("Unit");
        mUnitLabel.setPreferredSize(new java.awt.Dimension(200, 13));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        mVariablePanel.add(mUnitLabel, gridBagConstraints);

        mEqualLabel.setFont(new java.awt.Font("Dialog", 0, 12));
        mEqualLabel.setText(" = ");
        mEqualLabel.setPreferredSize(new java.awt.Dimension(16, 16));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 5, 0);
        mVariablePanel.add(mEqualLabel, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 4;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        getContentPane().add(mVariablePanel, gridBagConstraints);

        mSecondLabel.setFont(new java.awt.Font("Dialog", 0, 12));
        mSecondLabel.setText("[sec]");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 5, 5);
        getContentPane().add(mSecondLabel, gridBagConstraints);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private jp.riken.brain.ni.samuraigraph.base.SGButton mBeginningButton;
    private javax.swing.JPanel mButtonPanel;
    private jp.riken.brain.ni.samuraigraph.base.SGButton mCloseButton;
    private jp.riken.brain.ni.samuraigraph.base.SGButton mEndingButton;
    private javax.swing.JLabel mEqualLabel;
    private jp.riken.brain.ni.samuraigraph.base.SGCheckBox mLoopPlaybackCheckBox;
    private javax.swing.JLabel mNameLabel;
    private jp.riken.brain.ni.samuraigraph.base.SGButton mNextButton;
    private jp.riken.brain.ni.samuraigraph.base.SGButton mPauseButton;
    private jp.riken.brain.ni.samuraigraph.base.SGButton mPlayButton;
    private javax.swing.JPanel mPlayerButtonPanel;
    private jp.riken.brain.ni.samuraigraph.base.SGButton mPreviousButton;
    private jp.riken.brain.ni.samuraigraph.base.SGButton mRestoreButton;
    private javax.swing.JLabel mSecondLabel;
    private javax.swing.JSlider mSlider;
    private jp.riken.brain.ni.samuraigraph.base.SGButton mStopButton;
    private jp.riken.brain.ni.samuraigraph.base.SGComboBox mTimeIntervalComboBox;
    private javax.swing.JLabel mTimeIntervalLabel;
    private javax.swing.JLabel mUnitLabel;
    private jp.riken.brain.ni.samuraigraph.base.SGTextField mValueTextField;
    private javax.swing.JPanel mVariablePanel;
    // End of variables declaration//GEN-END:variables

    /**
     * Initialize the properties.
     */
    private void initProperty() {
        
        // set the title
        this.setTitle(TITLE);
        
        // set values to the combo box
        for (int ii = 0; ii < ANIMATION_TIME_INTERVALS.length; ii++) {
            this.mTimeIntervalComboBox.addItem(Integer.valueOf(ANIMATION_TIME_INTERVALS[ii]));
        }
        
//        // set the spinner model
//        this.mStepSizeSpinner.initProperties(new SpinnerNumberModel((float) ANIMATION_STEP_SIZE_MIN,
//                (float) ANIMATION_STEP_SIZE_MIN, (float) ANIMATION_STEP_SIZE_MAX,
//                (float) ANIMATION_STEP_SIZE_STEP), null, 0, 0);
//        this.mStepSizeSpinner.setEditable(false);

        // set renderer
        this.mTimeIntervalComboBox.setRenderer(new TimeIntervalComboBoxRenderer());

        // add event listeners
        this.mTimeIntervalComboBox.addItemListener(this);
//        this.mStepSizeSpinner.addChangeListener(this);
        this.mLoopPlaybackCheckBox.addActionListener(this);
        this.mPlayButton.addActionListener(this);
        this.mPauseButton.addActionListener(this);
        this.mStopButton.addActionListener(this);
        this.mBeginningButton.addActionListener(this);
        this.mPreviousButton.addActionListener(this);
        this.mNextButton.addActionListener(this);
        this.mEndingButton.addActionListener(this);
        this.mSlider.addChangeListener(this);
        this.mRestoreButton.addActionListener(this);
        this.mCloseButton.addActionListener(this);
        this.mSlider.addMouseListener(this);
        
        // create icons
        this.mPlayButton.setIcon(this.createIcon("Play.png"));
        this.mPauseButton.setIcon(this.createIcon("Pause.png"));
        this.mStopButton.setIcon(this.createIcon("Stop.png"));
        this.mBeginningButton.setIcon(this.createIcon("Beginning.png"));
        this.mPreviousButton.setIcon(this.createIcon("Previous.png"));
        this.mNextButton.setIcon(this.createIcon("Next.png"));
        this.mEndingButton.setIcon(this.createIcon("Ending.png"));
        
        // set tooltips
        this.mPlayButton.setToolTipText("Play");
        this.mPauseButton.setToolTipText("Pause");
        this.mStopButton.setToolTipText("Stop");
        this.mBeginningButton.setToolTipText("Head");
        this.mPreviousButton.setToolTipText("Prev");
        this.mNextButton.setToolTipText("Next");
        this.mEndingButton.setToolTipText("End");
    }
    
    /**
     * Create an icon object.
     *
     * @param name
     *            name of resource file
     */
    private ImageIcon createIcon(final String name) {
        URL url = this.getClass().getResource(SGIConstants.RESOURCES_DIRNAME + name);
        ImageIcon icon = new ImageIcon(url);
                // set the media tracker
        final MediaTracker mt = new MediaTracker(this);
        mt.addImage(icon.getImage(), 0);
        try {
            mt.waitForAll();
        } catch (InterruptedException ex) {
        }
        return icon;
    }
    
    /**
     * Called when an action event is invoked.
     * 
     * @param e
     *           an action event
     */
    public void actionPerformed(ActionEvent e) {
        Object source = e.getSource();
        if (source.equals(this.mRestoreButton)) {
            this.mAnimationThread.setPlaying(false);
            this.setIndex(this.mInitFrameIndex);
        } else if (source.equals(this.mCloseButton)) {
            // save all changes and close
            this.saveAndClose();
        } else {
            if (this.mAnimationThread != null) {
                if (source.equals(this.mPlayButton)) {
                    this.startAnimation();
                } else if (source.equals(this.mStopButton)) {
                    this.mAnimationThread.setPlaying(false);
                    this.setIndex(0);                    
                } else if (source.equals(this.mPauseButton)) {
                    this.pauseAnimation();
                } else if (source.equals(this.mBeginningButton)) {
                    this.setIndex(0);
                } else if (source.equals(this.mPreviousButton)) {
                    final int index = this.mAnimationThread.getCurrentFrameIndex() - 1;
                    this.setIndex(index);
                } else if (source.equals(this.mNextButton)) {
                    final int index = this.mAnimationThread.getCurrentFrameIndex() + 1;
                    this.setIndex(index);
                } else if (source.equals(this.mEndingButton)) {
                    final int index = this.mAnimationThread.getFrameNumber() - 1;
                    this.setIndex(index);
                } else if (source.equals(this.mLoopPlaybackCheckBox)) {
                    final boolean b = this.mLoopPlaybackCheckBox.isSelected();
                    mLoopPlaybackFlag = b;
                    this.mAnimationThread.setLoopPlaybackEnabled(b);
                }
            }
        }
    }
    
    // start the animation
    private void startAnimation() {
        this.mAnimationThread = new SGDataAnimationThread(this.mAnimationThread);
        this.mAnimationThread.setPlaying(true);
        this.mAnimationThread.start();
    }

    // pause the animation
    private void pauseAnimation() {
        this.mAnimationThread.setPlaying(false);
    }
    
    /**
     * Sets the current index.
     * @param index
     *           an index to be set
     */
    private void setIndex(final int index) {
        final int size = this.mAnimationThread.getFrameNumber();
        if (index < 0 || index >= size) {
            return;
        }
        this.mSlider.setValue(index);
    }

    /**
     * Called when an item event is invoked.
     * 
     * @param e
     *         an item event
     */
    public void itemStateChanged(ItemEvent e) {
        Object source = e.getSource();
        if (source.equals(this.mTimeIntervalComboBox)) {
            Integer item = (Integer) this.mTimeIntervalComboBox.getSelectedItem();
            final int time = item.intValue();
            mTimeInterval = time;
            this.mAnimationThread.setTimeInterval(time);
        }
    }
    
    /**
     * Called when a change event is invoked.
     * 
     * @param e
     *         a change event
     */
    public void stateChanged(ChangeEvent e) {
        Object source = e.getSource();
        if (source.equals(this.mSlider)) {
            final int index = this.mSlider.getValue();
            this.mAnimationThread.setCurrentFrameIndex(index);
            this.setCurrentValue();
//        } else if (source.equals(this.mStepSizeSpinner)) {
//            Object value = this.mStepSizeSpinner.getValue();
//            Integer num = SGUtilityText.getInteger(value.toString());
//            if (num != null) {
//                this.mAnimationThread.setStep(num.intValue());
//            }
        }
    }

    /**
     * Called when the escape key is typed.
     *
     */
    protected void onEscKeyTyped() {
        this.cancelAndClose();
    }

    /**
     * Cancel all changes and close this dialog.
     *
     */
    private void saveAndClose() {
        this.mAnimationThread.setPlaying(false);
        this.mAnimationThread.saveChanges();
        this.close();
    }

    /**
     * Cancel all changes and close this dialog.
     *
     */
    private void cancelAndClose() {
        this.mAnimationThread.setPlaying(false);
        this.mAnimationThread.cancelChanges();
        this.close();
    }

    /**
     * Close this dialog.
     *
     */
    private void close() {
//        this.mAnimationThread.dispose();
//        this.mAnimationThread = null;
        this.setVisible(false);
    }

    /**
     * A thread of an animation.
     */
    private SGDataAnimationThread mAnimationThread = null;
    
    /**
     * The time interval.
     */
    private static int mTimeInterval = ANIMATION_TIME_INTERVALS[2];
    
    /**
     * A flag whether to loop.
     */
    private static boolean mLoopPlaybackFlag = false;

    /**
     * Initial frame index.
     */
    private int mInitFrameIndex = -1;

    /**
     * Sets the animation data source.
     * 
     * @param animation
     *           the animation data source
     */
    public void setAnimation(SGIDataAnimation animation) {
        if (animation == null) {
            throw new IllegalArgumentException("animation == null");
        }
        this.mAnimationThread = new SGDataAnimationThread(animation);
        this.mAnimationThread.addAnimationThreadObserver(this);
        
        // set labels
        final String name = animation.getDataSourceName();
        if (name != null) {
            this.mNameLabel.setText(name);
            this.mNameLabel.setToolTipText(name);
        }
        final String unit = animation.getDataSourceUnitString();
        final String unitText;
        final String unitToolTipText;
        if (unit != null) {
            StringBuffer sb = new StringBuffer();
            sb.append('[');
            sb.append(unit);
            sb.append(']');
            unitText = sb.toString();
            unitToolTipText = unit;
        } else {
        	unitText = "";
        	unitToolTipText = null;
        }
        this.mUnitLabel.setText(unitText);
        this.mUnitLabel.setToolTipText(unitToolTipText);
        
        final Number value = animation.getCurrentValue();
        if (value != null) {
            this.setCurrentValue();
        }
        
        // setup the slider model
        final int initFrameIndex = animation.getCurrentFrameIndex();
        BoundedRangeModel model = new DefaultBoundedRangeModel();
        model.setMinimum(0);
        model.setMaximum(animation.getFrameNumber() - 1);
        model.setExtent(0);
        model.setValue(initFrameIndex);
        this.mSlider.setModel(model);
        
        // set values
//        final int interval = (int) this.mAnimationThread.getTimeInterval();
//        this.mTimeIntervalComboBox.setSelectedItem(Integer.valueOf(interval));
////        this.mStepSizeSpinner.setValue(Integer.valueOf(this.mAnimationThread.getStep()));
        this.mAnimationThread.setTimeInterval(mTimeInterval);
        this.mAnimationThread.setLoopPlaybackEnabled(mLoopPlaybackFlag);
        this.mTimeIntervalComboBox.setSelectedItem(Integer.valueOf(mTimeInterval));
        this.mLoopPlaybackCheckBox.setSelected(mLoopPlaybackFlag);
        
        // set to attribute
        this.mInitFrameIndex = initFrameIndex;
    }

    /**
     * Called when a thread cycle is looped.
     * 
     * @param th
     *          an animation thread
     */
    public void updated(final SGAnimationThread th) {
        SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                final int index = th.getCurrentFrameIndex();
                setIndex(index);
            }
        });
    }

    /**
     * Sets the current value to the components.
     *
     */
    private void setCurrentValue() {
        SGIDataAnimation dAnim = (SGIDataAnimation) this.mAnimationThread.getAnimation();
        final Number value = dAnim.getCurrentValue();
        final String strValue = value.toString();
        this.mValueTextField.setText(strValue);
        this.mValueTextField.setToolTipText(strValue);
        final int num = dAnim.getFrameNumber() - 1;
        final int index = dAnim.getCurrentFrameIndex();
        StringBuffer sb = new StringBuffer();
        sb.append(index);
        sb.append('/');
        sb.append(num);
        this.mSlider.setToolTipText(sb.toString());
        this.mValueTextField.setCaretPosition(0);
    }
    
    /**
     * Renderer class for the combo box for time interval.
     * @author kuromaru
     *
     */
    protected static class TimeIntervalComboBoxRenderer extends
            DefaultListCellRenderer implements ListCellRenderer {
        /**
         * Serial Version UID
         */
        private static final long serialVersionUID = 2127680422351963884L;
        
        /**
         * Builds a renderer object.
         *
         */
        public TimeIntervalComboBoxRenderer() {
            super();
        }
        
        /**
         * Returns a component.
         */
        public Component getListCellRendererComponent(JList list, Object value,
                int index, boolean isSelected, boolean cellHasFocus) {
            Integer num = (Integer) value;
            final float sec = num.floatValue() / 1000;
            setText(Float.toString(sec));
            if (isSelected) {
                this.setBackground(list.getSelectionBackground());
                this.setForeground(list.getSelectionForeground());
            } else {
                this.setBackground(list.getBackground());
                this.setForeground(list.getForeground());
            }
            return this;
        }

    }

    public void mouseClicked(MouseEvent e) {
    }

    public void mouseEntered(MouseEvent e) {
    }

    public void mouseExited(MouseEvent e) {
    }
    
    // a temporary flag
    private boolean mTempPlaying = false;

    /**
     * Called when the mouse press event is invoked.
     * 
     * @param e
     *          the mouse event
     */
    public void mousePressed(MouseEvent e) {
        Object source = e.getSource();
        if (source.equals(this.mSlider)) {
            // set to an attribute
            this.mTempPlaying = this.mAnimationThread.isPlaying();
            
            // pause the animation
            this.pauseAnimation();
        }
    }

    /**
     * Called when the mouse release event is invoked.
     * 
     * @param e
     *          the mouse event
     */
    public void mouseReleased(MouseEvent e) {
        Object source = e.getSource();
        if (source.equals(this.mSlider)) {
            if (this.mTempPlaying) {
                // restart the animation
                this.startAnimation();
            }
        }
    }
    
    /**
     * Called when the window is closing.
     * 
     * @param e
     *          the window event
     */
    public void windowClosing(WindowEvent e) {
        super.windowClosing(e);
        this.cancelAndClose();
    }
}
