/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * NewJPanel.java
 *
 * Created on 2009/07/07, 17:24:33
 */

package jp.riken.brain.ni.samuraigraph.data;

import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseWheelEvent;
import java.awt.event.MouseWheelListener;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.swing.BorderFactory;
import javax.swing.DefaultCellEditor;
import javax.swing.JComboBox;
import javax.swing.JScrollBar;
import javax.swing.JTable;
import javax.swing.SwingUtilities;
import javax.swing.event.PopupMenuEvent;
import javax.swing.event.PopupMenuListener;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableColumn;

import jp.riken.brain.ni.samuraigraph.base.SGButton;
import jp.riken.brain.ni.samuraigraph.base.SGDataColumnInfo;
import jp.riken.brain.ni.samuraigraph.base.SGDataColumnInfoSet;


/**
 * A panel to select the data columns.
 * 
 */
public abstract class SGDataColumnSelectionPanel extends javax.swing.JPanel
        implements SGIDataColumnTypeConstants, MouseWheelListener,
        ActionListener, PropertyChangeListener, SGIDataSetupTableHolder {

    /**
     * Serial Version UID
     */
    private static final long serialVersionUID = 4393429488857680488L;
    
    /** Creates new form NewJPanel */
    public SGDataColumnSelectionPanel() {
        super();
        initComponents();
        this.initProperty();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        mTableScrollPane = new javax.swing.JScrollPane();
        mTable = this.createTableInstance();
        mButtonPanel = new javax.swing.JPanel();
        mComplementButton = new jp.riken.brain.ni.samuraigraph.base.SGButton();
        mRestoreButton = new jp.riken.brain.ni.samuraigraph.base.SGButton();
        mClearButton = new jp.riken.brain.ni.samuraigraph.base.SGButton();
        mDataTypePanel = new javax.swing.JPanel();
        mDataTypeLabel = new javax.swing.JLabel();

        setLayout(new java.awt.GridBagLayout());

        mTableScrollPane.setBorder(null);
        mTableScrollPane.setHorizontalScrollBarPolicy(javax.swing.ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);
        mTableScrollPane.setFont(new java.awt.Font("Dialog", 0, 11));
        mTableScrollPane.setPreferredSize(new java.awt.Dimension(434, 120));

        mTable.setFont(new java.awt.Font("Dialog", 0, 11)); // NOI18N
        mTableScrollPane.setViewportView(mTable);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        add(mTableScrollPane, gridBagConstraints);

        mComplementButton.setText("Complement");
        mComplementButton.setFont(new java.awt.Font("Dialog", 1, 12));
        mButtonPanel.add(mComplementButton);

        mRestoreButton.setText("Restore");
        mRestoreButton.setFont(new java.awt.Font("Dialog", 1, 12));
        mButtonPanel.add(mRestoreButton);

        mClearButton.setText("Clear");
        mClearButton.setFont(new java.awt.Font("Dialog", 1, 12));
        mButtonPanel.add(mClearButton);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 0, 4);
        add(mButtonPanel, gridBagConstraints);

        mDataTypePanel.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Data Type", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 1, 12))); // NOI18N
        mDataTypePanel.setLayout(new java.awt.GridBagLayout());

        mDataTypeLabel.setFont(new java.awt.Font("Dialog", 0, 12));
        mDataTypeLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        mDataTypeLabel.setText("                ");
        mDataTypeLabel.setPreferredSize(new java.awt.Dimension(120, 16));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.insets = new java.awt.Insets(0, 2, 2, 2);
        mDataTypePanel.add(mDataTypeLabel, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 5, 0);
        add(mDataTypePanel, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel mButtonPanel;
    private jp.riken.brain.ni.samuraigraph.base.SGButton mClearButton;
    private jp.riken.brain.ni.samuraigraph.base.SGButton mComplementButton;
    private javax.swing.JLabel mDataTypeLabel;
    private javax.swing.JPanel mDataTypePanel;
    private jp.riken.brain.ni.samuraigraph.base.SGButton mRestoreButton;
    protected javax.swing.JTable mTable;
    private javax.swing.JScrollPane mTableScrollPane;
    // End of variables declaration//GEN-END:variables

    /**
     * The height of each row.
     */
    public static final int ROW_HEIGHT = 20;

    /**
     * The unit increment of the scroll bar.
     */
    protected static final int SCROLL_BAR_UNIT_INCREMENT = ROW_HEIGHT;
    
    /**
     * The block increment of the scroll bar.
     */
    protected static final int SCROLL_BAR_BLOCK_INCREMENT = 4 * SCROLL_BAR_UNIT_INCREMENT;

    /**
     * The minimum width of the combo box for the column type.
     */
    protected static final int COLUMN_TYPE_COMBOX_MIN_WIDTH = 200;
    
    /**
     * The table model.
     */
    protected DataColumnTableModel mTableModel = null;
    
    protected abstract String[] getColumnNameArray();
    
    protected abstract int[] getPreferredColumnWidthArray();
    
    protected abstract DataColumnTableModel createTableModel();
    
    /**
     * Initializes the table model.
     */
    protected void initTableModel() {
        this.mTableModel = this.createTableModel();
        this.mTableModel.setColumnIdentifiers(this.getColumnNameArray());
        this.mTable.setModel(this.mTableModel);
    }

    /**
     * A class of table model.
     */
    protected abstract class DataColumnTableModel extends DefaultTableModel {
        
        /**
         * Serial Version UID
         */
        private static final long serialVersionUID = 2213043296565029421L;

        public DataColumnTableModel() {
            super();
        }

        /**
         * Retuns false for the column for column type.
         */
        public boolean isCellEditable(int row, int col) {
            if (COLUMN_NAME_COLUMN_TYPE.equals(getColumnName(col))) {
                return true;
            } else {
                return false;
            }
        }

        protected abstract void addData(int index, SGDataColumnInfo data);
        
        public int getColumnCount() {
            return getColumnNameArray().length;
        }

        public String getColumnName(int index) {
            return getColumnNameArray()[index];
        }
    }

    /**
     * Returns the table.
     * 
     * @return a table object
     */
    public JTable getTable() {
        return this.mTable;
    }


    /**
     * Creates and returns an instance of a combo box.
     * 
     * @return a new instance of the combo box
     */
    private JComboBox createComboBoxInstance() {
        JComboBox cb = new JComboBox();
        cb.setBorder(BorderFactory.createEmptyBorder());
        return cb;
    }
    
    /**
     * Initialize this panel.
     */
    private void initProperty() {

        this.mRestoreButton.setEnabled(false);
        this.mClearButton.setEnabled(false);
        this.mComplementButton.setEnabled(false);

        // initialize the table model
        this.initTableModel();

        // set the height of all rows
        this.mTable.setRowHeight(ROW_HEIGHT);
        
        // set up the combo box
        this.mEditorComboBox = this.createComboBoxInstance();
        this.mRendererComboBox = this.createComboBoxInstance();
        ComboBoxWidthAdjuster adjuster = new ComboBoxWidthAdjuster(
        		COLUMN_TYPE_COMBOX_MIN_WIDTH);
        this.mEditorComboBox.addPopupMenuListener(adjuster);
        this.mRendererComboBox.addPopupMenuListener(adjuster);
        this.mEditorComboBox.setMaximumRowCount(12);
        this.mRendererComboBox.setMaximumRowCount(12);

        // add the table as a mouse wheel listener
        this.mTable.addMouseWheelListener(this);
        
        // add an action event listener
        this.mClearButton.addActionListener(this);
        this.mRestoreButton.addActionListener(this);
        this.mComplementButton.addActionListener(this);

        // add a property change event listener
        this.mTable.addPropertyChangeListener(this);

        // set up the scroll bar properties
        JScrollBar vertBar = this.mTableScrollPane.getVerticalScrollBar();
        vertBar.setUnitIncrement(SCROLL_BAR_UNIT_INCREMENT);
        vertBar.setBlockIncrement(SCROLL_BAR_BLOCK_INCREMENT);
    }

    /**
     * Clear all data.
     */
    public void clear() {
        
        // clear attributes
        this.mDataType = null;
        this.mDataTypeLabel.setText("");
        this.mColumnInfoList.clear();
        this.mDataInfoMap = null;
        
        // initialize the table model
        this.initTableModel();
        
        // update the table
        this.updateTable();
    }

    /**
     * Name of the column for the sequential number.
     */
    public static final String COLUMN_NAME_NUMBER = "No.";

    /**
     * Name of the column for the title.
     */
    public static final String COLUMN_NAME_TITLE = "Title";

    /**
     * Name of the column for the type of the value of each data column.
     */
    public static final String COLUMN_NAME_VALUE_TYPE = "Value Type";

    /**
     * Name of the column for the type of each data column.
     */
    public static final String COLUMN_NAME_COLUMN_TYPE = "Column Type";


    /**
     * The type of data.
     */
    protected String mDataType = null;

    /**
     * A list of column information.
     */
    protected List<SGDataColumnInfo> mColumnInfoList = new ArrayList<SGDataColumnInfo>();

    /**
     * A map of data information.
     */
    protected Map<String, Object> mDataInfoMap = null;
    
    /**
     * A flag whether to set default data column type.
     */
    protected boolean mShowDefaultFlag = false;

    /**
     * A combo box for table cell renderer.
     */
    protected JComboBox mRendererComboBox = null;

    /**
     * A combo box for table cell editor.
     */
    protected JComboBox mEditorComboBox = null;

    /**
     * Update the table.
     */
    public void updateTable() {
        this.setPreferredColumnWidth();
    }

    /**
     * Set preferred size of columns.
     */
    private void setPreferredColumnWidth() {
        String[] cArray = getColumnNameArray();
        int[] pArray = getPreferredColumnWidthArray();
        for (int ii = 0; ii < cArray.length; ii++) {
            TableColumn cl = this.mTable.getColumn(cArray[ii]);
            cl.setPreferredWidth(pArray[ii]);
        }
    }
    
    /**
     * Set the data type.
     * @param dataType
     *                the data type to be set
     */
    public void setDataType(final String dataType) {
        if (dataType == null) {
            throw new IllegalArgumentException("dataType == null");
        }
        this.mDataType = dataType;
        
        String text = SGDataTypeConstants.getLongDataTypeConstant(dataType);
        this.mDataTypeLabel.setText(text);
        this.mDataTypeLabel.setToolTipText(text);
    }
    
    protected abstract String[] getDataTypeArray();

    /**
     * Set information of data columns.
     *
     * @param dataType
     *            type of data
     * @param colInfoSet
     *            data columns
     * @param infoMap
     *            a map of information
     * @param showDefault
     *            a flag whether to show default column type
     * @return true if succeeded
     */
    public boolean setData(String dataType, SGDataColumnInfoSet colInfoSet, 
    		Map<String, Object> infoMap, final boolean showDefault) {
        
        if (dataType == null || colInfoSet == null) {
            throw new IllegalArgumentException(
                    "dataType == null || colInfoSet == null");
        }

        // check data types
        String[] dataTypeArray = this.getDataTypeArray();
        boolean bType = false;
        for (int ii = 0; ii < dataTypeArray.length; ii++) {
            if (dataTypeArray[ii].equals(dataType)) {
                bType = true;
                break;
            }
        }
        if (!bType) {
            throw new IllegalArgumentException("Data type is not supported: "
                    + dataType);
        }
        
        // clear old data
        this.clear();

        // set the data type
        this.setDataType(dataType);

        // get data columns
        SGDataColumnInfo[] cols = colInfoSet.getDataColumnInfoArray();

        // set to attributes
        this.mColumnInfoList.clear();
        for (int ii = 0; ii < cols.length; ii++) {
            SGDataColumnInfo info = (SGDataColumnInfo) cols[ii].clone();
            this.mColumnInfoList.add(info);
        }
        this.mDataInfoMap = infoMap;
        this.mShowDefaultFlag = showDefault;

        // set up the combo box
        final int colIndexColumnType = this.getColumnIndex(COLUMN_NAME_COLUMN_TYPE);
        TableColumn col = this.mTable.getColumnModel().getColumn(
                colIndexColumnType);
        col.setCellEditor(new DataColumnCellEditor(this.mEditorComboBox));
        col.setCellRenderer(new DataColumnCellRenderer());

        // set up the table
        for (int ii = 0; ii < cols.length; ii++) {
            SGDataColumnInfo cInfo = (SGDataColumnInfo) this.mColumnInfoList.get(ii);
            this.mTableModel.addData(ii, cInfo);
        }

        // initialize the column for data column type
        if (showDefault) {
            if (this.setDefaultColumnType() == false) {
                return false;
            }
        }

        this.mRestoreButton.setEnabled(true);
        this.mClearButton.setEnabled(true);
        this.mComplementButton.setEnabled(true);
        
        // show or hide the complement button
        if (infoMap.containsKey(KEY_DATA_TYPE) == false) {
            infoMap.put(KEY_DATA_TYPE, dataType);
        }
//        final boolean compVisible = SGDataUtility.isComplementButtonVisible(infoMap);
//        this.mComplementButton.setVisible(compVisible);
        // not use complement button.
        this.mComplementButton.setVisible(false);

        // set the value of vertical scroll bar to zero
        SwingUtilities.invokeLater(new Runnable(){
            public void run() {
                mTableScrollPane.getVerticalScrollBar().setValue(0);
            }
        });

        return true;
    }
    
    protected List<SGDataColumnInfo> getColumnInfoList() {
    	List<SGDataColumnInfo> list = new ArrayList<SGDataColumnInfo>(this.mColumnInfoList);
    	return list;
    }
    
    protected boolean setDefaultColumnType() {
        final int colIndexColumnType = this.getColumnIndex(COLUMN_NAME_COLUMN_TYPE);
        
        // If default column types are to be shown, get them.
        // If null value is returned, return false.
        SGDefaultColumnTypeUtility.DefaultColumnTypeResult result = SGDefaultColumnTypeUtility
                .getDefaultColumnTypes(this.mDataType, this.getColumnInfoList(),
                        this.mDataInfoMap);
        String[] columnTypes = result.getDefaultColumnTypes();
        for (int ii = 0; ii < columnTypes.length; ii++) {
            this.mTable.setValueAt(columnTypes[ii], ii, colIndexColumnType);
        }
        for (int ii = 0; ii < this.mColumnInfoList.size(); ii++) {
        	SGDataColumnInfo colInfo = this.mColumnInfoList.get(ii);
        	colInfo.setColumnType(columnTypes[ii]);
        }
        return result.isSucceeded();
    }

    /**
     * Checks selected items.
     * 
     * @return true if selected items are valid for the data type
     */
    public abstract boolean checkSelectedItems();
    
    /**
     * Updates selected items.
     * 
     * @return true if succeeded
     */
    public boolean updateSelectedItems() {
    	
        final int len = this.getColumnInfoList().size();
        final int colIndexColumnType = this.getColumnIndex(COLUMN_NAME_COLUMN_TYPE);
        String[] items = new String[len];
        for (int ii = 0; ii < len; ii++) {
            items[ii] = (String) this.mTable.getValueAt(ii, colIndexColumnType);
        }
        
        // call a static utility method
        String[] columnTypes = SGDataUtility.updateDataColumns(this.mDataType,
                this.mColumnInfoList.toArray(new SGDataColumnInfo[this.mColumnInfoList.size()]),
                items);
        if (columnTypes == null) {
        	return false;
        }
        
        // set to the table
        for (int ii = 0; ii < len; ii++) {
            this.mTable.setValueAt(columnTypes[ii], ii, colIndexColumnType);
        }
        
    	return true;
    }

    /**
     * Returns the column index of table.
     *
     * @param identifier
     * @return If the column with given identifier exists, returns the index.
     */
    public int getColumnIndex(final String identifier) {
        return this.mTable.getColumnModel().getColumnIndex(identifier);
    }

    /**
     * A cell editor class to display items in a combo box for various data
     * type.
     */
    protected class DataColumnCellEditor extends DefaultCellEditor {

        /**
         * SerialVersionUID
         */
        private static final long serialVersionUID = 1310814500603128330L;

        /**
         * Builds the cell editor for a combo box.
         *
         * @param comboBox
         */
        public DataColumnCellEditor(JComboBox comboBox) {
            super(comboBox);
        }

        /**
         * Returns the combo box component.
         */
        public Component getTableCellEditorComponent(JTable table,
                Object value, boolean isSelected, int row, int column) {

            // get the column info for a given row index
            SGDataColumnInfo cInfo = (SGDataColumnInfo) getColumnInfoList().get(row);

            Map<String, Object> infoMapUpd = new HashMap<String, Object>(mDataInfoMap);

            // the current row index
            infoMapUpd.put(KEY_CURRENT_ROW_INDEX, Integer.valueOf(row));

            // get the combo box items
            String valueType = cInfo.getValueType();
            Map<String, Object> infoMap = SGDataUtility.updateInfoMap(mDataType, 
            		getDataColumnTypes(), infoMapUpd);
            
            // get combo box items
            String[] items = SGDataUtility.getColumnTypeCandidates(mDataType, 
                    infoMap, valueType);

            // set up new combo box items
            JComboBox cb = (JComboBox) super.getTableCellEditorComponent(table,
                    value, isSelected, row, column);
            cb.removeAllItems();
            for (int ii = 0; ii < items.length; ii++) {
                cb.addItem(items[ii]);
            }

            // set value
            cb.setSelectedItem(value);

            return cb;
        }
    }

    /**
     * A cell renderer class to display items in a combo box for various data
     * type.
     */
    protected class DataColumnCellRenderer extends DefaultTableCellRenderer {

        /**
         * SerialVersionUID
         */
        private static final long serialVersionUID = 4333550774377195466L;
        
        /**
         * Builds the cell editor for a combo box.
         *
         * @param comboBox
         */
        public DataColumnCellRenderer() {
            super();
        }

        /**
         * Returns the combo box component.
         */
        public Component getTableCellRendererComponent(JTable table,
                Object value, boolean isSelected, boolean hasFocus, int row,
                int column) {
            
            // set value
            mRendererComboBox.removeAllItems();
            mRendererComboBox.addItem(value);
            
            // set color
            Color bgColor;
            Color fgColor;
            if (isSelected) {
                bgColor = table.getSelectionBackground();
                fgColor = table.getSelectionForeground();
            } else {
                bgColor = table.getBackground();
                fgColor = table.getForeground();
            }
            mRendererComboBox.setBackground(bgColor);
            mRendererComboBox.setForeground(fgColor);
            
            // set tool tip text
            String text = (value == null || "".equals(value)) ? null : value.toString();
            mRendererComboBox.setToolTipText(text);

            return mRendererComboBox;
        }
    }

    
    /**
     * Set visible or invisible this dialog.
     * @param b
     *         true to set visible
     */
    public void setVisible(boolean b) {
        if (!b) {
            // when this dialog is hiddden, clean up the combo box
            if (this.mEditorComboBox != null) {
                this.mEditorComboBox.removeAllItems();
            }
            if (this.mRendererComboBox != null) {
                this.mRendererComboBox.removeAllItems();
            }
        }
        super.setVisible(b);
    }


    /**
     * Returns selected column types.
     * 
     * @return
     *        selected column types
     */
    public SGDataColumnInfo[] getDataColumnTypes() {
//        final int colIndexColumnType = this.getColumnIndex(COLUMN_NAME_COLUMN_TYPE);
//        final int len = this.mColumnInfoList.size();
//        SGDataColumnInfo[] types = new SGDataColumnInfo[len];
//        for (int ii = 0; ii < len; ii++) {
//            SGDataColumnInfo info = (SGDataColumnInfo) this.mColumnInfoList.get(ii);
//            String columnType = (String) this.mTable.getValueAt(ii, colIndexColumnType);
//            types[ii] = (SGDataColumnInfo) info.clone();
//            types[ii].setColumnType(columnType);
//        }
//        return types;
    	SGDataColumnInfoSet columnInfoSet = this.getDataColumnInfoSet();
    	return columnInfoSet.getDataColumnInfoArray();
    }
    
    public SGDataColumnInfoSet getDataColumnInfoSet() {
        final int colIndexColumnType = this.getColumnIndex(COLUMN_NAME_COLUMN_TYPE);
        SGDataColumnInfo[] types = new SGDataColumnInfo[this.mColumnInfoList.size()];
        for (int ii = 0; ii < this.mColumnInfoList.size(); ii++) {
            SGDataColumnInfo info = (SGDataColumnInfo) this.mColumnInfoList.get(ii);
            String columnType = (String) this.mTable.getValueAt(ii, colIndexColumnType);
            types[ii] = (SGDataColumnInfo) info.clone();
            types[ii].setColumnType(columnType);
        }
        SGDataColumnInfoSet colInfoSet = new SGDataColumnInfoSet(types);
        return colInfoSet;
    }

    /**
     * Scroll the vertical scroll bar.
     */
    public void mouseWheelMoved(MouseWheelEvent e) {
        final int amount = e.getScrollAmount() * e.getWheelRotation();
        JScrollBar vertBar = this.mTableScrollPane.getVerticalScrollBar();
        final int value = vertBar.getValue() + amount * 6;
        vertBar.setValue(value);
    }

    /**
     * Called when an action event is generated.
     * 
     * @param e
     *            an action event
     */
    public void actionPerformed(ActionEvent e) {
        Object source = e.getSource();
        if (source.equals(this.mClearButton)) {
            // clear selected data column type
            final int colIndexColumnType = this
                    .getColumnIndex(COLUMN_NAME_COLUMN_TYPE);
            final int rowNum = this.mTable.getRowCount();
            for (int ii = 0; ii < rowNum; ii++) {
                this.mTable.setValueAt("", ii, colIndexColumnType);
            }
            
            // clear combo boxes
            this.mEditorComboBox.setSelectedItem("");
            this.mRendererComboBox.setSelectedItem("");
            
            this.updateComponentsEnabled();
            
        } else if (source.equals(this.mRestoreButton)) {
            final int colIndexColumnType = this
                    .getColumnIndex(COLUMN_NAME_COLUMN_TYPE);
            if (this.mShowDefaultFlag) {
                this.setDefaultColumnType();
            } else {
                final int rowNum = this.mTable.getRowCount();
                List<SGDataColumnInfo> cList = this.getColumnInfoList();
                for (int ii = 0; ii < rowNum; ii++) {
                    SGDataColumnInfo cInfo = (SGDataColumnInfo) cList
                            .get(ii);
                    this.mTable.setValueAt(cInfo.getColumnType(), ii,
                            colIndexColumnType);
                }
            }
            
            // set the value to combo boxes
            final int editRow = this.mTable.getEditingRow();
            if (editRow != -1) {
                Object editingItem = this.mTable.getValueAt(editRow,
                        colIndexColumnType);
                this.mEditorComboBox.setSelectedItem(editingItem);
                this.mRendererComboBox.setSelectedItem(editingItem);
            }
            
            this.updateComponentsEnabled();

        } else if (source.equals(this.mComplementButton)) {
            final int colIndexColumnType = this
					.getColumnIndex(COLUMN_NAME_COLUMN_TYPE);
			final int rowNum = this.mTable.getRowCount();
			String[] colType = new String[rowNum];
			for (int ii = 0; ii < rowNum; ii++) {
				Object obj = this.mTable.getValueAt(ii, colIndexColumnType);
				if (obj == null) {
					colType[ii] = "";
				} else {
					colType[ii] = obj.toString();
				}
			}
			String[] colTypeComp = SGDataUtility.getComplementedColumnType(
					this.mDataInfoMap, colType, this.getColumnInfoList());
			for (int ii = 0; ii < rowNum; ii++) {
				this.mTable.setValueAt(colTypeComp[ii], ii, colIndexColumnType);
			}
			
            this.updateComponentsEnabled();
        }
    }

    /**
     * Returns the button to restore all data column types.
     * 
     * @return the button to restore all data column types
     */
    public SGButton getRestoreButton() {
        return mRestoreButton;
    }

    /**
     * Returns the button to clear all data column types.
     * 
     * @return the button to clear all data column types
     */
    public SGButton getClearButton() {
        return mClearButton;
    }
    
    /**
     * Returns the button to complement the column types.
     * 
     * @return the button to complement the column types
     */
    public SGButton getComplementButton() {
    	return this.mComplementButton;
    }
    
    /**
	 * A PopupMenuListener class to adjust width of the combo box.
	 *
	 */
	protected static class ComboBoxWidthAdjuster implements PopupMenuListener {
		
		/**
		 * The minimum width.
		 */
		private int mMinWidth = 0;

		private boolean mAdjustingFlag = false;

		/**
		 * Builds this object with the given minimum width.
		 * 
		 * @param width
		 *           the minimum with to set
		 */
		public ComboBoxWidthAdjuster(final int width) {
			super();
			this.setMinWidth(width);
		}

		/**
		 * Sets the minimum width.
		 * @param width
		 *           the minimum with to set
		 */
		public void setMinWidth(int width) {
			if (width < 0) {
				width = 0;
			}
			this.mMinWidth = width;
		}

		public void popupMenuWillBecomeVisible(PopupMenuEvent e) {
			JComboBox cb = (JComboBox) e.getSource();
			Dimension size = cb.getSize();
			if (size.width >= this.mMinWidth) {
				return;
			}
			if (!this.mAdjustingFlag) {
				this.mAdjustingFlag = true;
				cb.setSize(this.mMinWidth, size.height);
				cb.showPopup();
			}
			cb.setSize(size);
			this.mAdjustingFlag = false;
		}

		public void popupMenuWillBecomeInvisible(PopupMenuEvent e) {
		}

		public void popupMenuCanceled(PopupMenuEvent e) {
		}
	}
	
    /**
     * Called when the table is changed.
     * 
     * @param evt
     *            an event that the property changes
     */
    public void propertyChange(PropertyChangeEvent evt) {
        Object source = evt.getSource();
        if (source.equals(this.getTable())) {
            String name = evt.getPropertyName();
            if ("tableCellEditor".equals(name)) {
                SwingUtilities.invokeLater(new Runnable(){
                    public void run() {
                    	updateComponentsEnabled();
                    }
                });
            }
        }
    }

    /**
     * Sets enabled or disabled the components with selected variables.
     *
     */
    private void updateComponentsEnabled() {
    	
        // set enabled or disabled the complement button
    	SGDataColumnInfoSet colInfoSet = this.getDataColumnInfoSet();
    	SGDataColumnInfo[] colInfoArray = colInfoSet.getDataColumnInfoArray();
    	String[] curColType = new String[colInfoArray.length];
    	for (int ii = 0; ii < curColType.length; ii++) {
    		curColType[ii] = colInfoArray[ii].getColumnType();
    	}
        final boolean b = SGDataUtility.isComplementedButtonEnabled(
        		this.mDataInfoMap, curColType, this.mColumnInfoList);
        this.getComplementButton().setEnabled(b);
    }

    /**
     * Creates and returns a table object.
     * 
     * @return a table object
     */
    protected abstract JTable createTableInstance();
}
