package jp.riken.brain.ni.samuraigraph.data;

/**
 * Constants of the data type.
 * 
 */
public class SGDataTypeConstants {

    /**
     * A text string for the scalar type XY data.
     */
    public static final String SXY_DATA = "SXY";

    /**
     * A text string for the scalar type XY data in a long form.
     */
    public static final String SXY_DATA_LONG = "Scalar-XY";

    /**
     * A text string for the scalar type XY date data.
     */
    public static final String SXY_DATE_DATA = "SXY_DATE";

    /**
     * A text string for the scalar type XY date data in a long form.
     */
    public static final String SXY_DATE_DATA_LONG = "Date-XY";

    /**
     * A text string for the scalar type XY multiple data.
     */
    public static final String SXY_MULTIPLE_DATA = "SXY_MULTIPLE";

    /**
     * A text string for the scalar type XY multiple data in a long form.
     */
    public static final String SXY_MULTIPLE_DATA_LONG = SXY_DATA_LONG;

    /**
     * A text string for the scalar type XY sampling data.
     */
    public static final String SXY_SAMPLING_DATA = "SXY_SAMPLING";

    /**
     * A text string for the scalar type XY sampling data in a long form.
     */
    public static final String SXY_SAMPLING_DATA_LONG = "Sampling-XY";

    /**
     * A text string for the vector type XY data.
     */
    public static final String VXY_DATA = "VXY";

    /**
     * A text string for the vector type XY data in a long form.
     */
    public static final String VXY_DATA_LONG = "Vector-XY";

    /**
     * A text string for the scalar type XYZ data.
     */
    public static final String SXYZ_DATA = "SXYZ";

    /**
     * A text string for the scalar type XYZ data in a long form.
     */
    public static final String SXYZ_DATA_LONG = "Scalar-XYZ";

    /**
     * A text string for the scalar type XY netCDF data.
     */
    public static final String SXY_NETCDF_DATA = "SXY_NETCDF";

    /**
     * A text string for the scalar type XY netCDF data in a long form.
     */
    public static final String SXY_NETCDF_DATA_LONG = "Scalar-XY";

    /**
     * A text string for the scalar type multiple XY netCDF data.
     */
    public static final String SXY_MULTIPLE_NETCDF_DATA = "SXY_MULTIPLE_NETCDF";

    /**
     * A text string for the scalar type multiple XY netCDF data in a long form.
     */
    public static final String SXY_MULTIPLE_NETCDF_DATA_LONG = SXY_NETCDF_DATA_LONG;
    
    /**
     * A text string for the scalar type multiple XY netCDF Dimension data.
     */
    public static final String SXY_MULTIPLE_NETCDF_DIMENSION_DATA = "SXY_MULTIPLE_NETCDF_PICKUP";
    
    /**
     * A text string for the scalar type multiple XY netCDF Dimension data in a long form.
     */
    public static final String SXY_MULTIPLE_NETCDF_DIMENSION_DATA_LONG = SXY_NETCDF_DATA_LONG;

    /**
     * A text string for the vector type XY netCDF data.
     */
    public static final String VXY_NETCDF_DATA = "VXY_NETCDF";

    /**
     * A text string for the vector type XY netCDF data in a long form.
     */
    public static final String VXY_NETCDF_DATA_LONG = "Vector-XY";

    /**
     * A text string for the scalar type XYZ netCDF data.
     */
    public static final String SXYZ_NETCDF_DATA = "SXYZ_NETCDF";

    /**
     * A text string for the scalar type XYZ netCDF data in a long form.
     */
    public static final String SXYZ_NETCDF_DATA_LONG = "Scalar-XYZ";
    
    /**
     * The correspondence table between various forms of data type constants.
     */
    private static final String[][] DATA_TYPE_ARRAY = {
        {SXY_DATA, SXY_DATA_LONG},
        {SXY_MULTIPLE_DATA, SXY_MULTIPLE_DATA_LONG},
        {SXY_SAMPLING_DATA, SXY_SAMPLING_DATA_LONG},
        {SXY_DATE_DATA, SXY_DATE_DATA_LONG},
        {VXY_DATA, VXY_DATA_LONG},
        {SXYZ_DATA, SXYZ_DATA_LONG},
        {SXY_NETCDF_DATA, SXY_NETCDF_DATA_LONG},
        {SXY_MULTIPLE_NETCDF_DATA, SXY_MULTIPLE_NETCDF_DATA_LONG},
        {SXY_MULTIPLE_NETCDF_DIMENSION_DATA, SXY_MULTIPLE_NETCDF_DIMENSION_DATA_LONG},
        {VXY_NETCDF_DATA, VXY_NETCDF_DATA_LONG},
        {SXYZ_NETCDF_DATA, SXYZ_NETCDF_DATA_LONG}
    };
    
    /**
     * Returns a text string that represents the data type of the long form.
     * 
     * @param dataType
     *                a text string that represents the data type of the short form
     * @return
     *                a text string that represents the data type of the long form
     */
    public static final String getLongDataTypeConstant(final String dataType) {
        String ret = null;
        for (int ii = 0; ii < DATA_TYPE_ARRAY.length; ii++) {
            if (DATA_TYPE_ARRAY[ii][0].equals(dataType)) {
                return DATA_TYPE_ARRAY[ii][1];
            }
        }
        return ret;
    }
}
