package jp.riken.brain.ni.samuraigraph.data;

import java.text.DecimalFormat;
import java.text.ParseException;
import java.util.Calendar;
import java.util.Date;

import jp.riken.brain.ni.samuraigraph.base.SGUtilityText;

/**
 * A class for date.
 * 
 */
public class SGDate {
    private static final String DEFAULT_DATE_FORMAT = "####/##/##";

    protected String mDateString;

    protected int year;

    protected int month;

    protected int date;

    public SGDate(final int Year, final int Month, final int Date) {
        super();
        this.year = Year;
        this.month = Month;
        this.date = Date;
        final DecimalFormat decimalFormat = new DecimalFormat(
                DEFAULT_DATE_FORMAT);
        this.mDateString = decimalFormat.format(this.year * 10000
                + this.month * 100 + this.date);
    }

    public SGDate(final String str) throws ParseException {
        super();
        final Calendar cal = Calendar.getInstance();
        final int cYear = Calendar.YEAR;
        final int cMonth = Calendar.MONTH;
        final int cDate = Calendar.DATE;
        this.mDateString = str;
        final Date d = SGUtilityText.getDate(str);
        if (d == null) {
            throw new ParseException("Parse error", 0);
        }
        cal.setTime(d);
        this.year = cal.get(cYear);
        this.month = cal.get(cMonth);
        this.date = cal.get(cDate);
    }
    
    public String toString() {
        return this.mDateString;
    }
}
