/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * SGGlobalAttributeDialog.java
 *
 * Created on 2009/08/31, 14:11:59
 */

package jp.riken.brain.ni.samuraigraph.data;

import java.util.List;
import javax.swing.JButton;
import javax.swing.JTextArea;
import ucar.nc2.Attribute;
import ucar.nc2.NetcdfFile;

/**
 * The dialog to display the global attributes.
 * @author kuromaru
 */
public class SGGlobalAttributeDialog extends SGAbstractAttributeDialog {

    /**
     * The title of this dialog.
     */
    public static final String TITLE = "Global Attributes";

    /** Creates new form SGGlobalAttributeDialog */
    public SGGlobalAttributeDialog(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
        this.initProperty();
    }

    /** Creates new form SGGlobalAttributeDialog */
    public SGGlobalAttributeDialog(java.awt.Dialog parent, boolean modal) {
        super(parent, modal);
        initComponents();
        this.initProperty();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        mAttributePanel = new jp.riken.brain.ni.samuraigraph.data.SGAttributePanel();
        mCloseButton = new jp.riken.brain.ni.samuraigraph.base.SGButton();
        mScrollPane = new javax.swing.JScrollPane();
        mTextArea = new javax.swing.JTextArea();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        getContentPane().setLayout(new java.awt.GridBagLayout());

        mAttributePanel.setPreferredSize(new java.awt.Dimension(360, 120));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 4);
        getContentPane().add(mAttributePanel, gridBagConstraints);

        mCloseButton.setText("Close");
        mCloseButton.setFont(new java.awt.Font("Dialog", 1, 12));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 4);
        getContentPane().add(mCloseButton, gridBagConstraints);

        mTextArea.setColumns(20);
        mTextArea.setRows(5);
        mScrollPane.setViewportView(mTextArea);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 4);
        getContentPane().add(mScrollPane, gridBagConstraints);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private jp.riken.brain.ni.samuraigraph.data.SGAttributePanel mAttributePanel;
    private jp.riken.brain.ni.samuraigraph.base.SGButton mCloseButton;
    private javax.swing.JScrollPane mScrollPane;
    private javax.swing.JTextArea mTextArea;
    // End of variables declaration//GEN-END:variables

    /**
     * Initialize the properties.
     */
    private void initProperty() {
        // set the title
        this.setTitle(TITLE);

        this.mTextArea.setLineWrap(true);

        // add an action event listener
        this.mCloseButton.addActionListener(this);

        // add a mouse event listener
        this.mAttributePanel.getTable().addMouseListener(this);
    }

    protected JButton getCloseButton() {
        return this.mCloseButton;
    }

    protected JTextArea getTextArea() {
        return this.mTextArea;
    }

    protected SGAttributePanel getAttributePanel() {
        return this.mAttributePanel;
    }

    /**
     * Sets the netCDF file.
     *
     * @param ncFile
     *           a netCDF file
     */
    public void setNetcdfFile(SGNetCDFFile ncFile) {
        List<Attribute> aList = ncFile.getNetcdfFile().getGlobalAttributes();
        this.mAttributePanel.setAttributes(aList);
    }

}
