package jp.riken.brain.ni.samuraigraph.data;

/**
 * Declare static constants for the type of data column.
 *
 */
public interface SGIDataColumnTypeConstants {

    /**
     * A constant for the number type column.
     */
    public static final String VALUE_TYPE_NUMBER = "Number";
    
    /**
     * A constant for the text type column.
     */
    public static final String VALUE_TYPE_TEXT = "Text";

    /**
     * A constant for the date type column.
     */
    public static final String VALUE_TYPE_DATE = "Date";

    /**
     * A constant for the column with the sampling rate.
     */
    public static final String VALUE_TYPE_SAMPLING_RATE = "Sampling Rate";

    /**
     * A constant for the byte date type column.
     */
    public static final String VALUE_TYPE_BYTE_DATA = "Byte Data";

    /**
     * A constant for x value.
     */
    public static final String X_VALUE = "X";

    /**
     * A constant for y value.
     */
    public static final String Y_VALUE = "Y";

    /**
     * A constant for z value.
     */
    public static final String Z_VALUE = "Z";
    
    /**
     * A constant for lower error value.
     */
    public static final String LOWER_ERROR_VALUE = "Lower Error";

    /**
     * A constant for upper error value.
     */
    public static final String UPPER_ERROR_VALUE = "Upper Error";

    /**
     * A constant for lower and upper error value.
     */
    public static final String LOWER_UPPER_ERROR_VALUE = "Lower / Upper Error";
    
    /**
     * A constant for tick label.
     */
    public static final String TICK_LABEL = "Tick Label";

    /**
     * A constant for date.
     */
    public static final String DATE = "Date";

    /**
     * A constant for the x coordinate.
     */
    public static final String X_COORDINATE = "X-Coordinate";

    /**
     * A constant for the y coordinate.
     */
    public static final String Y_COORDINATE = "Y-Coordinate";

    /**
     * A constant for the x component of a vector.
     */
    public static final String X_COMPONENT = "X-Component";

    /**
     * A constant for the y component of a vector.
     */
    public static final String Y_COMPONENT = "Y-Component";

    /**
     * A constant for the magnitude of a vector.
     */
    public static final String MAGNITUDE = "Magnitude";

    /**
     * A constant for the angle of a vector.
     */
    public static final String ANGLE = "Angle";

    /**
     * A constant for the animation.
     */
    public static final String TIME = "Time";
    
    /**
     * A constant for the multiple dimension.
     */
    public static final String PICKUP = "Pickup";

    /**
     * A constant for the serial numbers.
     */
    public static final String SERIAL_NUMBER = "SerialNumbers";

    /**
     * A key string for the data type.
     */
    public static final String KEY_DATA_TYPE = "DataType";
    
    /**
     * A key string for the sampling rate.
     */
    public static final String KEY_SAMPLING_RATE = "Sampling rate";
    
    /**
     * A key string whether the polar mode is selected for the vector data.
     */
    public static final String KEY_POLAR_SELECTED = "Polar selected";
    
    /**
     * A key string whether to draw multiple graphs.
     */
    public static final String KEY_MULTIPLE = "Multiple";
    
    /**
     * A key string whether multiple graphs are for multiple variables.
     */
    public static final String KEY_MULTIPLE_VARIABLE = "Graphs for multiple variables";

    /**
     * A key string for the start index of multiple graph of dimension.
     */
    public static final String KEY_MULTIPLE_DIMENSION_START = "Multiple dimension start";

    /**
     * A key string for the last index of multiple graph of dimension.
     */
    public static final String KEY_MULTIPLE_DIMENSION_END = "Multiple dimension end";

    /**
     * A key string for the step of multiple graph of dimension.
     */
    public static final String KEY_MULTIPLE_DIMENSION_STEP = "Multiple dimension step";

    /**
     * A key string for the data source.
     */
    public static final String KEY_DATA_SOURCE = "Data Source";

    /**
     * A key string for the data name.
     */
    public static final String KEY_DATA_NAME = "Data Name";

    /**
     * A key string for the column information.
     */
    public static final String KEY_COLUMN_INFO = "Column Information";
    
    /**
     * A key string for the current row index.
     */
    public static final String KEY_CURRENT_ROW_INDEX = "Current Row Index";

    /**
     * A key string for the column information of the x values.
     */
    public static final String KEY_SXY_COLUMN_INFO_X = "X Values for SXY";
    
    /**
     * A key string for the column information of the y values.
     */
    public static final String KEY_SXY_COLUMN_INFO_Y = "Y Values for SXY";
}
