package jp.riken.brain.ni.samuraigraph.data;

import jp.riken.brain.ni.samuraigraph.base.SGTuple2d;

/**
 * An interface for the scalar type XYZ data.
 * @author kuromaru
 *
 */
public interface SGISXYZTypeData extends SGIThreeDimensionalData {

    /**
     * Returns an array of x-values.
     * 
     * @return x-value array
     */
    public double[] getXValueArray();

    /**
     * Returns an array of y-values.
     * 
     * @return y-value array
     */
    public double[] getYValueArray();

    /**
     * Returns an array of xy-values.
     * 
     * @return an array of xy-values
     */
    public SGTuple2d[] getXYValueArray();
    
    /**
     * Returns an array of z-values.
     * 
     * @return z-value array
     */
    public double[] getZValueArray();
}
