package jp.riken.brain.ni.samuraigraph.data;

import jp.riken.brain.ni.samuraigraph.base.SGTuple2d;

/**
 * An interface for vector-type XY data.
 */
public interface SGIVXYTypeData extends SGITwoDimensionalData {

    /**
     * Returns a copy of x array.
     * 
     * @return x-value array
     */
    public double[] getXCoordinateArray();

    /**
     * Returns a copy of y array.
     * 
     * @return y-value array
     */
    public double[] getYCoordinateArray();
    
    /**
     * Returns an array of coordinates.
     * 
     * @return an array of coordinates
     */
    public SGTuple2d[] getCoordinateArray();

    /**
     * Returns a copy of magnitude array.
     * 
     * @return magnitude array
     */
    public double[] getMagnitudeArray();

    /**
     * Returns a copy of angle array.
     * 
     * @return angle array
     */
    public double[] getAngleArray();

    /**
     * 
     * @return
     */
    public double[] getXComponentArray();

    /**
     * 
     * @return
     */
    public double[] getYComponentArray();

    /**
     * 
     * @return
     */
    public boolean isPolar();

}
