/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * SGColorMapDialog.java
 *
 * Created on 2009/10/15, 14:46:02
 */

package jp.riken.brain.ni.samuraigraph.figure;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.geom.Rectangle2D;
import java.util.ArrayList;
import java.util.List;

import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.SpinnerNumberModel;

import jp.riken.brain.ni.samuraigraph.base.SGColorBarModel;
import jp.riken.brain.ni.samuraigraph.base.SGColorSelectionButton;
import jp.riken.brain.ni.samuraigraph.base.SGIFigureConstants;
import jp.riken.brain.ni.samuraigraph.base.SGIFigureElementAxis;
import jp.riken.brain.ni.samuraigraph.base.SGIPropertyDialogObserver;
import jp.riken.brain.ni.samuraigraph.base.SGPropertyDialog;
import jp.riken.brain.ni.samuraigraph.base.SGSpinner;
import jp.riken.brain.ni.samuraigraph.base.SGTextField;
import jp.riken.brain.ni.samuraigraph.base.SGUtility;
import jp.riken.brain.ni.samuraigraph.base.SGUtilityText;

/**
 * Property dialog for the color bar.
 * @author kuromaru
 */
public class SGColorBarDialog extends SGPropertyDialog
    implements SGIColorBarConstants, SGIFigureConstants, SGIAxisConstants, ItemListener {

    /**
     * Serial version UID.
     */
    private static final long serialVersionUID = -5966935892328455296L;
    
    /**
     * The title of this dialog.
     */
    public static final String TITLE = "Color Bar Properties";
    
    /** Creates new form SGColorMapDialog */
    public SGColorBarDialog(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
        this.initProperty();
        this.initialize();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        mButtonPanel = new javax.swing.JPanel();
        mOKButton = new jp.riken.brain.ni.samuraigraph.base.SGButton();
        mCancelButton = new jp.riken.brain.ni.samuraigraph.base.SGButton();
        mPreviewButton = new jp.riken.brain.ni.samuraigraph.base.SGButton();
        mAxisSelectionPanel = new jp.riken.brain.ni.samuraigraph.base.SGTwoAxesSelectionPanel();
        mTabbedPane = new javax.swing.JTabbedPane();
        mStylePanel = new javax.swing.JPanel();
        mLinePanel = new javax.swing.JPanel();
        mFrameLineWidthLabel2 = new javax.swing.JLabel();
        mLineColorLabel = new javax.swing.JLabel();
        mTickMarkLabel1 = new javax.swing.JLabel();
        mFrameLineWidthSpinner = new jp.riken.brain.ni.samuraigraph.base.SGSpinner();
        mTickMarkLabel2 = new javax.swing.JLabel();
        mTickMarkLengthLabel1 = new javax.swing.JLabel();
        mTickMarkLengthLabel2 = new javax.swing.JLabel();
        mTickMarkWidthSpinner = new jp.riken.brain.ni.samuraigraph.base.SGSpinner();
        mTickMarkLengthSpinner = new jp.riken.brain.ni.samuraigraph.base.SGSpinner();
        mLineColorButton = new jp.riken.brain.ni.samuraigraph.base.SGColorSelectionButton();
        mFrameLineWidthLabel1 = new javax.swing.JLabel();
        mFontPanel = new javax.swing.JPanel();
        mFontNameLabel = new javax.swing.JLabel();
        mFontSizeLabel = new javax.swing.JLabel();
        mFontColorLabel = new javax.swing.JLabel();
        mFontStyleComboBox = new jp.riken.brain.ni.samuraigraph.base.SGComboBox();
        mFontSizeSpinner = new jp.riken.brain.ni.samuraigraph.base.SGSpinner();
        mFontNameComboBox = new jp.riken.brain.ni.samuraigraph.base.SGComboBox();
        mFontColorButton = new jp.riken.brain.ni.samuraigraph.base.SGColorSelectionButton();
        mFontStyleLabel = new javax.swing.JLabel();
        mColorBarPanel = new javax.swing.JPanel();
        mColorBarStyleLabel = new javax.swing.JLabel();
        mColorBarStyleComboBox = new jp.riken.brain.ni.samuraigraph.base.SGComboBox();
        mColorBarRenderPanel = new javax.swing.JPanel();
        mReversedOrderCheckBox = new jp.riken.brain.ni.samuraigraph.base.SGCheckBox();
        mLayoutPanel = new javax.swing.JPanel();
        mXLabel = new javax.swing.JLabel();
        mYLabel = new javax.swing.JLabel();
        mBarWidthLabel = new javax.swing.JLabel();
        mBarWidthSpinner = new jp.riken.brain.ni.samuraigraph.base.SGSpinner();
        mBarLengthLabel = new javax.swing.JLabel();
        mBarLengthSpinner = new jp.riken.brain.ni.samuraigraph.base.SGSpinner();
        mSpaceLineAndScaleLabel = new javax.swing.JLabel();
        mSpaceLineAndScaleSpinner = new jp.riken.brain.ni.samuraigraph.base.SGSpinner();
        mSpaceScaleAndTitleLabel = new javax.swing.JLabel();
        mSpaceScaleAndTitleSpinner = new jp.riken.brain.ni.samuraigraph.base.SGSpinner();
        mDirectionLabel = new javax.swing.JLabel();
        mDirectionPanel = new javax.swing.JPanel();
        mHorizontalUpperRadioButton = new jp.riken.brain.ni.samuraigraph.base.SGRadioButton();
        mPerpendicularLeftRadioButton = new jp.riken.brain.ni.samuraigraph.base.SGRadioButton();
        mHorizontalLowerRadioButton = new jp.riken.brain.ni.samuraigraph.base.SGRadioButton();
        mPerpendicularRightRadioButton = new jp.riken.brain.ni.samuraigraph.base.SGRadioButton();
        mXValueTextField = new jp.riken.brain.ni.samuraigraph.base.SGTextField();
        mYValueTextField = new jp.riken.brain.ni.samuraigraph.base.SGTextField();
        mAxisParentPanel = new javax.swing.JPanel();

        getContentPane().setLayout(new java.awt.GridBagLayout());

        mOKButton.setText("OK");
        mOKButton.setFont(new java.awt.Font("Dialog", 1, 12));
        mButtonPanel.add(mOKButton);

        mCancelButton.setText("Cancel");
        mCancelButton.setFont(new java.awt.Font("Dialog", 1, 12));
        mButtonPanel.add(mCancelButton);

        mPreviewButton.setText("Preview");
        mPreviewButton.setFont(new java.awt.Font("Dialog", 1, 12));
        mButtonPanel.add(mPreviewButton);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        getContentPane().add(mButtonPanel, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 5);
        getContentPane().add(mAxisSelectionPanel, gridBagConstraints);

        mTabbedPane.setFont(new java.awt.Font("Dialog", 1, 12)); // NOI18N

        mStylePanel.setLayout(new java.awt.GridBagLayout());

        mLinePanel.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Line", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 3, 12))); // NOI18N
        mLinePanel.setLayout(new java.awt.GridBagLayout());

        mFrameLineWidthLabel2.setFont(new java.awt.Font("Dialog", 0, 12));
        mFrameLineWidthLabel2.setText("Width");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(0, 15, 5, 5);
        mLinePanel.add(mFrameLineWidthLabel2, gridBagConstraints);

        mLineColorLabel.setFont(new java.awt.Font("Dialog", 0, 12));
        mLineColorLabel.setText("Color");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridheight = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(5, 10, 10, 5);
        mLinePanel.add(mLineColorLabel, gridBagConstraints);

        mTickMarkLabel1.setFont(new java.awt.Font("Dialog", 0, 12));
        mTickMarkLabel1.setText("Tick Mark");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(5, 20, 0, 5);
        mLinePanel.add(mTickMarkLabel1, gridBagConstraints);

        mFrameLineWidthSpinner.setFont(new java.awt.Font("Dialog", 0, 12));
        mFrameLineWidthSpinner.setPreferredSize(new java.awt.Dimension(70, 22));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridheight = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 5, 5);
        mLinePanel.add(mFrameLineWidthSpinner, gridBagConstraints);

        mTickMarkLabel2.setFont(new java.awt.Font("Dialog", 0, 12));
        mTickMarkLabel2.setText("Width");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(0, 20, 10, 5);
        mLinePanel.add(mTickMarkLabel2, gridBagConstraints);

        mTickMarkLengthLabel1.setFont(new java.awt.Font("Dialog", 0, 12));
        mTickMarkLengthLabel1.setText("Tick Mark");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(5, 10, 0, 5);
        mLinePanel.add(mTickMarkLengthLabel1, gridBagConstraints);

        mTickMarkLengthLabel2.setFont(new java.awt.Font("Dialog", 0, 12));
        mTickMarkLengthLabel2.setText("Length");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(0, 10, 10, 5);
        mLinePanel.add(mTickMarkLengthLabel2, gridBagConstraints);

        mTickMarkWidthSpinner.setFont(new java.awt.Font("Dialog", 0, 12));
        mTickMarkWidthSpinner.setPreferredSize(new java.awt.Dimension(70, 22));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridheight = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 5, 5);
        mLinePanel.add(mTickMarkWidthSpinner, gridBagConstraints);

        mTickMarkLengthSpinner.setFont(new java.awt.Font("Dialog", 0, 12));
        mTickMarkLengthSpinner.setPreferredSize(new java.awt.Dimension(75, 22));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridheight = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 5, 5);
        mLinePanel.add(mTickMarkLengthSpinner, gridBagConstraints);

        mLineColorButton.setPreferredSize(new java.awt.Dimension(65, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridheight = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        mLinePanel.add(mLineColorButton, gridBagConstraints);

        mFrameLineWidthLabel1.setFont(new java.awt.Font("Dialog", 0, 12));
        mFrameLineWidthLabel1.setText("Frame Line");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 15, 0, 5);
        mLinePanel.add(mFrameLineWidthLabel1, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 5);
        mStylePanel.add(mLinePanel, gridBagConstraints);

        mFontPanel.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Font", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 3, 12))); // NOI18N
        mFontPanel.setLayout(new java.awt.GridBagLayout());

        mFontNameLabel.setFont(new java.awt.Font("Dialog", 0, 12));
        mFontNameLabel.setText("Name");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 20, 5, 5);
        mFontPanel.add(mFontNameLabel, gridBagConstraints);

        mFontSizeLabel.setFont(new java.awt.Font("Dialog", 0, 12));
        mFontSizeLabel.setText("Size");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 4;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(5, 10, 5, 5);
        mFontPanel.add(mFontSizeLabel, gridBagConstraints);

        mFontColorLabel.setFont(new java.awt.Font("Dialog", 0, 12));
        mFontColorLabel.setText("Color");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 4;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(5, 10, 5, 5);
        mFontPanel.add(mFontColorLabel, gridBagConstraints);

        mFontStyleComboBox.setFont(new java.awt.Font("Dialog", 0, 12));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        mFontPanel.add(mFontStyleComboBox, gridBagConstraints);

        mFontSizeSpinner.setFont(new java.awt.Font("Dialog", 0, 12));
        mFontSizeSpinner.setPreferredSize(new java.awt.Dimension(70, 22));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 5;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 10);
        mFontPanel.add(mFontSizeSpinner, gridBagConstraints);

        mFontNameComboBox.setFont(new java.awt.Font("Dialog", 0, 12));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        mFontPanel.add(mFontNameComboBox, gridBagConstraints);

        mFontColorButton.setPreferredSize(new java.awt.Dimension(65, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 5;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 10);
        mFontPanel.add(mFontColorButton, gridBagConstraints);

        mFontStyleLabel.setFont(new java.awt.Font("Dialog", 0, 12));
        mFontStyleLabel.setText("Style");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 20, 5, 5);
        mFontPanel.add(mFontStyleLabel, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 5);
        mStylePanel.add(mFontPanel, gridBagConstraints);

        mColorBarPanel.setLayout(new java.awt.GridBagLayout());

        mColorBarStyleLabel.setFont(new java.awt.Font("Dialog", 0, 12));
        mColorBarStyleLabel.setText("Style");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        mColorBarPanel.add(mColorBarStyleLabel, gridBagConstraints);

        mColorBarStyleComboBox.setFont(new java.awt.Font("Dialog", 0, 12));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        mColorBarPanel.add(mColorBarStyleComboBox, gridBagConstraints);

        mColorBarRenderPanel.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        mColorBarRenderPanel.setPreferredSize(new java.awt.Dimension(200, 20));
        mColorBarRenderPanel.setLayout(new javax.swing.BoxLayout(mColorBarRenderPanel, javax.swing.BoxLayout.LINE_AXIS));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 10, 5, 10);
        mColorBarPanel.add(mColorBarRenderPanel, gridBagConstraints);

        mReversedOrderCheckBox.setText("Reversed Order");
        mReversedOrderCheckBox.setFont(new java.awt.Font("Dialog", 0, 12));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(6, 6, 6, 6);
        mColorBarPanel.add(mReversedOrderCheckBox, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 5);
        mStylePanel.add(mColorBarPanel, gridBagConstraints);

        mTabbedPane.addTab("Style", mStylePanel);

        mLayoutPanel.setLayout(new java.awt.GridBagLayout());

        mXLabel.setFont(new java.awt.Font("Dialog", 0, 12));
        mXLabel.setText("X");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(5, 15, 5, 5);
        mLayoutPanel.add(mXLabel, gridBagConstraints);

        mYLabel.setFont(new java.awt.Font("Dialog", 0, 12));
        mYLabel.setText("Y");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(5, 10, 5, 5);
        mLayoutPanel.add(mYLabel, gridBagConstraints);

        mBarWidthLabel.setFont(new java.awt.Font("Dialog", 0, 12));
        mBarWidthLabel.setText("Width");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(5, 15, 5, 5);
        mLayoutPanel.add(mBarWidthLabel, gridBagConstraints);

        mBarWidthSpinner.setFont(new java.awt.Font("Dialog", 0, 12));
        mBarWidthSpinner.setPreferredSize(new java.awt.Dimension(75, 22));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        mLayoutPanel.add(mBarWidthSpinner, gridBagConstraints);

        mBarLengthLabel.setFont(new java.awt.Font("Dialog", 0, 12));
        mBarLengthLabel.setText("Length");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(5, 10, 5, 5);
        mLayoutPanel.add(mBarLengthLabel, gridBagConstraints);

        mBarLengthSpinner.setFont(new java.awt.Font("Dialog", 0, 12));
        mBarLengthSpinner.setPreferredSize(new java.awt.Dimension(75, 22));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 10, 5, 10);
        mLayoutPanel.add(mBarLengthSpinner, gridBagConstraints);

        mSpaceLineAndScaleLabel.setFont(new java.awt.Font("Dialog", 0, 12));
        mSpaceLineAndScaleLabel.setText("to Scale");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(5, 15, 5, 5);
        mLayoutPanel.add(mSpaceLineAndScaleLabel, gridBagConstraints);

        mSpaceLineAndScaleSpinner.setFont(new java.awt.Font("Dialog", 0, 12));
        mSpaceLineAndScaleSpinner.setPreferredSize(new java.awt.Dimension(75, 22));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        mLayoutPanel.add(mSpaceLineAndScaleSpinner, gridBagConstraints);

        mSpaceScaleAndTitleLabel.setFont(new java.awt.Font("Dialog", 0, 12));
        mSpaceScaleAndTitleLabel.setText("to Title");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(5, 10, 5, 5);
        mLayoutPanel.add(mSpaceScaleAndTitleLabel, gridBagConstraints);

        mSpaceScaleAndTitleSpinner.setFont(new java.awt.Font("Dialog", 0, 12));
        mSpaceScaleAndTitleSpinner.setPreferredSize(new java.awt.Dimension(75, 22));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 10, 5, 10);
        mLayoutPanel.add(mSpaceScaleAndTitleSpinner, gridBagConstraints);

        mDirectionLabel.setFont(new java.awt.Font("Dialog", 0, 12));
        mDirectionLabel.setText("Direction");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        mLayoutPanel.add(mDirectionLabel, gridBagConstraints);

        mDirectionPanel.setLayout(new java.awt.GridBagLayout());

        mHorizontalUpperRadioButton.setText("Horizontal Upper");
        mHorizontalUpperRadioButton.setFont(new java.awt.Font("Dialog", 0, 12));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 5);
        mDirectionPanel.add(mHorizontalUpperRadioButton, gridBagConstraints);

        mPerpendicularLeftRadioButton.setText("Perpendicular Left");
        mPerpendicularLeftRadioButton.setFont(new java.awt.Font("Dialog", 0, 12));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 5);
        mDirectionPanel.add(mPerpendicularLeftRadioButton, gridBagConstraints);

        mHorizontalLowerRadioButton.setText("Horizontal Lower");
        mHorizontalLowerRadioButton.setFont(new java.awt.Font("Dialog", 0, 12));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 5);
        mDirectionPanel.add(mHorizontalLowerRadioButton, gridBagConstraints);

        mPerpendicularRightRadioButton.setText("Perpendicular Right");
        mPerpendicularRightRadioButton.setFont(new java.awt.Font("Dialog", 0, 12));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 5);
        mDirectionPanel.add(mPerpendicularRightRadioButton, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        mLayoutPanel.add(mDirectionPanel, gridBagConstraints);

        mXValueTextField.setColumns(6);
        mXValueTextField.setFont(new java.awt.Font("Dialog", 0, 12));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        mLayoutPanel.add(mXValueTextField, gridBagConstraints);

        mYValueTextField.setColumns(6);
        mYValueTextField.setFont(new java.awt.Font("Dialog", 0, 12));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 10, 5, 10);
        mLayoutPanel.add(mYValueTextField, gridBagConstraints);

        mTabbedPane.addTab("Layout", mLayoutPanel);

        mAxisParentPanel.setLayout(new java.awt.GridBagLayout());
        mTabbedPane.addTab("Scale", mAxisParentPanel);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        getContentPane().add(mTabbedPane, gridBagConstraints);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel mAxisParentPanel;
    private jp.riken.brain.ni.samuraigraph.base.SGTwoAxesSelectionPanel mAxisSelectionPanel;
    private javax.swing.JLabel mBarLengthLabel;
    private jp.riken.brain.ni.samuraigraph.base.SGSpinner mBarLengthSpinner;
    private javax.swing.JLabel mBarWidthLabel;
    private jp.riken.brain.ni.samuraigraph.base.SGSpinner mBarWidthSpinner;
    private javax.swing.JPanel mButtonPanel;
    private jp.riken.brain.ni.samuraigraph.base.SGButton mCancelButton;
    private javax.swing.JPanel mColorBarPanel;
    private javax.swing.JPanel mColorBarRenderPanel;
    private jp.riken.brain.ni.samuraigraph.base.SGComboBox mColorBarStyleComboBox;
    private javax.swing.JLabel mColorBarStyleLabel;
    private javax.swing.JLabel mDirectionLabel;
    private javax.swing.JPanel mDirectionPanel;
    private jp.riken.brain.ni.samuraigraph.base.SGColorSelectionButton mFontColorButton;
    private javax.swing.JLabel mFontColorLabel;
    private jp.riken.brain.ni.samuraigraph.base.SGComboBox mFontNameComboBox;
    private javax.swing.JLabel mFontNameLabel;
    private javax.swing.JPanel mFontPanel;
    private javax.swing.JLabel mFontSizeLabel;
    private jp.riken.brain.ni.samuraigraph.base.SGSpinner mFontSizeSpinner;
    private jp.riken.brain.ni.samuraigraph.base.SGComboBox mFontStyleComboBox;
    private javax.swing.JLabel mFontStyleLabel;
    private javax.swing.JLabel mFrameLineWidthLabel1;
    private javax.swing.JLabel mFrameLineWidthLabel2;
    private jp.riken.brain.ni.samuraigraph.base.SGSpinner mFrameLineWidthSpinner;
    private jp.riken.brain.ni.samuraigraph.base.SGRadioButton mHorizontalLowerRadioButton;
    private jp.riken.brain.ni.samuraigraph.base.SGRadioButton mHorizontalUpperRadioButton;
    private javax.swing.JPanel mLayoutPanel;
    private jp.riken.brain.ni.samuraigraph.base.SGColorSelectionButton mLineColorButton;
    private javax.swing.JLabel mLineColorLabel;
    private javax.swing.JPanel mLinePanel;
    private jp.riken.brain.ni.samuraigraph.base.SGButton mOKButton;
    private jp.riken.brain.ni.samuraigraph.base.SGRadioButton mPerpendicularLeftRadioButton;
    private jp.riken.brain.ni.samuraigraph.base.SGRadioButton mPerpendicularRightRadioButton;
    private jp.riken.brain.ni.samuraigraph.base.SGButton mPreviewButton;
    private jp.riken.brain.ni.samuraigraph.base.SGCheckBox mReversedOrderCheckBox;
    private javax.swing.JLabel mSpaceLineAndScaleLabel;
    private jp.riken.brain.ni.samuraigraph.base.SGSpinner mSpaceLineAndScaleSpinner;
    private javax.swing.JLabel mSpaceScaleAndTitleLabel;
    private jp.riken.brain.ni.samuraigraph.base.SGSpinner mSpaceScaleAndTitleSpinner;
    private javax.swing.JPanel mStylePanel;
    private javax.swing.JTabbedPane mTabbedPane;
    private javax.swing.JLabel mTickMarkLabel1;
    private javax.swing.JLabel mTickMarkLabel2;
    private javax.swing.JLabel mTickMarkLengthLabel1;
    private javax.swing.JLabel mTickMarkLengthLabel2;
    private jp.riken.brain.ni.samuraigraph.base.SGSpinner mTickMarkLengthSpinner;
    private jp.riken.brain.ni.samuraigraph.base.SGSpinner mTickMarkWidthSpinner;
    private javax.swing.JLabel mXLabel;
    private jp.riken.brain.ni.samuraigraph.base.SGTextField mXValueTextField;
    private javax.swing.JLabel mYLabel;
    private jp.riken.brain.ni.samuraigraph.base.SGTextField mYValueTextField;
    // End of variables declaration//GEN-END:variables
    
    private SGAxisPanel mAxisPanel = null;

    private JRadioButton mColorBarDirectionNoSelectedRadioButton = new JRadioButton();

    // initialize this dialog
    private void initProperty() {
        
        // set the title
        this.setTitle(TITLE);
        
        // font name
        String fontArray[] = SGUtility.getAvailableFontFamilyNames();
        for (int ii = 0; ii < fontArray.length; ii++) {
            this.mFontNameComboBox.addItem(fontArray[ii]);
        }

        // font style
        String[] styleNameArray = { FONT_PLAIN, FONT_ITALIC, FONT_BOLD,
                FONT_BOLD_ITALIC };
        for (int ii = 0; ii < styleNameArray.length; ii++) {
            this.mFontStyleComboBox.addItem(styleNameArray[ii]);
        }
        
        // color bar style
        String[] colorBarNameArray = SGColorBarStyleManager.DEFAULT_COLOR_BAR_NAMES;
        for (int ii = 0; ii < colorBarNameArray.length; ii++) {
            this.mColorBarStyleComboBox.addItem(colorBarNameArray[ii]);
        }
        
        // add axis panel
        this.mAxisPanel = new SGAxisPanel(SGIFigureElementAxis.AXIS_NORMAL);
        this.mAxisParentPanel.add(this.mAxisPanel);
        
        
        //
        // create button groups
        //
        
        // direction
        ButtonGroup directionGroup = new ButtonGroup();
        directionGroup.add(this.mHorizontalLowerRadioButton);
        directionGroup.add(this.mHorizontalUpperRadioButton);
        directionGroup.add(this.mPerpendicularLeftRadioButton);
        directionGroup.add(this.mPerpendicularRightRadioButton);
        directionGroup.add(this.mColorBarDirectionNoSelectedRadioButton);
        
        //
        // set the spinner model
        //

        // width
        this.mBarWidthSpinner.initProperties(new SpinnerNumberModel(10.0,
                COLOR_BAR_WIDTH_MIN, COLOR_BAR_WIDTH_MAX, COLOR_BAR_WIDTH_STEP),
                COLOR_BAR_SIZE_UNIT, COLOR_BAR_SIZE_FRAC_DIFIT_MIN, 
                COLOR_BAR_SIZE_FRAC_DIFIT_MAX);

        // length
        this.mBarLengthSpinner.initProperties(new SpinnerNumberModel(10.0,
                COLOR_BAR_LENGTH_MIN, COLOR_BAR_LENGTH_MAX, COLOR_BAR_LENGTH_STEP),
                COLOR_BAR_SIZE_UNIT, COLOR_BAR_SIZE_FRAC_DIFIT_MIN,
                COLOR_BAR_SIZE_FRAC_DIFIT_MAX);
        
        // space to scale
        this.mSpaceLineAndScaleSpinner.initProperties(new SpinnerNumberModel(
                0.0, FIGURE_SPACE_TO_SCALE_MIN, FIGURE_SPACE_TO_SCALE_MAX,
                FIGURE_SPACE_STEP), FIGURE_SPACE_UNIT,
                FIGURE_SPACE_FRAC_DIGIT_MIN, FIGURE_SPACE_FRAC_DIGIT_MAX);

        // space to title
        this.mSpaceScaleAndTitleSpinner.initProperties(new SpinnerNumberModel(
                0.0, FIGURE_SPACE_TO_TITLE_MIN, FIGURE_SPACE_TO_TITLE_MAX,
                FIGURE_SPACE_STEP), FIGURE_SPACE_UNIT,
                FIGURE_SPACE_FRAC_DIGIT_MIN, FIGURE_SPACE_FRAC_DIGIT_MAX);

        // line width
        this.mFrameLineWidthSpinner.initProperties(
                getLineWidthSpinnerNumberModel(), LINE_WIDTH_UNIT,
                LINE_WIDTH_FRAC_DIGIT_MIN, LINE_WIDTH_FRAC_DIGIT_MAX);

        // tick mark width
        this.mTickMarkWidthSpinner.initProperties(
                getLineWidthSpinnerNumberModel(), LINE_WIDTH_UNIT,
                LINE_WIDTH_FRAC_DIGIT_MIN, LINE_WIDTH_FRAC_DIGIT_MAX);

        // tick mark length
        this.mTickMarkLengthSpinner.initProperties(new SpinnerNumberModel(
                0.10, AXIS_TICK_LENGTH_MIN, AXIS_TICK_LENGTH_MAX,
                TICK_MARK_LENGTH_STEP), AXIS_TICK_LENGTH_UNIT,
                TICK_MARK_LENGTH_FRAC_DIFIT_MIN,
                TICK_MARK_LENGTH_FRAC_DIFIT_MAX);

        // font size
        this.mFontSizeSpinner.initProperties(getFontSizeSpinnerNumberModel(),
                FONT_SIZE_UNIT, FONT_SIZE_FRAC_DIGIT_MIN, FONT_SIZE_FRAC_DIGIT_MAX);

        // add an action listener
        this.mHorizontalUpperRadioButton.addActionListener(this);
        this.mHorizontalLowerRadioButton.addActionListener(this);
        this.mPerpendicularLeftRadioButton.addActionListener(this);
        this.mPerpendicularRightRadioButton.addActionListener(this);
        this.mReversedOrderCheckBox.addActionListener(this);
        
        // set the name
        this.mXValueTextField.setDescription("Layout-> X");
        this.mYValueTextField.setDescription("Layout-> Y");
        this.mBarWidthSpinner.setDescription("Layout-> Width");
        this.mBarLengthSpinner.setDescription("Layout-> Length");
        this.mSpaceLineAndScaleSpinner.setDescription("Layout-> to Scale");
        this.mSpaceScaleAndTitleSpinner.setDescription("Layout-> to Title");
        this.mFrameLineWidthSpinner.setDescription("Line-> Frame Line Width");
        this.mTickMarkWidthSpinner.setDescription("Line-> Tick Mark Width");
        this.mTickMarkLengthSpinner.setDescription("Line-> Tick Mark Length");
        this.mFontSizeSpinner.setDescription("Font-> Size");
        this.mAxisPanel.mTitleTextField.setDescription("Title-> Label");
        this.mAxisPanel.mMinValueTextField.setDescription("Scale-> Min");
        this.mAxisPanel.mMaxValueTextField.setDescription("Scale-> Max");
        this.mAxisPanel.mStepTextField.setDescription("Scale-> Tick Mark-> Step");
        this.mAxisPanel.mBaseTextField.setDescription("Scale-> Tick Mark-> Base");
        this.mAxisPanel.mExponentSpinner.setDescription("Scale-> Number-> Format-> Exp Part");
        this.mAxisPanel.mNumberAngleSpinner.setDescription("Scale-> Number-> Angle");

        // add action listener
        this.mColorBarStyleComboBox.addItemListener(this);
        
        // set the name of the check box for visibility
        this.mAxisPanel.setVisibleName("Color Bar Visible");
        
        this.mColorBarRenderPanel.add(new ColorBarPanel());
        
        // pack this dialog
        this.pack();
    }

    
    protected JButton getOKButton() {
        return this.mOKButton;
    }
    
    protected JButton getCancelButton() {
        return this.mCancelButton;
    }
    
    protected JButton getPreviewButton() {
        return this.mPreviewButton;
    }

    public List getColorSelectionButtonsList() {
        final List<SGColorSelectionButton> list = new ArrayList<SGColorSelectionButton>();
        list.add(this.mLineColorButton);
        list.add(this.mFontColorButton);
        return list;
    }

    public List getNumberTextFieldList() {
        final List<SGTextField> list = new ArrayList<SGTextField>();
        list.add(this.mXValueTextField);
        list.add(this.mYValueTextField);
        return list;
    }

    @Override
    public List<SGSpinner> getSpinnerList() {
        final List<SGSpinner> list = new ArrayList<SGSpinner>();
        list.add(this.mBarWidthSpinner);
        list.add(this.mBarLengthSpinner);
        list.add(this.mSpaceScaleAndTitleSpinner);
        list.add(this.mSpaceLineAndScaleSpinner);
        list.add(this.mFrameLineWidthSpinner);
        list.add(this.mTickMarkWidthSpinner);
        list.add(this.mTickMarkLengthSpinner);
        list.add(this.mFontSizeSpinner);
        return list;
    }
    
    public List getTextFieldComponentsList() {
        final List list = this.getFormattedTextFieldsListFromSpinners();
        list.addAll(this.getNumberTextFieldList());
        list.addAll(this.mAxisPanel.getTextFieldComponentsList());
        final List<SGSpinner> sList = this.mAxisPanel.getSpinnerList();
        for (int ii = 0; ii < sList.size(); ii++) {
            SGSpinner spinner = (SGSpinner) sList.get(ii);
            list.add(spinner.getFormattedTextField());
        }
        return list;
    }

    
    public Number getXValue() {
        return this.getNumber(this.mXValueTextField);
    }
    
    public Number getYValue() {
        return this.getNumber(this.mYValueTextField);
    }

    public Number getBarWidth() {
        return this.mBarWidthSpinner.getNumber();
    }

    public Number getBarLength() {
        return this.mBarLengthSpinner.getNumber();
    }
    
    public Number getSpaceLineAndScale() {
        return this.mSpaceLineAndScaleSpinner.getNumber();
    }
    
    public Number getSpaceScaleAndTitle() {
        return this.mSpaceScaleAndTitleSpinner.getNumber();
    }
    
    public String getColorBarDirection() {
        String direction = null;
        if (this.mHorizontalLowerRadioButton.isSelected()) {
            direction = SGIColorBarConstants.DIRECTION_HORIZONTAL_LOWER;
        } else if (this.mHorizontalUpperRadioButton.isSelected()) {
            direction = SGIColorBarConstants.DIRECTION_HORIZONTAL_UPPER;
        } else if (this.mPerpendicularLeftRadioButton.isSelected()) {
            direction = SGIColorBarConstants.DIRECTION_PERPENDICULAR_LEFT;
        } else if (this.mPerpendicularRightRadioButton.isSelected()) {
            direction = SGIColorBarConstants.DIRECTION_PERPENDICULAR_RIGHT;
        }
        return direction;
    }
    
    public Boolean isReversedOrder() {
        return this.mReversedOrderCheckBox.getSelected();
    }
    
    public Number getFrameLineWidth() {
        return this.mFrameLineWidthSpinner.getNumber();
    }
    
    public Color getLineColor() {
        return this.mLineColorButton.getColor();
    }
    
    public Number getTickMarkWidth() {
        return this.mTickMarkWidthSpinner.getNumber();
    }
    
    public Number getTickMarkLength() {
        return this.mTickMarkLengthSpinner.getNumber();
    }

    public Boolean isTitleVisible() {
        return this.mAxisPanel.isTitleVisible();
    }

    public String getTitleString() {
        return this.mAxisPanel.getTitleString();
    }
    
    public String getColorBarStyle() {
        return (String) this.mColorBarStyleComboBox.getSelectedItem();
    }
    
    public String getFontName() {
        return (String) this.mFontNameComboBox.getSelectedItem();
    }

    public Number getFontSize() {
        return this.mFontSizeSpinner.getNumber();
    }

    public Integer getFontStyle() {
        final String item = (String) this.mFontStyleComboBox.getSelectedItem();
        return SGUtilityText.getFontStyle(item);
    }

    public Color getFontColor() {
        return this.mFontColorButton.getColor();
    }

    public Number getMinValue() {
        return this.mAxisPanel.getMinValue();
    }

    public Number getMaxValue() {
        return this.mAxisPanel.getMaxValue();
    }

    public Integer getScaleType() {
        return this.mAxisPanel.getScaleType();
    }
    
    public Boolean isScaleInvert() {
        return this.mAxisPanel.getInvCoordFlag();
    }

    public Boolean isTickMarkAuto() {
        return this.mAxisPanel.getAutoCalcFlag();
    }

    public Boolean isTickMarkVisible() {
        return this.mAxisPanel.isTickMarkVisible();
    }

    public Boolean isScaleLineInner() {
        return this.mAxisPanel.getScaleLineDirection();
    }
    
    public Boolean isFormatVisible() {
        return this.mAxisPanel.isFormatVisible();
    }

    public Boolean isFormatInteger() {
        return this.mAxisPanel.isFormatInteger();
    }

    public Boolean isExponentVisible() {
        return this.mAxisPanel.isExponentVisible();
    }

    public Number getExponentValue() {
        return this.mAxisPanel.getExponentValue();
    }
    
    public boolean setXValue(final Object obj) {
        return this.setValue(this.mXValueTextField, obj);
    }

    public boolean setYValue(final Object obj) {
        return this.setValue(this.mYValueTextField, obj);
    }

    public boolean setBarWidth(final Object value) {
        return this.setValue(this.mBarWidthSpinner, value);
    }

    public boolean setBarLength(final Object value) {
        return this.setValue(this.mBarLengthSpinner, value);
    }
    
    public boolean setSpaceLineAndScale(final Object value) {
        return this.setValue(this.mSpaceLineAndScaleSpinner, value);
    }
    
    public boolean setSpaceScaleAndTitle(final Object value) {
        return this.setValue(this.mSpaceScaleAndTitleSpinner, value);
    }
    
    public boolean setColorBarDirection(final String direction) {
        if (direction == null) {
            this.mColorBarDirectionNoSelectedRadioButton.setSelected(true);
        } else {
            if (direction.equals(SGIColorBarConstants.DIRECTION_HORIZONTAL_LOWER)) {
                this.mHorizontalLowerRadioButton.setSelected(true);
            } else if (direction.equals(SGIColorBarConstants.DIRECTION_HORIZONTAL_UPPER)) {
                this.mHorizontalUpperRadioButton.setSelected(true);
            } else if (direction.equals(SGIColorBarConstants.DIRECTION_PERPENDICULAR_LEFT)) {
                this.mPerpendicularLeftRadioButton.setSelected(true);
            } else if (direction.equals(SGIColorBarConstants.DIRECTION_PERPENDICULAR_RIGHT)) {
                this.mPerpendicularRightRadioButton.setSelected(true);
            }
        }
        return true;
    }
    
    public boolean setReversedOrder(final Boolean b) {
        this.mReversedOrderCheckBox.setSelected(b);
        return true;
    }
    
    public boolean setColorBarStyle(final String name) {
        this.mColorBarStyleComboBox.setSelectedItem(name);
        return true;
    }
    
    public boolean setFrameLineWidth(final Object value) {
        return this.setValue(this.mFrameLineWidthSpinner, value);
    }

    public boolean setTickMarkWidth(final Object value) {
        return this.setValue(this.mTickMarkWidthSpinner, value);
    }

    public boolean setTickMarkLength(final Object value) {
        return this.setValue(this.mTickMarkLengthSpinner, value);
    }
    
    public boolean setLineColor(final Color cl) {
        this.mLineColorButton.setColor(cl);
        return true;
    }

    /**
     * Sets the font name.
     * 
     * @param name
     *           the font name to set
     * @return true if succeeded
     */
    public boolean setFontName(final String name) {
    	final String fName = SGUtility.findFontFamilyName(name);
        this.mFontNameComboBox.setSelectedItem(fName);
        return true;
    }

    public boolean setFontSize(final Object value) {
        return this.setValue(this.mFontSizeSpinner, value);
    }

    public boolean setFontStyle(final Integer style) {
        String styleName = null;
        if (style != null) {
            styleName = SGUtilityText.getFontStyleName(style.intValue());
        }
        this.mFontStyleComboBox.setSelectedItem(styleName);
        return true;
    }
    
    public boolean setFontColor(final Color cl) {
        this.mFontColorButton.setColor(cl);
        return true;
    }
    
    public boolean setTitleVisible(final Boolean b) {
        return this.mAxisPanel.setTitleVisible(b);
    }

    public boolean setTitleString(final String str) {
        return this.mAxisPanel.setTitle(str);
    }

    public boolean setMinValue(final Object value) {
        return this.mAxisPanel.setMinValue(value);
    }

    public boolean setMaxValue(final Object value) {
        return this.mAxisPanel.setMaxValue(value);
    }

    public boolean setScaleType(final Integer value) {
        return this.mAxisPanel.setScaleType(value);
    }

    public boolean setScaleInvert(final Boolean b) {
        return this.mAxisPanel.setInvertCoordinates(b);
    }
    
    public boolean setTickMarkAuto(final Boolean b) {
        return this.mAxisPanel.setAutoCalcFlag(b);
    }

    public boolean setStepValue(final Object value) {
        return this.mAxisPanel.setStepValue(value);
    }

    public boolean setBaseValue(final Object value) {
        return this.mAxisPanel.setBaseValue(value);
    }

    public boolean setTickMarkVisible(final Boolean visible) {
        return this.mAxisPanel.setTickMarkVisible(visible);
    }

    public boolean setTickMarkInside(final Boolean value) {
        return this.mAxisPanel.setTickMarkInside(value);
    }

    public boolean setFormatVisible(final Boolean visible) {
        return this.mAxisPanel.setFormatVisible(visible);
    }

    public boolean setFormatInteger(final Boolean b) {
        return this.mAxisPanel.setFormatInteger(b);
    }

    public boolean setExponentVisible(final Boolean b) {
        return this.mAxisPanel.setExponentVisible(b);
    }

    public boolean setExponentValue(final Object value) {
        return this.mAxisPanel.setExponentValue(value);
    }

    
    public boolean setDialogProperty() {
        
        if (this.mPropertyDialogObserverList.size() == 0) {
            return false;
        }
        
        List list = this.mPropertyDialogObserverList;

        // set properties to the axis selection panel
        if (this.mAxisSelectionPanel.setSelected(list) == false) {
            return false;
        }
        
        SGIColorBarDialogObserver obs0 = (SGIColorBarDialogObserver) list.get(0);
        final double xValue0 = obs0.getXValue();
        final double yValue0 = obs0.getYValue();
        final float barWidth0 = obs0.getBarWidth(COLOR_BAR_SIZE_UNIT);
        final float barLength0 = obs0.getBarLength(COLOR_BAR_SIZE_UNIT);
        final float toScale0 = obs0.getSpaceToScale(FIGURE_SPACE_UNIT);
        final float toTitle0 = obs0.getSpaceToTitle(FIGURE_SPACE_UNIT);
        final String direction0 = obs0.getDirection();
        final String style0 = obs0.getColorBarStyle();
        final boolean reversed0 = obs0.isReversedOrder();
        final float frameLineWidth0 = obs0.getFrameLineWidth(LINE_WIDTH_UNIT);
        final Color lineColor0 = obs0.getLineColor();
        final float tickMarkWidth0 = obs0.getTickMarkWidth(LINE_WIDTH_UNIT);
        final float tickMarkLength0 = obs0.getTickMarkLength(AXIS_TICK_LENGTH_UNIT);
        final String fontName0 = obs0.getFontName();
        final float fontSize0 = obs0.getFontSize(FONT_SIZE_UNIT);
        final int fontStyle0 = obs0.getFontStyle();
        final Color fontColor0 = obs0.getFontColor();

        Double xValue = Double.valueOf(xValue0);
        Double yValue = Double.valueOf(yValue0);
        Float barWidth = Float.valueOf(barWidth0);
        Float barLength = Float.valueOf(barLength0);
        Float toScale = Float.valueOf(toScale0);
        Float toTitle = Float.valueOf(toTitle0);
        String direction = direction0;
        Boolean reversed = Boolean.valueOf(reversed0);
        String style = style0;
        Float frameLineWidth = Float.valueOf(frameLineWidth0);
        Color lineColor = lineColor0;
        Float tickMarkWidth = Float.valueOf(tickMarkWidth0);
        Float tickMarkLength = Float.valueOf(tickMarkLength0);
        String fontName = fontName0;
        Float fontSize = Float.valueOf(fontSize0);
        Integer fontStyle = Integer.valueOf(fontStyle0);
        Color fontColor = fontColor0;
        
        if (list.size() > 1) {
            for (int ii = 1; ii < list.size(); ii++) {
                SGIColorBarDialogObserver obs1 = (SGIColorBarDialogObserver) list
                        .get(ii);
                final double xValue1 = obs1.getXValue();
                if (xValue0 != xValue1) {
                    xValue = null;
                    break;
                }
            }
            for (int ii = 1; ii < list.size(); ii++) {
                SGIColorBarDialogObserver obs1 = (SGIColorBarDialogObserver) list
                        .get(ii);
                final double yValue1 = obs1.getYValue();
                if (yValue0 != yValue1) {
                    yValue = null;
                    break;
                }
            }
            for (int ii = 1; ii < list.size(); ii++) {
                SGIColorBarDialogObserver obs1 = (SGIColorBarDialogObserver) list
                        .get(ii);
                final float barWidth1 = obs1.getBarWidth(COLOR_BAR_SIZE_UNIT);
                if (barWidth0 != barWidth1) {
                    barWidth = null;
                    break;
                }
            }
            for (int ii = 1; ii < list.size(); ii++) {
                SGIColorBarDialogObserver obs1 = (SGIColorBarDialogObserver) list
                        .get(ii);
                final float barLength1 = obs1.getBarLength(COLOR_BAR_SIZE_UNIT);
                if (barLength0 != barLength1) {
                    barLength = null;
                    break;
                }
            }
            for (int ii = 1; ii < list.size(); ii++) {
                SGIColorBarDialogObserver obs1 = (SGIColorBarDialogObserver) list
                        .get(ii);
                final float toScale1 = obs1.getSpaceToScale(FIGURE_SPACE_UNIT);
                if (toScale0 != toScale1) {
                    toScale = null;
                    break;
                }
            }
            for (int ii = 1; ii < list.size(); ii++) {
                SGIColorBarDialogObserver obs1 = (SGIColorBarDialogObserver) list
                        .get(ii);
                final float toTitle1 = obs1.getSpaceToTitle(FIGURE_SPACE_UNIT);
                if (toTitle0 != toTitle1) {
                    toTitle = null;
                    break;
                }
            }
            for (int ii = 1; ii < list.size(); ii++) {
                SGIColorBarDialogObserver obs1 = (SGIColorBarDialogObserver) list
                        .get(ii);
                final String direction1 = obs1.getDirection();
                if (!direction0.equals(direction1)) {
                    direction = null;
                    break;
                }
            }
            for (int ii = 1; ii < list.size(); ii++) {
                SGIColorBarDialogObserver obs1 = (SGIColorBarDialogObserver) list
                        .get(ii);
                final boolean reversed1 = obs1.isReversedOrder();
                if (reversed0 != reversed1) {
                    reversed = null;
                    break;
                }
            }
            for (int ii = 1; ii < list.size(); ii++) {
                SGIColorBarDialogObserver obs1 = (SGIColorBarDialogObserver) list
                        .get(ii);
                final String style1 = obs1.getColorBarStyle();
                if (!style0.equals(style1)) {
                    style = null;
                    break;
                }
            }
            for (int ii = 1; ii < list.size(); ii++) {
                SGIColorBarDialogObserver obs1 = (SGIColorBarDialogObserver) list
                        .get(ii);
                final float frameLineWidth1 = obs1.getFrameLineWidth(LINE_WIDTH_UNIT);
                if (frameLineWidth0 != frameLineWidth1) {
                    frameLineWidth = null;
                    break;
                }
            }
            for (int ii = 1; ii < list.size(); ii++) {
                SGIColorBarDialogObserver obs1 = (SGIColorBarDialogObserver) list
                        .get(ii);
                final float tickMarkWidth1 = obs1.getTickMarkWidth(LINE_WIDTH_UNIT);
                if (tickMarkWidth0 != tickMarkWidth1) {
                    tickMarkWidth = null;
                    break;
                }
            }
            for (int ii = 1; ii < list.size(); ii++) {
                SGIColorBarDialogObserver obs1 = (SGIColorBarDialogObserver) list
                        .get(ii);
                final float tickMarkLength1 = obs1.getTickMarkWidth(AXIS_TICK_LENGTH_UNIT);
                if (tickMarkLength0 != tickMarkLength1) {
                    tickMarkLength = null;
                    break;
                }
            }
            for (int ii = 1; ii < list.size(); ii++) {
                SGIColorBarDialogObserver obs1 = (SGIColorBarDialogObserver) list
                        .get(ii);
                final String fontName1 = obs1.getFontName();
                if (fontName0.equals(fontName1) == false) {
                    fontName = null;
                    break;
                }
            }
            for (int ii = 1; ii < list.size(); ii++) {
                SGIColorBarDialogObserver obs1 = (SGIColorBarDialogObserver) list
                        .get(ii);
                final float fontSize1 = obs1.getFontSize(FONT_SIZE_UNIT);
                if (fontSize0 != fontSize1) {
                    fontSize = null;
                    break;
                }
            }
            for (int ii = 1; ii < list.size(); ii++) {
                SGIColorBarDialogObserver obs1 = (SGIColorBarDialogObserver) list
                        .get(ii);
                final int fontStyle1 = obs1.getFontStyle();
                if (fontStyle0 != fontStyle1) {
                    fontStyle = null;
                    break;
                }
            }
            for (int ii = 1; ii < list.size(); ii++) {
                SGIColorBarDialogObserver obs1 = (SGIColorBarDialogObserver) list
                        .get(ii);
                final Color fontColor1 = obs1.getFontColor();
                if (!fontColor0.equals(fontColor1)) {
                    fontColor = null;
                    break;
                }
            }
        }

        // layout
        this.setXValue(xValue);
        this.setYValue(yValue);
        this.setBarWidth(barWidth);
        this.setBarLength(barLength);
        this.setSpaceLineAndScale(toScale);
        this.setSpaceScaleAndTitle(toTitle);
        this.setColorBarDirection(direction);
        this.setReversedOrder(reversed);
        
        // style
        this.setColorBarStyle(style);
        
        // line
        this.setFrameLineWidth(frameLineWidth);
        this.setTickMarkWidth(tickMarkWidth);
        this.setTickMarkLength(tickMarkLength);
        this.setLineColor(lineColor);
        
        // font
        this.setFontName(fontName);
        this.setFontStyle(fontStyle);
        this.setFontSize(fontSize);
        this.setFontColor(fontColor);
        
        // set properties to the axis panel
        if (this.mAxisPanel.setComponentsProperty(new ArrayList(this.mPropertyDialogObserverList)) == false) {
            return false;
        }
        
        return true;
    }

    public boolean setPropertiesToListeners(SGIPropertyDialogObserver obs) {
        
        SGIColorBarDialogObserver cb = (SGIColorBarDialogObserver) obs;

        // get values
        final int xConfig = this.mAxisSelectionPanel.getXAxisLocation();
        final int yConfig = this.mAxisSelectionPanel.getYAxisLocation();
        final Number xValue = this.getXValue();
        final Number yValue = this.getYValue();
        final Number barWidth = this.getBarWidth();
        final Number barLength = this.getBarLength();
        final Number toScale = this.getSpaceLineAndScale();
        final Number toTitle = this.getSpaceScaleAndTitle();
        final String direction = this.getColorBarDirection();
        final Boolean reversed = this.isReversedOrder();
        
        final String style = this.getColorBarStyle();
        
        final Number frameLineWidth = this.getFrameLineWidth();
        final Color lineColor = this.getLineColor();
        final Number tickMarkWidth = this.getTickMarkWidth();
        final Number tickMarkLength = this.getTickMarkLength();
        
        final String fontName = this.getFontName();
        final Number fontSize = this.getFontSize();
        final Integer fontStyle = this.getFontStyle();
        final Color fontColor = this.getFontColor();
        
        // check values
        ArrayList list = new ArrayList();
        if (cb.hasValidXAxisValue(xConfig, xValue) == false) {
            list.add("X");
        }
        if (cb.hasValidYAxisValue(yConfig, yValue) == false) {
            list.add("Y");
        }
        if (list.size() != 0) {
            StringBuffer sb = new StringBuffer();
            sb.append(ERRMSG_AXIS_VALUE_INVALID);
            sb.append(":\n");
            for (int ii = 0; ii < list.size(); ii++) {
                String str = (String) list.get(ii);
                sb.append('-');
                sb.append(str);
                sb.append('\n');
            }
            this.setInputErrorMessage(sb.toString());
            return false;
        }

        // set the related axes
        if (xConfig != -1) {
            cb.setXAxisLocation(xConfig);
        }

        if (yConfig != -1) {
            cb.setYAxisLocation(yConfig);
        }

        // x value
        if (xValue != null) {
            cb.setXValue(xValue.doubleValue());
        }

        // y value
        if (yValue != null) {
            cb.setYValue(yValue.doubleValue());
        }
        
        // bar width
        if (barWidth != null) {
            cb.setBarWidth(barWidth.floatValue(), COLOR_BAR_SIZE_UNIT);
        }
        
        // bar length
        if (barLength != null) {
            cb.setBarLength(barLength.floatValue(), COLOR_BAR_SIZE_UNIT);
        }
        
        // space to scale
        if (toScale != null) {
            cb.setSpaceToScale(toScale.floatValue(), FIGURE_SPACE_UNIT);
        }
        
        // space to title
        if (toTitle != null) {
            cb.setSpaceToTitle(toTitle.floatValue(), FIGURE_SPACE_UNIT);
        }
        
        // direction
        if (direction != null) {
            cb.setDirection(direction);
        }
        
        // reversed order
        if (reversed != null) {
            cb.setReversedOrder(reversed);
        }
        
        // style
        if (style != null) {
            cb.setColorBarStyle(style);
        }
        
        // frame line width
        if (frameLineWidth != null) {
            cb.setFrameLineWidth(frameLineWidth.floatValue(), LINE_WIDTH_UNIT);
        }
        
        // line color
        if (lineColor != null) {
            cb.setLineColor(lineColor);
        }
        
        // tick mark width
        if (tickMarkWidth != null) {
            cb.setTickMarkWidth(tickMarkWidth.floatValue(), LINE_WIDTH_UNIT);
        }
        
        // tick mark length
        if (tickMarkLength != null) {
            cb.setTickMarkLength(tickMarkLength.floatValue(), AXIS_TICK_LENGTH_UNIT);
        }
        
        // font name
        if (fontName != null) {
            cb.setFontName(fontName);
        }
        
        // font size
        if (fontSize != null) {
            cb.setFontSize(fontSize.floatValue(), FONT_SIZE_UNIT);
        }
        
        // font style
        if (fontStyle != null) {
            cb.setFontStyle(fontStyle);
        }
        
        // font color
        if (fontColor != null) {
            cb.setFontColor(fontColor);
        }

        // axis properties
        if (this.mAxisPanel.setPropertiesToListeners(cb) == false) {
            return false;
        }

        return true;
    }
    
    
    
    class ColorBarPanel extends JPanel {
        
        /**
         * Serial Version UID
         */
        private static final long serialVersionUID = 1829361019103918985L;

        /**
         * Color bar style manager.
         */
        private SGColorBarStyleManager mColorBarStyleManager = new SGColorBarStyleManager();

        /**
         * Default constructor.
         */
        public ColorBarPanel() {
            super();
            this.setOpaque(false);
        }
        
        public void paintComponent(Graphics g) {
            String style = (String) SGColorBarDialog.this.mColorBarStyleComboBox.getSelectedItem();
            if (style != null) {
                SGColorBarModel model = this.mColorBarStyleManager.getColorBarModel(style);
                Boolean reversed = SGColorBarDialog.this.mReversedOrderCheckBox.getSelected();
                if (model != null && reversed != null) {
                    model.setValueRange(0.0, 1.0);
                    model.setReversedOrder(reversed.booleanValue());
                    Graphics2D g2d = (Graphics2D) g;
                    Rectangle2D bounds = this.getBounds();
                    final double width = bounds.getWidth();
                    final int nWidth = (int) width;
                    final int nHeight = (int) bounds.getHeight();
                    for (int ii = 0; ii < nWidth; ii ++) {
                        final double ratio = (double) ii / nWidth;
                        Rectangle rect = new Rectangle(ii, 0, 1, nHeight);
                        Color cl = model.evaluate(ratio);
                        g2d.setPaint(cl);
                        g2d.fill(rect);
                    }
                }
            }
        }
    }

    /**
     * Called when an item event is invoked.
     */
    public void itemStateChanged(ItemEvent e) {
        Object source = e.getSource();
        if (source.equals(this.mColorBarStyleComboBox)) {
            this.repaint();
        }
    }

    /**
     * Called when an action event is invoked.
     */
    public void actionPerformed(ActionEvent e) {
        super.actionPerformed(e);
        Object source = e.getSource();
        if (source.equals(this.mReversedOrderCheckBox)) {
            this.repaint();
        }
    }
    
    /**
     * Overrode this method to check the input values.
     * 
     * @return true if all input values are valid
     */
    protected boolean hasValidInputValues() {
        boolean valid = true;
        if (super.hasValidInputValues() == false) {
            valid = false;
        }
        if (this.hasValidNumber(this.mXValueTextField, null, null) == false) {
        	valid = false;
        }
        if (this.hasValidNumber(this.mYValueTextField, null, null) == false) {
        	valid = false;
        }
        List tfList = this.mAxisPanel.getNumberTextFieldList();
        for (int ii = 0; ii < tfList.size(); ii++) {
        	SGTextField tf = (SGTextField) tfList.get(ii);
            if (this.hasValidNumber(tf, null, null) == false) {
            	valid = false;
            }
        }
        
        // spinners in axis panel
        List sList = this.mAxisPanel.getSpinnerList();
        for (int ii = 0; ii < sList.size(); ii++) {
            SGSpinner s = (SGSpinner) sList.get(ii);
            if (s.hasValidValue() == false) {
                this.addInputErrorDescription(s.getDescription());
                valid = false;
            }
        }
        
        // text fields in axis panel (not for number input)
        List tList = this.mAxisPanel.getTextFieldComponentsList();
        for (int ii = 0; ii < tList.size(); ii++) {
        	SGTextField tf = (SGTextField) tList.get(ii);
        	if (tf.hasValidText() == false) {
                this.addInputErrorDescription(tf.getDescription());
                valid = false;
        	}
        }

    	return valid;
    }

}
