package jp.riken.brain.ni.samuraigraph.figure;

import java.awt.Color;
import java.awt.Font;

import jp.riken.brain.ni.samuraigraph.base.SGIConstants;

/**
 * Constants for axes.
 */
public interface SGIAxisConstants extends SGIConstants {

    /**
     * Constants for the tick marks.
     */
    public static final String AXIS_TICK_LENGTH_UNIT = cm;

    public static final double AXIS_TICK_LENGTH_MIN = 0.0;

    public static final double AXIS_TICK_LENGTH_MAX = 0.50;
    
    public static final double TICK_MARK_LENGTH_STEP = 0.05;

    public static final int TICK_MARK_LENGTH_FRAC_DIFIT_MIN = 1;
    
    public static final int TICK_MARK_LENGTH_FRAC_DIFIT_MAX = 2;
    
    public static final int TICK_MARK_LENGTH_MINIMAL_ORDER = - TICK_MARK_LENGTH_FRAC_DIFIT_MAX;
    
    
    /**
     * Constans for the exponent.
     */
    public static final int AXIS_EXPONENT_MIN = -10;

    public static final int AXIS_EXPONENT_MAX = 10;
    
    public static final int AXIS_EXPONENT_STEP = 1;

    /**
     * Constants for the angle of number.
     */
    public static final double AXIS_NUMBER_ANGLE_MIN = -180.0;

    public static final double AXIS_NUMBER_ANGLE_MAX = 180.0;

    public static final double AXIS_NUMBER_ANGLE_STEP = 1.0;

    public static final int AXIS_NUMBER_ANGLE_FRAC_DIFIT_MIN = 1;
    
    public static final int AXIS_NUMBER_ANGLE_FRAC_DIFIT_MAX = 2;
    
    public static final int AXIS_NUMBER_ANGLE_MINIMAL_ORDER = - AXIS_NUMBER_ANGLE_FRAC_DIFIT_MAX;
    
    //
    // Default values
    //

    //
    // Axis Line
    //

    // Axis width
    public static final float DEFAULT_AXIS_LINE_WIDTH = 1.5f;

    // Scale width
    public static final float DEFAULT_TICK_MARK_LINE_WIDTH = 1.5f;

    // Scale length
    public static final float DEFAULT_TICK_MARK_LENGTH = 0.25f;

    // Color
    public static final Color DEFAULT_LINE_COLOR = Color.BLACK;

    //
    // Frame
    //

    // Visible
    public static final boolean DEFAULT_FRAME_LINE_VISIBLE = false;

    // Width
    public static final float DEFAULT_FRAME_LINE_WIDTH = 1.5f;

    // Color
    public static final Color DEFAULT_FRAME_LINE_COLOR = Color.BLACK;

    //
    // Font
    //

    public static final String DEFAULT_FONT_NAME = "Serif";

    public static final int DEFAULT_FONT_STYLE = Font.PLAIN;

    public static final float DEFAULT_FONT_SIZE = 16.0f;

    public static final Color DEFAULT_FONT_COLOR = Color.BLACK;

    //
    // Visible Axis
    //

    public static final boolean DEFAULT_BOTTOM_AXIS_VISIBLE = true;

    public static final boolean DEFAULT_TOP_AXIS_VISIBLE = false;

    public static final boolean DEFAULT_LEFT_AXIS_VISIBLE = true;

    public static final boolean DEFAULT_RIGHT_AXIS_VISIBLE = false;

    //
    // Title
    //
    
    public static final String DEFAULT_HORIZONTAL_AXIS_TITLE = "X Label";

    public static final String DEFAULT_PERPENDICULAR_AXIS_TITLE = "Y Label";

    public static final String DEFAULT_NORMAL_AXIS_TITLE = "Z Label";

    public static final String DEFAULT_BOTTOM_AXIS_TITLE = DEFAULT_HORIZONTAL_AXIS_TITLE;

    public static final String DEFAULT_TOP_AXIS_TITLE = DEFAULT_HORIZONTAL_AXIS_TITLE;

    public static final String DEFAULT_LEFT_AXIS_TITLE = DEFAULT_PERPENDICULAR_AXIS_TITLE;

    public static final String DEFAULT_RIGHT_AXIS_TITLE = DEFAULT_PERPENDICULAR_AXIS_TITLE;

    public static final String DEFAULT_Z_AXIS_TITLE = DEFAULT_NORMAL_AXIS_TITLE;
    
    //
    // Scale
    //

    // Number
    public static final boolean DEFAULT_NUMBER_VISIBLE = true;

    public static final boolean DEFAULT_NUMBER_INTEGER = false;
    
    public static final float DEFAULT_NUMBER_ANGLE = 0.0f;

    // Scale Line
    public static final boolean DEFAULT_SCALE_LINE_VISIBLE = true;

    public static final boolean DEFAULT_SCALE_LINE_INNER = true;


    //
    // Range
    //

    public static final double DEFAULT_MIN_VALUE = 0.0;
    
    public static final double DEFAULT_MAX_VALUE = 1.0;

    public static final double DEFAULT_X_MIN_VALUE = DEFAULT_MIN_VALUE;
    
    public static final double DEFAULT_X_MAX_VALUE = DEFAULT_MAX_VALUE;

    public static final double DEFAULT_Y_MIN_VALUE = DEFAULT_MIN_VALUE;
    
    public static final double DEFAULT_Y_MAX_VALUE = DEFAULT_MAX_VALUE;

    public static final double DEFAULT_Z_MIN_VALUE = DEFAULT_MIN_VALUE;
    
    public static final double DEFAULT_Z_MAX_VALUE = DEFAULT_MAX_VALUE;

    
    // text
    public static final String COM_AXIS_FONT_NAME = "FontName";

    public static final String COM_AXIS_FONT_STYLE = "FontStyle";

    public static final String COM_AXIS_FONT_SIZE = "FontSize";

    public static final String COM_AXIS_FONT_COLOR = "FontColor";

    // frame
    public static final String COM_AXIS_FRAME_VISIBLE = "FrameVisible";

    public static final String COM_AXIS_FRAME_LINE_WIDTH = "FrameLineWidth";

    public static final String COM_AXIS_FRAME_COLOR = "FrameColor";

    // lines
    public static final String COM_AXIS_LINE_WIDTH = "LineWidth";

    public static final String COM_TICK_MARK_WIDTH = "TickMarkWidth";

    public static final String COM_TICK_MARK_LENGTH = "TickMarkLength";

    public static final String COM_AXIS_LINE_COLOR = "LineColor";
    
    // each axis
    public static final String COM_AXIS_VISIBLE = "Visible";

    public static final String COM_AXIS_TITLE_VISIBLE = "TitleVisible";

    public static final String COM_AXIS_TITLE = "TitleText";

    public static final String COM_AXIS_SCALE_MIN_VALUE = "ScaleMinValue";

    public static final String COM_AXIS_SCALE_MAX_VALUE = "ScaleMaxValue";

    public static final String COM_AXIS_SCALE_RANGE = "ScaleRange";

    public static final String COM_AXIS_SCALE_TYPE = "ScaleType";

    public static final String COM_AXIS_INVERT_COORDINATES = "InvertCoordinates";
    
    public static final String COM_AXIS_TICK_MARK_VISIBLE = "TickMarkVisible";

    public static final String COM_AXIS_TICK_MARK_AUTO = "TickMarkAuto";

    public static final String COM_AXIS_TICK_MARK_STEP = "TickMarkStep";

    public static final String COM_AXIS_TICK_MARK_BASE = "TickMarkBase";

    public static final String COM_AXIS_TICK_MARK_INNER = "TickMarkInner";

    public static final String COM_AXIS_NUMBER_VISIBLE = "NumberVisible";

    public static final String COM_AXIS_NUMBER_INTEGER = "NumberInteger";
    
    public static final String COM_AXIS_NUMBER_ANGLE = "NumberAngle";

    public static final String COM_AXIS_NUMBER_FORMAT_EXPONENT_VISIBLE = "NumberFormatExponentVisible";

    public static final String COM_AXIS_NUMBER_FORMAT_EXPONTNE_VALUE = "NumberFormatExponentValue";

}
