package jp.riken.brain.ni.samuraigraph.figure.java2d;

import jp.riken.brain.ni.samuraigraph.data.SGISXYTypeMultipleData;

public interface SGIElementGroupSetMultipleSXY extends
		SGIElementGroupSetInFigureElement, SGIElementGroupSetXY {
	
    /**
     * Adds a group set.
     * 
     * @param gs
     *           the group set to be add
     */
	public void addChildGroupSet(SGIElementGroupSetInFigureElement gs);
	
    /**
     * Removes a group set.
     * 
     * @param gs
     *           the group set to be removed
     */
    public void removeChildGroupSet(SGIElementGroupSetInFigureElement gs);

	public SGIElementGroupSetInFigureElement[] getChildGroupSetArray();

	public SGIElementGroupSetInFigureElement getFirst();

	/**
	 * Creates drawing elements of error bars.
	 * 
	 * @param dataXY
	 *             XY type data
	 * @return the group of error bars
	 */
	public SGElementGroupErrorBar createErrorBars(SGISXYTypeMultipleData dataXY);

	/**
	 * Creates drawing elements of tick labels.
	 * 
	 * @param dataXY
	 *             XY type data
	 * @return the group of tick labels
	 */
	public SGElementGroupTickLabel createTickLabels(
			SGISXYTypeMultipleData dataXY);

	/**
	 * Update the text strings of tick labels.
	 */
	public void updateTickLabelStrings();

	/**
	 * Sets the direction of error bars.
	 * 
	 * @param vertical
	 *           true to set vertical
	 * @return true if succeeded
	 */
	public boolean setErrorBarDirection(final boolean vertical);
	
	/**
	 * Sets the alignment of tick label.
	 * 
	 * @param horizontal
	 *           true to align horizontally
	 * @return true if succeeded
	 */
	public boolean setTickLabelAlignment(final boolean horizontal);

}
