package jp.riken.brain.ni.samuraigraph.figure.java2d;

import java.awt.Color;
import java.awt.Component;
import java.awt.event.ActionEvent;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JRadioButton;
import javax.swing.SpinnerNumberModel;
import javax.swing.event.ChangeEvent;

import jp.riken.brain.ni.samuraigraph.base.SGCheckBox;
import jp.riken.brain.ni.samuraigraph.base.SGColorSelectionButton;
import jp.riken.brain.ni.samuraigraph.base.SGComponentGroup;
import jp.riken.brain.ni.samuraigraph.base.SGComponentGroupElement;
import jp.riken.brain.ni.samuraigraph.base.SGData;
import jp.riken.brain.ni.samuraigraph.base.SGDataColumnInfo;
import jp.riken.brain.ni.samuraigraph.base.SGFillPaint;
import jp.riken.brain.ni.samuraigraph.base.SGGradationPaint;
import jp.riken.brain.ni.samuraigraph.base.SGGradationPaintDialog;
import jp.riken.brain.ni.samuraigraph.base.SGIConstants;
import jp.riken.brain.ni.samuraigraph.base.SGIPaint;
import jp.riken.brain.ni.samuraigraph.base.SGIPropertyDialogObserver;
import jp.riken.brain.ni.samuraigraph.base.SGPatternPaint;
import jp.riken.brain.ni.samuraigraph.base.SGPatternPaintDialog;
import jp.riken.brain.ni.samuraigraph.base.SGSelectablePaint;
import jp.riken.brain.ni.samuraigraph.base.SGTextField;
import jp.riken.brain.ni.samuraigraph.base.SGTransparentPaint;
import jp.riken.brain.ni.samuraigraph.base.SGUtility;
import jp.riken.brain.ni.samuraigraph.base.SGUtilityText;
import jp.riken.brain.ni.samuraigraph.data.SGDataSetupDialog;
import jp.riken.brain.ni.samuraigraph.data.SGDataUtility;
import jp.riken.brain.ni.samuraigraph.data.SGIDataColumnTypeConstants;
import jp.riken.brain.ni.samuraigraph.data.SGISXYData;
import jp.riken.brain.ni.samuraigraph.data.SGNetCDFData;
import jp.riken.brain.ni.samuraigraph.data.SGNetCDFDataSetupDialog;
import jp.riken.brain.ni.samuraigraph.data.SGNetCDFFile;
import jp.riken.brain.ni.samuraigraph.data.SGSXYMultipleDimensionNetCDFData;
import jp.riken.brain.ni.samuraigraph.data.SGSXYMultipleVariableNetCDFData;
import jp.riken.brain.ni.samuraigraph.data.SGVariable;
import jp.riken.brain.ni.samuraigraph.figure.SGDrawingElementErrorBar;
import jp.riken.brain.ni.samuraigraph.figure.SGDrawingElementLine;
import jp.riken.brain.ni.samuraigraph.figure.SGDrawingElementSymbol;
import jp.riken.brain.ni.samuraigraph.figure.SGIErrorBarConstants;
import jp.riken.brain.ni.samuraigraph.figure.SGIFigureDrawingElementConstants;
import jp.riken.brain.ni.samuraigraph.figure.SGILineConstants;
import jp.riken.brain.ni.samuraigraph.figure.SGISymbolConstants;
import jp.riken.brain.ni.samuraigraph.figure.SGPaintConstants;

/**
 * A dialog to set the properties of two-dimensional scalar type data.
 */
public class SGPropertyDialogSXYData extends SGDataDialog implements
        SGIFigureDrawingElementConstants, SGIDataColumnTypeConstants {

    // serialVersionID
    private static final long serialVersionUID = -8504726423602738949L;

    /**
     * The title of this dialog.
     */
    public static final String TITLE = "Data Properties";

    /**
     * Creates new form SGPropertyDialogSXYData
     */
    public SGPropertyDialogSXYData(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
        this.initProperty();
        this.initialize();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        mBarWidthLabel = new javax.swing.JLabel();
        mBarWidthSpinner = new jp.riken.brain.ni.samuraigraph.base.SGSpinner();
        mLineEditButton = new jp.riken.brain.ni.samuraigraph.base.SGButton();
        mCommonPanel = new javax.swing.JPanel();
        mLegendVisibleCheckBox = new jp.riken.brain.ni.samuraigraph.base.SGCheckBox();
        mNameLabel = new javax.swing.JLabel();
        mNameField = new jp.riken.brain.ni.samuraigraph.base.SGTextField();
        mAxisPanel = new jp.riken.brain.ni.samuraigraph.base.SGTwoAxesSelectionPanel();
        mDataColumnSelectionButton = new jp.riken.brain.ni.samuraigraph.base.SGButton();
        mTabbedPane = new javax.swing.JTabbedPane();
        mLinePanel = new javax.swing.JPanel();
        mLineVisibleCheckBox = new jp.riken.brain.ni.samuraigraph.base.SGCheckBox();
        mLineWidthLabel = new javax.swing.JLabel();
        mLineWidthSpinner = new jp.riken.brain.ni.samuraigraph.base.SGSpinner();
        mLineColorLabel = new javax.swing.JLabel();
        mLineColorButton = new jp.riken.brain.ni.samuraigraph.base.SGColorSelectionButton();
        mLineTypeLabel = new javax.swing.JLabel();
        mLineTypeComboBox = new jp.riken.brain.ni.samuraigraph.base.SGComboBox();
        mLineConnectCheckBox = new jp.riken.brain.ni.samuraigraph.base.SGCheckBox();
        mLineSymbolLabel = new javax.swing.JLabel();
        mLineSymbolSeparator = new javax.swing.JSeparator();
        mLinePlacementLabel = new javax.swing.JLabel();
        mLinePlacementSeparator = new javax.swing.JSeparator();
        mLinePlacementShiftXLabel = new javax.swing.JLabel();
        mLinePlacementShiftYLabel = new javax.swing.JLabel();
        mLinePlacementShiftXTextField = new jp.riken.brain.ni.samuraigraph.base.SGTextField();
        mLinePlacementShiftYTextField = new jp.riken.brain.ni.samuraigraph.base.SGTextField();
        mLineSymbolPanel = new javax.swing.JPanel();
        mSymbolVisibleCheckBox = new jp.riken.brain.ni.samuraigraph.base.SGCheckBox();
        mSymbolTypePanel = new javax.swing.JPanel();
        mSymbolTypeLabel = new javax.swing.JLabel();
        mSymbolTypeComboBox = new jp.riken.brain.ni.samuraigraph.base.SGComboBox();
        mSymbolBodyLabel = new javax.swing.JLabel();
        mSymbolBodySeparator = new javax.swing.JSeparator();
        mSymbolSizeLabel = new javax.swing.JLabel();
        mSymbolSizeSpinner = new jp.riken.brain.ni.samuraigraph.base.SGSpinner();
        mSymbolColorLabel = new javax.swing.JLabel();
        mSymbolColorButton = new jp.riken.brain.ni.samuraigraph.base.SGColorSelectionButton();
        mSymbolBodyTransparencyPanel = new javax.swing.JPanel();
        mSymbolBodyTransparencyLabel = new javax.swing.JLabel();
        mSymbolBodyTransparencySpinner = new jp.riken.brain.ni.samuraigraph.base.SGSpinner();
        mSymbolLineWidthSpinner = new jp.riken.brain.ni.samuraigraph.base.SGSpinner();
        mSymbolLineWidthLabel = new javax.swing.JLabel();
        mSymbolLineColorLabel = new javax.swing.JLabel();
        mSymbolLineColorButton = new jp.riken.brain.ni.samuraigraph.base.SGColorSelectionButton();
        mSymbolLineLabel = new javax.swing.JLabel();
        mSymbolLineVisibleCheckBox = new jp.riken.brain.ni.samuraigraph.base.SGCheckBox();
        mSymbolLineSeparator = new javax.swing.JSeparator();
        mBarPanel = new javax.swing.JPanel();
        mBarVisibleCheckBox = new jp.riken.brain.ni.samuraigraph.base.SGCheckBox();
        mBarLineWidthLabel = new javax.swing.JLabel();
        mBarLineColorLabel = new javax.swing.JLabel();
        mBarLineWidthSpinner = new jp.riken.brain.ni.samuraigraph.base.SGSpinner();
        mBarLineColorButton = new jp.riken.brain.ni.samuraigraph.base.SGColorSelectionButton();
        mBarLineVisibleCheckBox = new jp.riken.brain.ni.samuraigraph.base.SGCheckBox();
        mBarBodyLabel = new javax.swing.JLabel();
        mBarLineLabel = new javax.swing.JLabel();
        mBarInnerColorButton = new jp.riken.brain.ni.samuraigraph.base.SGColorSelectionButton();
        mBarBodySeparator = new javax.swing.JSeparator();
        mBarLineSeparator = new javax.swing.JSeparator();
        mBarBaseLinePanel = new javax.swing.JPanel();
        mBarBaseLineTextField = new jp.riken.brain.ni.samuraigraph.base.SGTextField();
        mBarBaseLineValueLabel = new javax.swing.JLabel();
        mBarWidthValueLabel = new javax.swing.JLabel();
        mBarWidthValueTextField = new jp.riken.brain.ni.samuraigraph.base.SGTextField();
        mBarVerticalCheckBox = new jp.riken.brain.ni.samuraigraph.base.SGCheckBox();
        mBarColorLabel = new javax.swing.JLabel();
        mBarBodyColorFillRadioButton = new jp.riken.brain.ni.samuraigraph.base.SGRadioButton();
        mBarBodyColorPatternRadioButton = new jp.riken.brain.ni.samuraigraph.base.SGRadioButton();
        mBarBodyColorGradationRadioButton = new jp.riken.brain.ni.samuraigraph.base.SGRadioButton();
        mBarBodyColorPatternPaintButton = new jp.riken.brain.ni.samuraigraph.base.SGPatternPaintSelectionButton();
        mBarBodyColorGradationColorButton = new jp.riken.brain.ni.samuraigraph.base.SGGradationPaintSelectionButton();
        mBarBodyTransparencyPanel = new javax.swing.JPanel();
        mBarBodyTransparencyLabel = new javax.swing.JLabel();
        mBarBodyTransparencySpinner = new jp.riken.brain.ni.samuraigraph.base.SGSpinner();
        mBarPlacementLabel = new javax.swing.JLabel();
        mBarPlacementSeparator = new javax.swing.JSeparator();
        mBarPlacementShiftXLabel = new javax.swing.JLabel();
        mBarPlacementShiftYLabel = new javax.swing.JLabel();
        mBarPlacementShiftXTextField = new jp.riken.brain.ni.samuraigraph.base.SGTextField();
        mBarPlacementShiftYTextField = new jp.riken.brain.ni.samuraigraph.base.SGTextField();
        mBarPlacementIntervalLabel = new javax.swing.JLabel();
        mBarPlacementIntervalTextField = new jp.riken.brain.ni.samuraigraph.base.SGTextField();
        mErrorBarPanel = new javax.swing.JPanel();
        mErrorBarVisibleCheckBox = new jp.riken.brain.ni.samuraigraph.base.SGCheckBox();
        mErrorBarSymbolSizeLabel = new javax.swing.JLabel();
        mErrorBarSymbolSizeSpinner = new jp.riken.brain.ni.samuraigraph.base.SGSpinner();
        mErrorBarColorLabel = new javax.swing.JLabel();
        mErrorBarTypeLabel = new javax.swing.JLabel();
        mErrorBarTypeComboBox = new jp.riken.brain.ni.samuraigraph.base.SGComboBox();
        mErrorBarColorButton = new jp.riken.brain.ni.samuraigraph.base.SGColorSelectionButton();
        mErrorBarStyleLabel = new javax.swing.JLabel();
        mErrorBarSymbolLabel = new javax.swing.JLabel();
        mErrorBarStyleSeparator = new javax.swing.JSeparator();
        mErrorBarSymbolSeparator = new javax.swing.JSeparator();
        mErrorBarSylePanel = new javax.swing.JPanel();
        mErrorBarBothsidesRadioButton = new jp.riken.brain.ni.samuraigraph.base.SGRadioButton();
        mErrorBarUpsideRadioButton = new jp.riken.brain.ni.samuraigraph.base.SGRadioButton();
        mErrorBarDownsideRadioButton = new jp.riken.brain.ni.samuraigraph.base.SGRadioButton();
        mErrorBarLineWidthPanel = new javax.swing.JPanel();
        mErrorBarLineWidthLabel1 = new javax.swing.JLabel();
        mErrorBarLineWidthSpinner = new jp.riken.brain.ni.samuraigraph.base.SGSpinner();
        mErrorBarLineWidthLabel2 = new javax.swing.JLabel();
        mErrorBarVerticalCheckBox = new jp.riken.brain.ni.samuraigraph.base.SGCheckBox();
        mErrorBarPositionLabel = new javax.swing.JLabel();
        mErrorBarPositionSeparator = new javax.swing.JSeparator();
        mErrorBarPositionPanel = new javax.swing.JPanel();
        mErrorBarPositionLineRadioButton = new jp.riken.brain.ni.samuraigraph.base.SGRadioButton();
        mErrorBarPositionBarRadioButton = new jp.riken.brain.ni.samuraigraph.base.SGRadioButton();
        mTickLabelPanel = new javax.swing.JPanel();
        mTickLabelFontSizeLabel = new javax.swing.JLabel();
        mTickLabelVisibleCheckBox = new jp.riken.brain.ni.samuraigraph.base.SGCheckBox();
        mTickLabelFontSizeSpinner = new jp.riken.brain.ni.samuraigraph.base.SGSpinner();
        mTickLabelColorButton = new jp.riken.brain.ni.samuraigraph.base.SGColorSelectionButton();
        mTickLabelColorLabel = new javax.swing.JLabel();
        mTickLabelAnglePanel = new javax.swing.JPanel();
        mTickLabelAngleLabel = new javax.swing.JLabel();
        mTickLabelAngleSpinner = new jp.riken.brain.ni.samuraigraph.base.SGSpinner();
        mTickLabelFontLabel = new javax.swing.JLabel();
        mTickLabelFontSeparator = new javax.swing.JSeparator();
        mTickLabelTextLabel = new javax.swing.JLabel();
        mTickLanelAngleSeparator = new javax.swing.JSeparator();
        mTickLabelFontStyleComboBox = new jp.riken.brain.ni.samuraigraph.base.SGComboBox();
        mTickLabelFontNameComboBox = new jp.riken.brain.ni.samuraigraph.base.SGComboBox();
        mTickLabelFontNameLabel = new javax.swing.JLabel();
        mTickLabelFontStyleLabel = new javax.swing.JLabel();
        mTickLabelFormatLabel = new javax.swing.JLabel();
        mTickLabelFormatSeparator = new javax.swing.JSeparator();
        mTickLabelFormatPanel = new javax.swing.JPanel();
        mTickLabelDecimalPlacesSpinner = new jp.riken.brain.ni.samuraigraph.base.SGSpinner();
        mTickLabelDecimalPlacesLabel = new javax.swing.JLabel();
        mTickLabelExponentBaseLabel = new javax.swing.JLabel();
        mTickLabelExponentSpinner = new jp.riken.brain.ni.samuraigraph.base.SGSpinner();
        mTickLabelExponentLabel = new javax.swing.JLabel();
        mTickLabelHorizontalAlignmentCheckBox = new jp.riken.brain.ni.samuraigraph.base.SGCheckBox();
        mButtonPanel = new javax.swing.JPanel();
        mOKButton = new jp.riken.brain.ni.samuraigraph.base.SGButton();
        mCancelButton = new jp.riken.brain.ni.samuraigraph.base.SGButton();
        mPreviewButton = new jp.riken.brain.ni.samuraigraph.base.SGButton();

        mBarWidthLabel.setFont(new java.awt.Font("Dialog", 0, 12));
        mBarWidthLabel.setText("Width");

        mBarWidthSpinner.setFont(new java.awt.Font("Dialog", 0, 12));
        mBarWidthSpinner.setPreferredSize(new java.awt.Dimension(75, 22));

        mLineEditButton.setText("Edit");

        getContentPane().setLayout(new java.awt.GridBagLayout());

        mCommonPanel.setLayout(new java.awt.GridBagLayout());

        mLegendVisibleCheckBox.setText("Legend Visible");
        mLegendVisibleCheckBox.setFont(new java.awt.Font("Dialog", 0, 12));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 0);
        mCommonPanel.add(mLegendVisibleCheckBox, gridBagConstraints);

        mNameLabel.setFont(new java.awt.Font("Dialog", 0, 12));
        mNameLabel.setText("Name");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 5, 0);
        mCommonPanel.add(mNameLabel, gridBagConstraints);

        mNameField.setColumns(16);
        mNameField.setFont(new java.awt.Font("Dialog", 0, 12));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 5, 0);
        mCommonPanel.add(mNameField, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 4;
        mCommonPanel.add(mAxisPanel, gridBagConstraints);

        mDataColumnSelectionButton.setText("Data Column");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 0);
        mCommonPanel.add(mDataColumnSelectionButton, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 5, 0);
        getContentPane().add(mCommonPanel, gridBagConstraints);

        mTabbedPane.setFont(new java.awt.Font("Dialog", 1, 12));
        mTabbedPane.setPreferredSize(new java.awt.Dimension(360, 400));

        mLinePanel.setFont(new java.awt.Font("Dialog", 0, 12));
        mLinePanel.setLayout(new java.awt.GridBagLayout());

        mLineVisibleCheckBox.setText("Visible");
        mLineVisibleCheckBox.setFont(new java.awt.Font("Dialog", 0, 12));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 4;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 10, 5, 10);
        mLinePanel.add(mLineVisibleCheckBox, gridBagConstraints);

        mLineWidthLabel.setFont(new java.awt.Font("Dialog", 0, 12));
        mLineWidthLabel.setText("Width");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 15, 0, 5);
        mLinePanel.add(mLineWidthLabel, gridBagConstraints);

        mLineWidthSpinner.setFont(new java.awt.Font("Dialog", 0, 12));
        mLineWidthSpinner.setMinimumSize(new java.awt.Dimension(75, 22));
        mLineWidthSpinner.setPreferredSize(new java.awt.Dimension(75, 22));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 5);
        mLinePanel.add(mLineWidthSpinner, gridBagConstraints);

        mLineColorLabel.setFont(new java.awt.Font("Dialog", 0, 12));
        mLineColorLabel.setText("Color");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 20, 0, 5);
        mLinePanel.add(mLineColorLabel, gridBagConstraints);

        mLineColorButton.setFont(new java.awt.Font("Dialog", 0, 11));
        mLineColorButton.setMinimumSize(new java.awt.Dimension(65, 20));
        mLineColorButton.setPreferredSize(new java.awt.Dimension(65, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 10);
        mLinePanel.add(mLineColorButton, gridBagConstraints);

        mLineTypeLabel.setFont(new java.awt.Font("Dialog", 0, 12));
        mLineTypeLabel.setText("Type");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 15, 5, 5);
        mLinePanel.add(mLineTypeLabel, gridBagConstraints);

        mLineTypeComboBox.setFont(new java.awt.Font("Dialog", 0, 12));
        mLineTypeComboBox.setMinimumSize(new java.awt.Dimension(140, 22));
        mLineTypeComboBox.setPreferredSize(new java.awt.Dimension(140, 22));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 10);
        mLinePanel.add(mLineTypeComboBox, gridBagConstraints);

        mLineConnectCheckBox.setText("Ignore Missing Values");
        mLineConnectCheckBox.setFont(new java.awt.Font("Dialog", 0, 12));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 40, 5, 10);
        mLinePanel.add(mLineConnectCheckBox, gridBagConstraints);

        mLineSymbolLabel.setFont(new java.awt.Font("Dialog", 3, 12));
        mLineSymbolLabel.setText("Symbol");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(10, 0, 0, 0);
        mLinePanel.add(mLineSymbolLabel, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridwidth = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(10, 50, 0, 10);
        mLinePanel.add(mLineSymbolSeparator, gridBagConstraints);

        mLinePlacementLabel.setFont(new java.awt.Font("Dialog", 3, 12));
        mLinePlacementLabel.setText("Placement");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(10, 0, 0, 0);
        mLinePanel.add(mLinePlacementLabel, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.gridwidth = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(10, 70, 0, 10);
        mLinePanel.add(mLinePlacementSeparator, gridBagConstraints);

        mLinePlacementShiftXLabel.setFont(new java.awt.Font("Dialog", 0, 12));
        mLinePlacementShiftXLabel.setText("Shift X");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 15, 5, 5);
        mLinePanel.add(mLinePlacementShiftXLabel, gridBagConstraints);

        mLinePlacementShiftYLabel.setFont(new java.awt.Font("Dialog", 0, 12));
        mLinePlacementShiftYLabel.setText("Shift Y");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        mLinePanel.add(mLinePlacementShiftYLabel, gridBagConstraints);

        mLinePlacementShiftXTextField.setFont(new java.awt.Font("Dialog", 0, 12));
        mLinePlacementShiftXTextField.setMinimumSize(new java.awt.Dimension(70, 22));
        mLinePlacementShiftXTextField.setPreferredSize(new java.awt.Dimension(70, 22));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        mLinePanel.add(mLinePlacementShiftXTextField, gridBagConstraints);

        mLinePlacementShiftYTextField.setFont(new java.awt.Font("Dialog", 0, 12));
        mLinePlacementShiftYTextField.setMinimumSize(new java.awt.Dimension(70, 22));
        mLinePlacementShiftYTextField.setPreferredSize(new java.awt.Dimension(70, 22));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 10);
        mLinePanel.add(mLinePlacementShiftYTextField, gridBagConstraints);

        mLineSymbolPanel.setLayout(new java.awt.GridBagLayout());

        mSymbolVisibleCheckBox.setText("Visible");
        mSymbolVisibleCheckBox.setFont(new java.awt.Font("Dialog", 0, 12));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 4;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 10, 0, 10);
        mLineSymbolPanel.add(mSymbolVisibleCheckBox, gridBagConstraints);

        mSymbolTypePanel.setLayout(new java.awt.GridBagLayout());

        mSymbolTypeLabel.setFont(new java.awt.Font("Dialog", 0, 12));
        mSymbolTypeLabel.setText("Type");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 5);
        mSymbolTypePanel.add(mSymbolTypeLabel, gridBagConstraints);

        mSymbolTypeComboBox.setFont(new java.awt.Font("Dialog", 0, 12));
        mSymbolTypeComboBox.setMinimumSize(new java.awt.Dimension(150, 22));
        mSymbolTypeComboBox.setPreferredSize(new java.awt.Dimension(150, 22));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 0);
        mSymbolTypePanel.add(mSymbolTypeComboBox, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 30, 0, 0);
        mLineSymbolPanel.add(mSymbolTypePanel, gridBagConstraints);

        mSymbolBodyLabel.setFont(new java.awt.Font("Dialog", 3, 12));
        mSymbolBodyLabel.setText("Body");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = 4;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 15, 5, 5);
        mLineSymbolPanel.add(mSymbolBodyLabel, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(0, 50, 0, 10);
        mLineSymbolPanel.add(mSymbolBodySeparator, gridBagConstraints);

        mSymbolSizeLabel.setFont(new java.awt.Font("Dialog", 0, 12));
        mSymbolSizeLabel.setText("Size");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 25, 0, 5);
        mLineSymbolPanel.add(mSymbolSizeLabel, gridBagConstraints);

        mSymbolSizeSpinner.setFont(new java.awt.Font("Dialog", 0, 12));
        mSymbolSizeSpinner.setMinimumSize(new java.awt.Dimension(75, 22));
        mSymbolSizeSpinner.setPreferredSize(new java.awt.Dimension(75, 22));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 5);
        mLineSymbolPanel.add(mSymbolSizeSpinner, gridBagConstraints);

        mSymbolColorLabel.setFont(new java.awt.Font("Dialog", 0, 12));
        mSymbolColorLabel.setText("Color");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 20, 0, 5);
        mLineSymbolPanel.add(mSymbolColorLabel, gridBagConstraints);

        mSymbolColorButton.setFont(new java.awt.Font("Dialog", 0, 11));
        mSymbolColorButton.setMinimumSize(new java.awt.Dimension(65, 20));
        mSymbolColorButton.setPreferredSize(new java.awt.Dimension(65, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 10);
        mLineSymbolPanel.add(mSymbolColorButton, gridBagConstraints);

        mSymbolBodyTransparencyPanel.setLayout(new java.awt.GridBagLayout());

        mSymbolBodyTransparencyLabel.setFont(new java.awt.Font("Dialog", 0, 12));
        mSymbolBodyTransparencyLabel.setText("Transparency");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        mSymbolBodyTransparencyPanel.add(mSymbolBodyTransparencyLabel, gridBagConstraints);

        mSymbolBodyTransparencySpinner.setFont(new java.awt.Font("Dialog", 0, 12));
        mSymbolBodyTransparencySpinner.setMinimumSize(new java.awt.Dimension(75, 22));
        mSymbolBodyTransparencySpinner.setPreferredSize(new java.awt.Dimension(75, 22));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 10, 0, 0);
        mSymbolBodyTransparencyPanel.add(mSymbolBodyTransparencySpinner, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(3, 25, 0, 0);
        mLineSymbolPanel.add(mSymbolBodyTransparencyPanel, gridBagConstraints);

        mSymbolLineWidthSpinner.setFont(new java.awt.Font("Dialog", 0, 12));
        mSymbolLineWidthSpinner.setMinimumSize(new java.awt.Dimension(75, 22));
        mSymbolLineWidthSpinner.setPreferredSize(new java.awt.Dimension(75, 22));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 5, 5);
        mLineSymbolPanel.add(mSymbolLineWidthSpinner, gridBagConstraints);

        mSymbolLineWidthLabel.setFont(new java.awt.Font("Dialog", 0, 12));
        mSymbolLineWidthLabel.setText("Width");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 25, 5, 5);
        mLineSymbolPanel.add(mSymbolLineWidthLabel, gridBagConstraints);

        mSymbolLineColorLabel.setFont(new java.awt.Font("Dialog", 0, 12));
        mSymbolLineColorLabel.setText("Color");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 20, 5, 5);
        mLineSymbolPanel.add(mSymbolLineColorLabel, gridBagConstraints);

        mSymbolLineColorButton.setFont(new java.awt.Font("Dialog", 0, 11));
        mSymbolLineColorButton.setMinimumSize(new java.awt.Dimension(65, 20));
        mSymbolLineColorButton.setPreferredSize(new java.awt.Dimension(65, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 5, 10);
        mLineSymbolPanel.add(mSymbolLineColorButton, gridBagConstraints);

        mSymbolLineLabel.setFont(new java.awt.Font("Dialog", 3, 12));
        mSymbolLineLabel.setText("Line");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.gridwidth = 4;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 15, 5, 5);
        mLineSymbolPanel.add(mSymbolLineLabel, gridBagConstraints);

        mSymbolLineVisibleCheckBox.setText("Visible");
        mSymbolLineVisibleCheckBox.setFont(new java.awt.Font("Dialog", 0, 12));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 25, 0, 0);
        mLineSymbolPanel.add(mSymbolLineVisibleCheckBox, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.gridwidth = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(5, 45, 5, 10);
        mLineSymbolPanel.add(mSymbolLineSeparator, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.gridwidth = 4;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        mLinePanel.add(mLineSymbolPanel, gridBagConstraints);

        mTabbedPane.addTab("Line", mLinePanel);

        mBarPanel.setLayout(new java.awt.GridBagLayout());

        mBarVisibleCheckBox.setText("Visible");
        mBarVisibleCheckBox.setFont(new java.awt.Font("Dialog", 0, 12));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 4;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 10, 5, 10);
        mBarPanel.add(mBarVisibleCheckBox, gridBagConstraints);

        mBarLineWidthLabel.setFont(new java.awt.Font("Dialog", 0, 12));
        mBarLineWidthLabel.setText("Width");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 10;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(5, 25, 0, 5);
        mBarPanel.add(mBarLineWidthLabel, gridBagConstraints);

        mBarLineColorLabel.setFont(new java.awt.Font("Dialog", 0, 12));
        mBarLineColorLabel.setText("Color");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 10;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 20, 0, 5);
        mBarPanel.add(mBarLineColorLabel, gridBagConstraints);

        mBarLineWidthSpinner.setFont(new java.awt.Font("Dialog", 0, 12));
        mBarLineWidthSpinner.setMinimumSize(new java.awt.Dimension(75, 22));
        mBarLineWidthSpinner.setPreferredSize(new java.awt.Dimension(75, 22));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 10;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 0, 5);
        mBarPanel.add(mBarLineWidthSpinner, gridBagConstraints);

        mBarLineColorButton.setFont(new java.awt.Font("Dialog", 0, 11));
        mBarLineColorButton.setMinimumSize(new java.awt.Dimension(65, 20));
        mBarLineColorButton.setPreferredSize(new java.awt.Dimension(65, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 10;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 0, 10);
        mBarPanel.add(mBarLineColorButton, gridBagConstraints);

        mBarLineVisibleCheckBox.setText("Visible");
        mBarLineVisibleCheckBox.setFont(new java.awt.Font("Dialog", 0, 12));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 8;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 50, 0, 0);
        mBarPanel.add(mBarLineVisibleCheckBox, gridBagConstraints);

        mBarBodyLabel.setFont(new java.awt.Font("Dialog", 3, 12));
        mBarBodyLabel.setText("Body");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = 4;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 15, 5, 10);
        mBarPanel.add(mBarBodyLabel, gridBagConstraints);

        mBarLineLabel.setFont(new java.awt.Font("Dialog", 3, 12));
        mBarLineLabel.setText("Line");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 8;
        gridBagConstraints.gridwidth = 4;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 15, 5, 10);
        mBarPanel.add(mBarLineLabel, gridBagConstraints);

        mBarInnerColorButton.setFont(new java.awt.Font("Dialog", 0, 11));
        mBarInnerColorButton.setMinimumSize(new java.awt.Dimension(65, 20));
        mBarInnerColorButton.setPreferredSize(new java.awt.Dimension(65, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 10);
        mBarPanel.add(mBarInnerColorButton, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(5, 50, 5, 10);
        mBarPanel.add(mBarBodySeparator, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 8;
        gridBagConstraints.gridwidth = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(5, 125, 5, 10);
        mBarPanel.add(mBarLineSeparator, gridBagConstraints);

        mBarBaseLinePanel.setLayout(new java.awt.GridBagLayout());

        mBarBaseLineTextField.setHorizontalAlignment(javax.swing.JTextField.LEFT);
        mBarBaseLineTextField.setText("0.0");
        mBarBaseLineTextField.setFont(new java.awt.Font("Dialog", 0, 12));
        mBarBaseLineTextField.setMinimumSize(new java.awt.Dimension(70, 22));
        mBarBaseLineTextField.setPreferredSize(new java.awt.Dimension(70, 22));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 0);
        mBarBaseLinePanel.add(mBarBaseLineTextField, gridBagConstraints);

        mBarBaseLineValueLabel.setFont(new java.awt.Font("Dialog", 0, 12));
        mBarBaseLineValueLabel.setText("Baseline");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 5);
        mBarBaseLinePanel.add(mBarBaseLineValueLabel, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 4;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 15, 5, 10);
        mBarPanel.add(mBarBaseLinePanel, gridBagConstraints);

        mBarWidthValueLabel.setFont(new java.awt.Font("Dialog", 0, 12));
        mBarWidthValueLabel.setText("Width");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 5);
        mBarPanel.add(mBarWidthValueLabel, gridBagConstraints);

        mBarWidthValueTextField.setHorizontalAlignment(javax.swing.JTextField.LEFT);
        mBarWidthValueTextField.setText("0.0");
        mBarWidthValueTextField.setFont(new java.awt.Font("Dialog", 0, 12));
        mBarWidthValueTextField.setMinimumSize(new java.awt.Dimension(70, 22));
        mBarWidthValueTextField.setPreferredSize(new java.awt.Dimension(70, 22));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 5);
        mBarPanel.add(mBarWidthValueTextField, gridBagConstraints);

        mBarVerticalCheckBox.setText("Vertical");
        mBarVerticalCheckBox.setFont(new java.awt.Font("Dialog", 0, 12));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 10, 5, 5);
        mBarPanel.add(mBarVerticalCheckBox, gridBagConstraints);

        mBarColorLabel.setFont(new java.awt.Font("Dialog", 0, 12));
        mBarColorLabel.setText("Color");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(5, 20, 5, 5);
        mBarPanel.add(mBarColorLabel, gridBagConstraints);

        mBarBodyColorFillRadioButton.setText("Fill");
        mBarBodyColorFillRadioButton.setFont(new java.awt.Font("Dialog", 0, 12));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 10, 0, 0);
        mBarPanel.add(mBarBodyColorFillRadioButton, gridBagConstraints);

        mBarBodyColorPatternRadioButton.setText("Pattern");
        mBarBodyColorPatternRadioButton.setFont(new java.awt.Font("Dialog", 0, 12));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 10, 0, 0);
        mBarPanel.add(mBarBodyColorPatternRadioButton, gridBagConstraints);

        mBarBodyColorGradationRadioButton.setText("Gradation");
        mBarBodyColorGradationRadioButton.setFont(new java.awt.Font("Dialog", 0, 12));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 10, 0, 0);
        mBarPanel.add(mBarBodyColorGradationRadioButton, gridBagConstraints);

        mBarBodyColorPatternPaintButton.setMinimumSize(new java.awt.Dimension(65, 20));
        mBarBodyColorPatternPaintButton.setPreferredSize(new java.awt.Dimension(65, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 5, 10);
        mBarPanel.add(mBarBodyColorPatternPaintButton, gridBagConstraints);

        mBarBodyColorGradationColorButton.setMinimumSize(new java.awt.Dimension(65, 20));
        mBarBodyColorGradationColorButton.setPreferredSize(new java.awt.Dimension(65, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 5, 10);
        mBarPanel.add(mBarBodyColorGradationColorButton, gridBagConstraints);

        mBarBodyTransparencyPanel.setLayout(new java.awt.GridBagLayout());

        mBarBodyTransparencyLabel.setFont(new java.awt.Font("Dialog", 0, 12));
        mBarBodyTransparencyLabel.setText("Transparency");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 5, 5);
        mBarBodyTransparencyPanel.add(mBarBodyTransparencyLabel, gridBagConstraints);

        mBarBodyTransparencySpinner.setFont(new java.awt.Font("Dialog", 0, 12));
        mBarBodyTransparencySpinner.setMinimumSize(new java.awt.Dimension(75, 22));
        mBarBodyTransparencySpinner.setPreferredSize(new java.awt.Dimension(75, 22));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 10, 0, 0);
        mBarBodyTransparencyPanel.add(mBarBodyTransparencySpinner, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.gridwidth = 4;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 50, 5, 10);
        mBarPanel.add(mBarBodyTransparencyPanel, gridBagConstraints);

        mBarPlacementLabel.setFont(new java.awt.Font("Dialog", 3, 12));
        mBarPlacementLabel.setText("Placement");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 11;
        gridBagConstraints.insets = new java.awt.Insets(5, 15, 0, 10);
        mBarPanel.add(mBarPlacementLabel, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 11;
        gridBagConstraints.gridwidth = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(0, 80, 0, 0);
        mBarPanel.add(mBarPlacementSeparator, gridBagConstraints);

        mBarPlacementShiftXLabel.setFont(new java.awt.Font("Dialog", 0, 12));
        mBarPlacementShiftXLabel.setText("Shift X");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 12;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(0, 25, 0, 5);
        mBarPanel.add(mBarPlacementShiftXLabel, gridBagConstraints);

        mBarPlacementShiftYLabel.setFont(new java.awt.Font("Dialog", 0, 12));
        mBarPlacementShiftYLabel.setText("Shift Y");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 12;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        mBarPanel.add(mBarPlacementShiftYLabel, gridBagConstraints);

        mBarPlacementShiftXTextField.setFont(new java.awt.Font("Dialog", 0, 12));
        mBarPlacementShiftXTextField.setMinimumSize(new java.awt.Dimension(70, 22));
        mBarPlacementShiftXTextField.setPreferredSize(new java.awt.Dimension(70, 22));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 12;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 10, 0, 0);
        mBarPanel.add(mBarPlacementShiftXTextField, gridBagConstraints);

        mBarPlacementShiftYTextField.setFont(new java.awt.Font("Dialog", 0, 12));
        mBarPlacementShiftYTextField.setMinimumSize(new java.awt.Dimension(70, 22));
        mBarPlacementShiftYTextField.setPreferredSize(new java.awt.Dimension(70, 22));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 12;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 10);
        mBarPanel.add(mBarPlacementShiftYTextField, gridBagConstraints);

        mBarPlacementIntervalLabel.setFont(new java.awt.Font("Dialog", 0, 12));
        mBarPlacementIntervalLabel.setText("Interval");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 13;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 10, 0);
        mBarPanel.add(mBarPlacementIntervalLabel, gridBagConstraints);

        mBarPlacementIntervalTextField.setFont(new java.awt.Font("Dialog", 0, 12));
        mBarPlacementIntervalTextField.setMinimumSize(new java.awt.Dimension(70, 22));
        mBarPlacementIntervalTextField.setPreferredSize(new java.awt.Dimension(70, 22));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 13;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 10, 10, 0);
        mBarPanel.add(mBarPlacementIntervalTextField, gridBagConstraints);

        mTabbedPane.addTab("Bar", mBarPanel);

        mErrorBarPanel.setLayout(new java.awt.GridBagLayout());

        mErrorBarVisibleCheckBox.setText("Visible");
        mErrorBarVisibleCheckBox.setFont(new java.awt.Font("Dialog", 0, 12));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(10, 10, 5, 5);
        mErrorBarPanel.add(mErrorBarVisibleCheckBox, gridBagConstraints);

        mErrorBarSymbolSizeLabel.setFont(new java.awt.Font("Dialog", 0, 12));
        mErrorBarSymbolSizeLabel.setText("Size");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 25, 5, 5);
        mErrorBarPanel.add(mErrorBarSymbolSizeLabel, gridBagConstraints);

        mErrorBarSymbolSizeSpinner.setFont(new java.awt.Font("Dialog", 0, 12));
        mErrorBarSymbolSizeSpinner.setPreferredSize(new java.awt.Dimension(75, 22));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        mErrorBarPanel.add(mErrorBarSymbolSizeSpinner, gridBagConstraints);

        mErrorBarColorLabel.setFont(new java.awt.Font("Dialog", 0, 12));
        mErrorBarColorLabel.setText("Color");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(5, 20, 5, 5);
        mErrorBarPanel.add(mErrorBarColorLabel, gridBagConstraints);

        mErrorBarTypeLabel.setFont(new java.awt.Font("Dialog", 0, 12));
        mErrorBarTypeLabel.setText("Type");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 25, 5, 5);
        mErrorBarPanel.add(mErrorBarTypeLabel, gridBagConstraints);

        mErrorBarTypeComboBox.setFont(new java.awt.Font("Dialog", 0, 12));
        mErrorBarTypeComboBox.setPreferredSize(new java.awt.Dimension(90, 22));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 10);
        mErrorBarPanel.add(mErrorBarTypeComboBox, gridBagConstraints);

        mErrorBarColorButton.setFont(new java.awt.Font("Dialog", 0, 11));
        mErrorBarColorButton.setPreferredSize(new java.awt.Dimension(65, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 10);
        mErrorBarPanel.add(mErrorBarColorButton, gridBagConstraints);

        mErrorBarStyleLabel.setFont(new java.awt.Font("Dialog", 3, 12));
        mErrorBarStyleLabel.setText("Style");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.gridwidth = 4;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 15, 5, 10);
        mErrorBarPanel.add(mErrorBarStyleLabel, gridBagConstraints);

        mErrorBarSymbolLabel.setFont(new java.awt.Font("Dialog", 3, 12));
        mErrorBarSymbolLabel.setText("Symbol ");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 4;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 15, 5, 10);
        mErrorBarPanel.add(mErrorBarSymbolLabel, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.gridwidth = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(5, 50, 5, 10);
        mErrorBarPanel.add(mErrorBarStyleSeparator, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(5, 65, 5, 10);
        mErrorBarPanel.add(mErrorBarSymbolSeparator, gridBagConstraints);

        mErrorBarSylePanel.setLayout(new java.awt.GridBagLayout());

        mErrorBarBothsidesRadioButton.setText("Bothsides");
        mErrorBarBothsidesRadioButton.setFont(new java.awt.Font("Dialog", 0, 12));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        mErrorBarSylePanel.add(mErrorBarBothsidesRadioButton, gridBagConstraints);

        mErrorBarUpsideRadioButton.setText("Upside");
        mErrorBarUpsideRadioButton.setFont(new java.awt.Font("Dialog", 0, 12));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        mErrorBarSylePanel.add(mErrorBarUpsideRadioButton, gridBagConstraints);

        mErrorBarDownsideRadioButton.setText("Downside");
        mErrorBarDownsideRadioButton.setFont(new java.awt.Font("Dialog", 0, 12));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        mErrorBarSylePanel.add(mErrorBarDownsideRadioButton, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.gridwidth = 4;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 30, 5, 10);
        mErrorBarPanel.add(mErrorBarSylePanel, gridBagConstraints);

        mErrorBarLineWidthPanel.setLayout(new java.awt.GridBagLayout());

        mErrorBarLineWidthLabel1.setFont(new java.awt.Font("Dialog", 0, 12));
        mErrorBarLineWidthLabel1.setText("Line");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 5);
        mErrorBarLineWidthPanel.add(mErrorBarLineWidthLabel1, gridBagConstraints);

        mErrorBarLineWidthSpinner.setFont(new java.awt.Font("Dialog", 0, 12));
        mErrorBarLineWidthSpinner.setPreferredSize(new java.awt.Dimension(75, 22));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 0);
        mErrorBarLineWidthPanel.add(mErrorBarLineWidthSpinner, gridBagConstraints);

        mErrorBarLineWidthLabel2.setFont(new java.awt.Font("Dialog", 0, 12));
        mErrorBarLineWidthLabel2.setText("Width");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 5);
        mErrorBarLineWidthPanel.add(mErrorBarLineWidthLabel2, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.gridwidth = 4;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 25, 5, 10);
        mErrorBarPanel.add(mErrorBarLineWidthPanel, gridBagConstraints);

        mErrorBarVerticalCheckBox.setText("Vertical");
        mErrorBarVerticalCheckBox.setFont(new java.awt.Font("Dialog", 0, 12));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(10, 10, 5, 5);
        mErrorBarPanel.add(mErrorBarVerticalCheckBox, gridBagConstraints);

        mErrorBarPositionLabel.setFont(new java.awt.Font("Dialog", 3, 12));
        mErrorBarPositionLabel.setText("Position");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 15, 5, 10);
        mErrorBarPanel.add(mErrorBarPositionLabel, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.gridwidth = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(5, 70, 5, 10);
        mErrorBarPanel.add(mErrorBarPositionSeparator, gridBagConstraints);

        mErrorBarPositionPanel.setLayout(new java.awt.GridBagLayout());

        mErrorBarPositionLineRadioButton.setText("Line");
        mErrorBarPositionLineRadioButton.setFont(new java.awt.Font("Dialog", 0, 12));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        mErrorBarPositionPanel.add(mErrorBarPositionLineRadioButton, gridBagConstraints);

        mErrorBarPositionBarRadioButton.setText("Bar");
        mErrorBarPositionBarRadioButton.setFont(new java.awt.Font("Dialog", 0, 12));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 20, 0, 0);
        mErrorBarPositionPanel.add(mErrorBarPositionBarRadioButton, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 8;
        gridBagConstraints.gridwidth = 4;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 30, 5, 10);
        mErrorBarPanel.add(mErrorBarPositionPanel, gridBagConstraints);

        mTabbedPane.addTab("Error Bar", mErrorBarPanel);

        mTickLabelPanel.setMaximumSize(new java.awt.Dimension(2147483647, 2147483647));
        mTickLabelPanel.setMinimumSize(new java.awt.Dimension(297, 229));
        mTickLabelPanel.setLayout(new java.awt.GridBagLayout());

        mTickLabelFontSizeLabel.setFont(new java.awt.Font("Dialog", 0, 12));
        mTickLabelFontSizeLabel.setText("Size");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 25, 5, 5);
        mTickLabelPanel.add(mTickLabelFontSizeLabel, gridBagConstraints);

        mTickLabelVisibleCheckBox.setText("Visible");
        mTickLabelVisibleCheckBox.setFont(new java.awt.Font("Dialog", 0, 12));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(10, 10, 5, 10);
        mTickLabelPanel.add(mTickLabelVisibleCheckBox, gridBagConstraints);

        mTickLabelFontSizeSpinner.setFont(new java.awt.Font("Dialog", 0, 12));
        mTickLabelFontSizeSpinner.setPreferredSize(new java.awt.Dimension(75, 22));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        mTickLabelPanel.add(mTickLabelFontSizeSpinner, gridBagConstraints);

        mTickLabelColorButton.setFont(new java.awt.Font("Dialog", 0, 11));
        mTickLabelColorButton.setPreferredSize(new java.awt.Dimension(65, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 10);
        mTickLabelPanel.add(mTickLabelColorButton, gridBagConstraints);

        mTickLabelColorLabel.setFont(new java.awt.Font("Dialog", 0, 12));
        mTickLabelColorLabel.setText("Color");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 20, 5, 5);
        mTickLabelPanel.add(mTickLabelColorLabel, gridBagConstraints);

        mTickLabelAnglePanel.setMinimumSize(new java.awt.Dimension(150, 22));
        mTickLabelAnglePanel.setLayout(new java.awt.GridBagLayout());

        mTickLabelAngleLabel.setFont(new java.awt.Font("Dialog", 0, 12));
        mTickLabelAngleLabel.setText("Angle");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        mTickLabelAnglePanel.add(mTickLabelAngleLabel, gridBagConstraints);

        mTickLabelAngleSpinner.setFont(new java.awt.Font("Dialog", 0, 12));
        mTickLabelAngleSpinner.setPreferredSize(new java.awt.Dimension(75, 22));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 27, 0, 0);
        mTickLabelAnglePanel.add(mTickLabelAngleSpinner, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.gridwidth = 4;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 20, 5, 10);
        mTickLabelPanel.add(mTickLabelAnglePanel, gridBagConstraints);

        mTickLabelFontLabel.setFont(new java.awt.Font("Dialog", 3, 12));
        mTickLabelFontLabel.setText("Font");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 4;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 15, 5, 5);
        mTickLabelPanel.add(mTickLabelFontLabel, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 45, 0, 10);
        mTickLabelPanel.add(mTickLabelFontSeparator, gridBagConstraints);

        mTickLabelTextLabel.setFont(new java.awt.Font("Dialog", 3, 12));
        mTickLabelTextLabel.setText("Text");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.gridwidth = 4;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 15, 5, 10);
        mTickLabelPanel.add(mTickLabelTextLabel, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.gridwidth = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 55, 0, 10);
        mTickLabelPanel.add(mTickLanelAngleSeparator, gridBagConstraints);

        mTickLabelFontStyleComboBox.setFont(new java.awt.Font("Dialog", 0, 12));
        mTickLabelFontStyleComboBox.setPreferredSize(new java.awt.Dimension(100, 22));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 10);
        mTickLabelPanel.add(mTickLabelFontStyleComboBox, gridBagConstraints);

        mTickLabelFontNameComboBox.setFont(new java.awt.Font("Dialog", 0, 12));
        mTickLabelFontNameComboBox.setPreferredSize(new java.awt.Dimension(170, 22));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 10);
        mTickLabelPanel.add(mTickLabelFontNameComboBox, gridBagConstraints);

        mTickLabelFontNameLabel.setFont(new java.awt.Font("Dialog", 0, 12));
        mTickLabelFontNameLabel.setText("Famiry");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 25, 5, 5);
        mTickLabelPanel.add(mTickLabelFontNameLabel, gridBagConstraints);

        mTickLabelFontStyleLabel.setFont(new java.awt.Font("Dialog", 0, 12));
        mTickLabelFontStyleLabel.setText("Style");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 25, 5, 5);
        mTickLabelPanel.add(mTickLabelFontStyleLabel, gridBagConstraints);

        mTickLabelFormatLabel.setFont(new java.awt.Font("Dialog", 3, 12));
        mTickLabelFormatLabel.setText("Format");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.gridwidth = 4;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 15, 5, 10);
        mTickLabelPanel.add(mTickLabelFormatLabel, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 10);
        mTickLabelPanel.add(mTickLabelFormatSeparator, gridBagConstraints);

        mTickLabelFormatPanel.setLayout(new java.awt.GridBagLayout());

        mTickLabelDecimalPlacesSpinner.setFont(new java.awt.Font("Dialog", 0, 12));
        mTickLabelDecimalPlacesSpinner.setPreferredSize(new java.awt.Dimension(75, 22));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 10, 5, 5);
        mTickLabelFormatPanel.add(mTickLabelDecimalPlacesSpinner, gridBagConstraints);

        mTickLabelDecimalPlacesLabel.setFont(new java.awt.Font("Dialog", 0, 12));
        mTickLabelDecimalPlacesLabel.setText("Decimal Places");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        mTickLabelFormatPanel.add(mTickLabelDecimalPlacesLabel, gridBagConstraints);

        mTickLabelExponentBaseLabel.setFont(new java.awt.Font("Dialog", 1, 14));
        mTickLabelExponentBaseLabel.setText("10");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 0);
        mTickLabelFormatPanel.add(mTickLabelExponentBaseLabel, gridBagConstraints);

        mTickLabelExponentSpinner.setFont(new java.awt.Font("Dialog", 0, 10));
        mTickLabelExponentSpinner.setPreferredSize(new java.awt.Dimension(40, 20));
        mTickLabelExponentSpinner.setValue(Integer.valueOf(0));
        mTickLabelExponentSpinner.setVerifyInputWhenFocusTarget(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 0, 30);
        mTickLabelFormatPanel.add(mTickLabelExponentSpinner, gridBagConstraints);

        mTickLabelExponentLabel.setFont(new java.awt.Font("Dialog", 0, 12));
        mTickLabelExponentLabel.setText("Exponent");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridheight = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        mTickLabelFormatPanel.add(mTickLabelExponentLabel, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 8;
        gridBagConstraints.gridwidth = 4;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 20, 5, 10);
        mTickLabelPanel.add(mTickLabelFormatPanel, gridBagConstraints);

        mTickLabelHorizontalAlignmentCheckBox.setText("Horizontal Alignment");
        mTickLabelHorizontalAlignmentCheckBox.setFont(new java.awt.Font("Dialog", 0, 12));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(10, 20, 5, 10);
        mTickLabelPanel.add(mTickLabelHorizontalAlignmentCheckBox, gridBagConstraints);

        mTabbedPane.addTab("Tick Label", mTickLabelPanel);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 5, 0);
        getContentPane().add(mTabbedPane, gridBagConstraints);

        mOKButton.setText("OK");
        mOKButton.setFont(new java.awt.Font("Dialog", 1, 12));
        mButtonPanel.add(mOKButton);

        mCancelButton.setText("Cancel");
        mCancelButton.setFont(new java.awt.Font("Dialog", 1, 12));
        mButtonPanel.add(mCancelButton);

        mPreviewButton.setText("Preview");
        mPreviewButton.setFont(new java.awt.Font("Dialog", 1, 12));
        mButtonPanel.add(mPreviewButton);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        getContentPane().add(mButtonPanel, gridBagConstraints);

        pack();
    }// </editor-fold>//GEN-END:initComponents
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private jp.riken.brain.ni.samuraigraph.base.SGTwoAxesSelectionPanel mAxisPanel;
    private javax.swing.JPanel mBarBaseLinePanel;
    private jp.riken.brain.ni.samuraigraph.base.SGTextField mBarBaseLineTextField;
    private javax.swing.JLabel mBarBaseLineValueLabel;
    private jp.riken.brain.ni.samuraigraph.base.SGRadioButton mBarBodyColorFillRadioButton;
    private jp.riken.brain.ni.samuraigraph.base.SGGradationPaintSelectionButton mBarBodyColorGradationColorButton;
    private jp.riken.brain.ni.samuraigraph.base.SGRadioButton mBarBodyColorGradationRadioButton;
    private jp.riken.brain.ni.samuraigraph.base.SGPatternPaintSelectionButton mBarBodyColorPatternPaintButton;
    private jp.riken.brain.ni.samuraigraph.base.SGRadioButton mBarBodyColorPatternRadioButton;
    private javax.swing.JLabel mBarBodyLabel;
    private javax.swing.JSeparator mBarBodySeparator;
    private javax.swing.JLabel mBarBodyTransparencyLabel;
    private javax.swing.JPanel mBarBodyTransparencyPanel;
    private jp.riken.brain.ni.samuraigraph.base.SGSpinner mBarBodyTransparencySpinner;
    private javax.swing.JLabel mBarColorLabel;
    private jp.riken.brain.ni.samuraigraph.base.SGColorSelectionButton mBarInnerColorButton;
    private jp.riken.brain.ni.samuraigraph.base.SGColorSelectionButton mBarLineColorButton;
    private javax.swing.JLabel mBarLineColorLabel;
    private javax.swing.JLabel mBarLineLabel;
    private javax.swing.JSeparator mBarLineSeparator;
    private jp.riken.brain.ni.samuraigraph.base.SGCheckBox mBarLineVisibleCheckBox;
    private javax.swing.JLabel mBarLineWidthLabel;
    private jp.riken.brain.ni.samuraigraph.base.SGSpinner mBarLineWidthSpinner;
    private javax.swing.JPanel mBarPanel;
    private javax.swing.JLabel mBarPlacementIntervalLabel;
    private jp.riken.brain.ni.samuraigraph.base.SGTextField mBarPlacementIntervalTextField;
    private javax.swing.JLabel mBarPlacementLabel;
    private javax.swing.JSeparator mBarPlacementSeparator;
    private javax.swing.JLabel mBarPlacementShiftXLabel;
    private jp.riken.brain.ni.samuraigraph.base.SGTextField mBarPlacementShiftXTextField;
    private javax.swing.JLabel mBarPlacementShiftYLabel;
    private jp.riken.brain.ni.samuraigraph.base.SGTextField mBarPlacementShiftYTextField;
    private jp.riken.brain.ni.samuraigraph.base.SGCheckBox mBarVerticalCheckBox;
    private jp.riken.brain.ni.samuraigraph.base.SGCheckBox mBarVisibleCheckBox;
    private javax.swing.JLabel mBarWidthLabel;
    private jp.riken.brain.ni.samuraigraph.base.SGSpinner mBarWidthSpinner;
    private javax.swing.JLabel mBarWidthValueLabel;
    private jp.riken.brain.ni.samuraigraph.base.SGTextField mBarWidthValueTextField;
    private javax.swing.JPanel mButtonPanel;
    private jp.riken.brain.ni.samuraigraph.base.SGButton mCancelButton;
    private javax.swing.JPanel mCommonPanel;
    private jp.riken.brain.ni.samuraigraph.base.SGButton mDataColumnSelectionButton;
    private jp.riken.brain.ni.samuraigraph.base.SGRadioButton mErrorBarBothsidesRadioButton;
    private jp.riken.brain.ni.samuraigraph.base.SGColorSelectionButton mErrorBarColorButton;
    private javax.swing.JLabel mErrorBarColorLabel;
    private jp.riken.brain.ni.samuraigraph.base.SGRadioButton mErrorBarDownsideRadioButton;
    private javax.swing.JLabel mErrorBarLineWidthLabel1;
    private javax.swing.JLabel mErrorBarLineWidthLabel2;
    private javax.swing.JPanel mErrorBarLineWidthPanel;
    private jp.riken.brain.ni.samuraigraph.base.SGSpinner mErrorBarLineWidthSpinner;
    private javax.swing.JPanel mErrorBarPanel;
    private jp.riken.brain.ni.samuraigraph.base.SGRadioButton mErrorBarPositionBarRadioButton;
    private javax.swing.JLabel mErrorBarPositionLabel;
    private jp.riken.brain.ni.samuraigraph.base.SGRadioButton mErrorBarPositionLineRadioButton;
    private javax.swing.JPanel mErrorBarPositionPanel;
    private javax.swing.JSeparator mErrorBarPositionSeparator;
    private javax.swing.JLabel mErrorBarStyleLabel;
    private javax.swing.JSeparator mErrorBarStyleSeparator;
    private javax.swing.JPanel mErrorBarSylePanel;
    private javax.swing.JLabel mErrorBarSymbolLabel;
    private javax.swing.JSeparator mErrorBarSymbolSeparator;
    private javax.swing.JLabel mErrorBarSymbolSizeLabel;
    private jp.riken.brain.ni.samuraigraph.base.SGSpinner mErrorBarSymbolSizeSpinner;
    private jp.riken.brain.ni.samuraigraph.base.SGComboBox mErrorBarTypeComboBox;
    private javax.swing.JLabel mErrorBarTypeLabel;
    private jp.riken.brain.ni.samuraigraph.base.SGRadioButton mErrorBarUpsideRadioButton;
    private jp.riken.brain.ni.samuraigraph.base.SGCheckBox mErrorBarVerticalCheckBox;
    private jp.riken.brain.ni.samuraigraph.base.SGCheckBox mErrorBarVisibleCheckBox;
    private jp.riken.brain.ni.samuraigraph.base.SGCheckBox mLegendVisibleCheckBox;
    private jp.riken.brain.ni.samuraigraph.base.SGColorSelectionButton mLineColorButton;
    private javax.swing.JLabel mLineColorLabel;
    private jp.riken.brain.ni.samuraigraph.base.SGCheckBox mLineConnectCheckBox;
    private jp.riken.brain.ni.samuraigraph.base.SGButton mLineEditButton;
    private javax.swing.JPanel mLinePanel;
    private javax.swing.JLabel mLinePlacementLabel;
    private javax.swing.JSeparator mLinePlacementSeparator;
    private javax.swing.JLabel mLinePlacementShiftXLabel;
    private jp.riken.brain.ni.samuraigraph.base.SGTextField mLinePlacementShiftXTextField;
    private javax.swing.JLabel mLinePlacementShiftYLabel;
    private jp.riken.brain.ni.samuraigraph.base.SGTextField mLinePlacementShiftYTextField;
    private javax.swing.JLabel mLineSymbolLabel;
    private javax.swing.JPanel mLineSymbolPanel;
    private javax.swing.JSeparator mLineSymbolSeparator;
    private jp.riken.brain.ni.samuraigraph.base.SGComboBox mLineTypeComboBox;
    private javax.swing.JLabel mLineTypeLabel;
    private jp.riken.brain.ni.samuraigraph.base.SGCheckBox mLineVisibleCheckBox;
    private javax.swing.JLabel mLineWidthLabel;
    private jp.riken.brain.ni.samuraigraph.base.SGSpinner mLineWidthSpinner;
    private jp.riken.brain.ni.samuraigraph.base.SGTextField mNameField;
    private javax.swing.JLabel mNameLabel;
    private jp.riken.brain.ni.samuraigraph.base.SGButton mOKButton;
    private jp.riken.brain.ni.samuraigraph.base.SGButton mPreviewButton;
    private javax.swing.JLabel mSymbolBodyLabel;
    private javax.swing.JSeparator mSymbolBodySeparator;
    private javax.swing.JLabel mSymbolBodyTransparencyLabel;
    private javax.swing.JPanel mSymbolBodyTransparencyPanel;
    private jp.riken.brain.ni.samuraigraph.base.SGSpinner mSymbolBodyTransparencySpinner;
    private jp.riken.brain.ni.samuraigraph.base.SGColorSelectionButton mSymbolColorButton;
    private javax.swing.JLabel mSymbolColorLabel;
    private jp.riken.brain.ni.samuraigraph.base.SGColorSelectionButton mSymbolLineColorButton;
    private javax.swing.JLabel mSymbolLineColorLabel;
    private javax.swing.JLabel mSymbolLineLabel;
    private javax.swing.JSeparator mSymbolLineSeparator;
    private jp.riken.brain.ni.samuraigraph.base.SGCheckBox mSymbolLineVisibleCheckBox;
    private javax.swing.JLabel mSymbolLineWidthLabel;
    private jp.riken.brain.ni.samuraigraph.base.SGSpinner mSymbolLineWidthSpinner;
    private javax.swing.JLabel mSymbolSizeLabel;
    private jp.riken.brain.ni.samuraigraph.base.SGSpinner mSymbolSizeSpinner;
    private jp.riken.brain.ni.samuraigraph.base.SGComboBox mSymbolTypeComboBox;
    private javax.swing.JLabel mSymbolTypeLabel;
    private javax.swing.JPanel mSymbolTypePanel;
    private jp.riken.brain.ni.samuraigraph.base.SGCheckBox mSymbolVisibleCheckBox;
    private javax.swing.JTabbedPane mTabbedPane;
    private javax.swing.JLabel mTickLabelAngleLabel;
    private javax.swing.JPanel mTickLabelAnglePanel;
    private jp.riken.brain.ni.samuraigraph.base.SGSpinner mTickLabelAngleSpinner;
    private jp.riken.brain.ni.samuraigraph.base.SGColorSelectionButton mTickLabelColorButton;
    private javax.swing.JLabel mTickLabelColorLabel;
    private javax.swing.JLabel mTickLabelDecimalPlacesLabel;
    private jp.riken.brain.ni.samuraigraph.base.SGSpinner mTickLabelDecimalPlacesSpinner;
    private javax.swing.JLabel mTickLabelExponentBaseLabel;
    private javax.swing.JLabel mTickLabelExponentLabel;
    private jp.riken.brain.ni.samuraigraph.base.SGSpinner mTickLabelExponentSpinner;
    private javax.swing.JLabel mTickLabelFontLabel;
    private jp.riken.brain.ni.samuraigraph.base.SGComboBox mTickLabelFontNameComboBox;
    private javax.swing.JLabel mTickLabelFontNameLabel;
    private javax.swing.JSeparator mTickLabelFontSeparator;
    private javax.swing.JLabel mTickLabelFontSizeLabel;
    private jp.riken.brain.ni.samuraigraph.base.SGSpinner mTickLabelFontSizeSpinner;
    private jp.riken.brain.ni.samuraigraph.base.SGComboBox mTickLabelFontStyleComboBox;
    private javax.swing.JLabel mTickLabelFontStyleLabel;
    private javax.swing.JLabel mTickLabelFormatLabel;
    private javax.swing.JPanel mTickLabelFormatPanel;
    private javax.swing.JSeparator mTickLabelFormatSeparator;
    private jp.riken.brain.ni.samuraigraph.base.SGCheckBox mTickLabelHorizontalAlignmentCheckBox;
    private javax.swing.JPanel mTickLabelPanel;
    private javax.swing.JLabel mTickLabelTextLabel;
    private jp.riken.brain.ni.samuraigraph.base.SGCheckBox mTickLabelVisibleCheckBox;
    private javax.swing.JSeparator mTickLanelAngleSeparator;
    // End of variables declaration//GEN-END:variables
    

    private JRadioButton mNoErrorBarStyleSelectionRadioButton = new JRadioButton();
    
    private JRadioButton mNoBarBodyColorStyleSelectionRadioButton = new JRadioButton();

    private Integer mMultipleDimensionStart = null;

    private Integer mMultipleDimensionEnd = null;
    
    private Integer mMultipleDimensionStep = null;
    
    private SGPatternPaintDialog mPatternPaintDialog;
    
    private SGGradationPaintDialog mGradationPaintDialog;

    /** members of this group disabled if transparency is 1.0 */
    private SGComponentGroup mBarBodyTransparentComponentGroup = new SGComponentGroup();    
    // /**
    // *
    // *
    // */
    // public void dispose()
    // {
    // this.mAxisPanel.dispose();
    // this.mAxisPanel = null;
    //		
    // this.mNoErrorBarStyleSelectionRadioButton = null;
    // this.mNoTickLabelAngleSelectionRadioButton = null;
    //		
    // this.mFocusedLineColorButton = null;
    // this.mFocusedSymbolColorButton = null;
    // this.mFocusedBarColorButton = null;
    // this.mFocusedErrorBarColorButton = null;
    // this.mFocusedTickLabelColorButton = null;
    // this.mFocusedColorSetButton = null;
    //
    // super.dispose();
    // }

    private boolean initProperty() {

        // set the title
        this.setTitle(SGPropertyDialogSXYData.TITLE);

        {
            // add items to the line type combo box
            final String typeArray[] = { SGILineConstants.LINE_NAME_SOLID,
                    SGILineConstants.LINE_NAME_BROKEN,
                    SGILineConstants.LINE_NAME_DOT,
                    SGILineConstants.LINE_NAME_DASHED,
                    SGILineConstants.LINE_NAME_DOUBLE_DASHED };
            for (int ii = 0; ii < typeArray.length; ii++) {
                this.mLineTypeComboBox.addItem(typeArray[ii]);
            }
        }

        {
            // add items to the symbol type combo box
            final Object typeArray[] = { SGISymbolConstants.SYMBOL_NAME_CIRCLE,
                    SGISymbolConstants.SYMBOL_NAME_SQUARE,
                    SGISymbolConstants.SYMBOL_NAME_DIAMOND,
                    SGISymbolConstants.SYMBOL_NAME_TRIANGLE,
                    SGISymbolConstants.SYMBOL_NAME_INVERTED_TRIANGLE,
                    SGISymbolConstants.SYMBOL_NAME_CROSS,
                    SGISymbolConstants.SYMBOL_NAME_PLUS };
            for (int ii = 0; ii < typeArray.length; ii++) {
                this.mSymbolTypeComboBox.addItem(typeArray[ii]);
            }
        }

        {
            // add items to the error bar type combo box
            final String typeArray[] = { SGIErrorBarConstants.SYMBOL_NAME_CIRCLE,
            		SGIErrorBarConstants.SYMBOL_NAME_TRANSVERSE_LINE,
            		SGIErrorBarConstants.SYMBOL_NAME_VOID };
            for (int ii = 0; ii < typeArray.length; ii++) {
                this.mErrorBarTypeComboBox.addItem(typeArray[ii]);
            }

            // create a button group for the radio buttons of error bar style
            this.mNoErrorBarStyleSelectionRadioButton.setVisible(false);
            final ButtonGroup group = new ButtonGroup();
            group.add(this.mErrorBarBothsidesRadioButton);
            group.add(this.mErrorBarUpsideRadioButton);
            group.add(this.mErrorBarDownsideRadioButton);
            group.add(this.mNoErrorBarStyleSelectionRadioButton);
            
            final ButtonGroup positionGroup = new ButtonGroup();
            positionGroup.add(this.mErrorBarPositionLineRadioButton);
            positionGroup.add(this.mErrorBarPositionBarRadioButton);
        }
        
        {
            // create a button group for the radio buttons of bar body paint types
            this.mNoBarBodyColorStyleSelectionRadioButton.setVisible(false);
            final ButtonGroup group  = new ButtonGroup();
            group.add(this.mBarBodyColorFillRadioButton);
            group.add(this.mBarBodyColorPatternRadioButton);
            group.add(this.mBarBodyColorGradationRadioButton);
            group.add(this.mNoBarBodyColorStyleSelectionRadioButton);
        }

        {
            // add items to the tick label combo box
            final String fontArray[] = SGUtility.getAvailableFontFamilyNames();
            for (int ii = 0; ii < fontArray.length; ii++) {
                this.mTickLabelFontNameComboBox.addItem(fontArray[ii]);
            }
            final String[] styleNameArray = { FONT_PLAIN, FONT_ITALIC,
                    FONT_BOLD, FONT_BOLD_ITALIC };
            for (int ii = 0; ii < styleNameArray.length; ii++) {
                this.mTickLabelFontStyleComboBox.addItem(styleNameArray[ii]);
            }
        }

        this.pack();

        //
        // Set spinner models
        //

        // line
        this.mLineWidthSpinner.initProperties(
                getLineWidthSpinnerNumberModel(), LINE_WIDTH_UNIT,
                LINE_WIDTH_FRAC_DIGIT_MIN, LINE_WIDTH_FRAC_DIGIT_MAX);

        // symbol
        this.mSymbolSizeSpinner.initProperties(new SpinnerNumberModel(0.1,
                SYMBOL_SIZE_MIN, SYMBOL_SIZE_MAX, SYMBOL_SIZE_STEP),
                SYMBOL_SIZE_UNIT, SYMBOL_SIZE_FRAC_DIFIT_MIN, SYMBOL_SIZE_FRAC_DIFIT_MAX);

        this.mSymbolLineWidthSpinner.initProperties(
                getLineWidthSpinnerNumberModel(), LINE_WIDTH_UNIT,
                LINE_WIDTH_FRAC_DIGIT_MIN, LINE_WIDTH_FRAC_DIGIT_MAX);
        
        this.mSymbolBodyTransparencySpinner.initProperties(
                new SpinnerNumberModel(100.0,
                        (float)SGPaintConstants.TRANSPARENCY_MIN,
                        (float)SGPaintConstants.TRANSPARENCY_MAX,
                        (float)SGPaintConstants.TRANSPARENCY_STEP),
                SGIConstants.percent,
                SGPaintConstants.TRANSPARENCY_FRAC_DIGIT_MIN,
                SGPaintConstants.TRANSPARENCY_FRAC_DIGIT_MAX);

        // bar
        this.mBarLineWidthSpinner.initProperties(
                getLineWidthSpinnerNumberModel(), LINE_WIDTH_UNIT,
                LINE_WIDTH_FRAC_DIGIT_MIN, LINE_WIDTH_FRAC_DIGIT_MAX);

        // error bar
        this.mErrorBarLineWidthSpinner.initProperties(
                getLineWidthSpinnerNumberModel(), LINE_WIDTH_UNIT,
                LINE_WIDTH_FRAC_DIGIT_MIN, LINE_WIDTH_FRAC_DIGIT_MAX);
        
        // bar inner paint transparency
        this.mBarBodyTransparencySpinner.initProperties(
                new SpinnerNumberModel(100.0,
                        (float)SGPaintConstants.TRANSPARENCY_MIN,
                        (float)SGPaintConstants.TRANSPARENCY_MAX,
                        (float)SGPaintConstants.TRANSPARENCY_STEP),
                SGIConstants.percent,
                SGPaintConstants.TRANSPARENCY_FRAC_DIGIT_MIN,
                SGPaintConstants.TRANSPARENCY_FRAC_DIGIT_MAX);

        this.mErrorBarSymbolSizeSpinner.initProperties(new SpinnerNumberModel(
                0.1, ERROR_BAR_HEAD_SIZE_MIN, ERROR_BAR_HEAD_SIZE_MAX,
                ERROR_BAR_HEAD_SIZE_STEP), ERROR_BAR_HEAD_SIZE_UNIT,
                ERROR_BAR_HEAD_SIZE_FRAC_DIFIT_MIN, ERROR_BAR_HEAD_SIZE_FRAC_DIFIT_MAX);

        // tick label
        this.mTickLabelFontSizeSpinner.initProperties(
                getFontSizeSpinnerNumberModel(), FONT_SIZE_UNIT,
                FONT_SIZE_FRAC_DIGIT_MIN, FONT_SIZE_FRAC_DIGIT_MAX);
        this.mTickLabelDecimalPlacesSpinner.initProperties(new SpinnerNumberModel(0.0,
                (float) TICK_LABEL_DECIMAL_PLACES_MIN, (float) TICK_LABEL_DECIMAL_PLACES_MAX,
                (float) TICK_LABEL_DECIMAL_PLACES_STEP), null, 0, 0);
        this.mTickLabelExponentSpinner.initProperties(new SpinnerNumberModel(0.0,
                (float) TICK_LABEL_EXPONENT_MIN, (float) TICK_LABEL_EXPONENT_MAX,
                (float) TICK_LABEL_EXPONENT_STEP), null, 0, 0);
        this.mTickLabelAngleSpinner.initProperties(new SpinnerNumberModel(0.0,
                (float) TICK_LABEL_TEXT_ANGLE_MIN, (float) TICK_LABEL_TEXT_ANGLE_MAX,
                (float) TICK_LABEL_TEXT_ANGLE_STEP), degree,
                TICK_LABEL_TEXT_ANGLE_FRAC_DIFIT_MIN,
                TICK_LABEL_TEXT_ANGLE_FRAC_DIFIT_MAX);

        // add an action listener to each items
        this.mLineVisibleCheckBox.addActionListener(this);
        this.mSymbolVisibleCheckBox.addActionListener(this);
        this.mSymbolLineVisibleCheckBox.addActionListener(this);
        this.mBarVisibleCheckBox.addActionListener(this);
        this.mBarLineVisibleCheckBox.addActionListener(this);
        this.mErrorBarVisibleCheckBox.addActionListener(this);
        this.mTickLabelVisibleCheckBox.addActionListener(this);
        this.mLegendVisibleCheckBox.addActionListener(this);
        this.mLineEditButton.addActionListener(this);
        this.mDataColumnSelectionButton.addActionListener(this);
        this.mAxisPanel.addActionListener(this);
        this.mLineTypeComboBox.addActionListener(this);
        this.mSymbolTypeComboBox.addActionListener(this);
        this.mBarBodyColorPatternPaintButton.addActionListener(this);
        this.mBarBodyColorGradationColorButton.addActionListener(this);
        this.mErrorBarTypeComboBox.addActionListener(this);
        this.mTickLabelFontNameComboBox.addActionListener(this);
        this.mTickLabelFontStyleComboBox.addActionListener(this);
        this.mErrorBarBothsidesRadioButton.addActionListener(this);
        this.mErrorBarUpsideRadioButton.addActionListener(this);
        this.mErrorBarDownsideRadioButton.addActionListener(this);

        // set the name
        this.mNameField.setDescription("Name");
        this.mLineWidthSpinner.setDescription("Line-> Width");
        this.mSymbolSizeSpinner.setDescription("Line-> Symbol-> Body-> Size");
        this.mSymbolBodyTransparencySpinner.setDescription("Line-> Symbol-> Body-> Transparency");
        this.mSymbolLineWidthSpinner.setDescription("Line-> Symbol-> Line-> Width");
        this.mLinePlacementShiftXTextField.setDescription("Line-> Placement-> Shift X");
        this.mLinePlacementShiftYTextField.setDescription("Line-> Placement-> Shift Y");
        this.mBarBaseLineTextField.setDescription("Bar-> Baseline");
        this.mBarWidthValueTextField.setDescription("Bar-> Body-> Width");
        this.mBarBodyTransparencySpinner.setDescription("Bar-> Body-> Transparency");
        this.mBarLineWidthSpinner.setDescription("Bar-> Line-> Width");
        this.mBarPlacementShiftXTextField.setDescription("Bar-> Placement-> Shift X");
        this.mBarPlacementShiftYTextField.setDescription("Bar-> Placement-> Shift Y");
        this.mBarPlacementIntervalTextField.setDescription("Bar-> Placement-> Interval");
        this.mErrorBarSymbolSizeSpinner
                .setDescription("Error Bar-> Symbol-> Size");
        this.mErrorBarLineWidthSpinner
                .setDescription("Error Bar-> Symbol-> Line Width");
        this.mTickLabelFontSizeSpinner
                .setDescription("Tick Label-> Font-> Size");
        this.mTickLabelAngleSpinner
                .setDescription("Tick Label-> Text-> Angle");
        this.mTickLabelDecimalPlacesSpinner
                .setDescription("Tick Label-> Format-> Decimal Places");
        this.mTickLabelExponentSpinner
                .setDescription("Tick Label-> Format-> Exponent");

        // add as a change listener
        this.mTabbedPane.addChangeListener(this);
        this.mBarBodyTransparencySpinner.addChangeListener(this);
        this.mSymbolBodyTransparencySpinner.addChangeListener(this);

        // create a dialog to edit line stroke
        // this.mStrokeDialog = new SGStrokeDialog(this, true);
        
        this.mErrorBarVerticalCheckBox.setVisible(false);
        this.mTickLabelHorizontalAlignmentCheckBox.setVisible(false);
        
        // setup gradation paint dialog.
        this.mGradationPaintDialog = new SGGradationPaintDialog(this, "Gradation Paint Dialog", false);
        this.mGradationPaintDialog.setDefaultCloseOperation(JFrame.HIDE_ON_CLOSE);
        this.mGradationPaintDialog.pack();
        this.mGradationPaintDialog.setResizable(false);
        this.mGradationPaintDialog.addModelChangeListener(this);
        
        // setup pattern paint dialog.
        this.mPatternPaintDialog = new SGPatternPaintDialog(this, "Pattern Paint Dialog", false);
        this.mPatternPaintDialog.setDefaultCloseOperation(JFrame.HIDE_ON_CLOSE);
        this.mPatternPaintDialog.pack();
        this.mPatternPaintDialog.setResizable(false);
        this.mPatternPaintDialog.addModelChangeListener(this);
        
        SGComponentGroupElement[] array = {
                new SGComponentGroupElement(this.mBarColorLabel),
                new SGComponentGroupElement(this.mBarInnerColorButton),
                new SGComponentGroupElement(this.mBarBodyColorFillRadioButton),
                new SGComponentGroupElement(this.mBarBodyColorPatternPaintButton),
                new SGComponentGroupElement(this.mBarBodyColorPatternRadioButton),
                new SGComponentGroupElement(this.mBarBodyColorGradationColorButton),
                new SGComponentGroupElement(this.mBarBodyColorGradationRadioButton)
        };
        this.mBarBodyTransparentComponentGroup.addElement(array);
        
        return true;
    }
    
    @Override
    public void stateChanged(final ChangeEvent e) {
        Object source = e.getSource();
        if (source==this.mGradationPaintDialog) {
            SGGradationPaint gradation = this.mGradationPaintDialog.getGradationPaint();
            this.mBarBodyColorGradationColorButton.setGradationPaint(gradation);
            return;
        } else if (source==this.mPatternPaintDialog) {
            SGPatternPaint patternPaint = this.mPatternPaintDialog.getPatternPaint();
            this.mBarBodyColorPatternPaintButton.setPatternPaint(patternPaint);
            return;
        } else if (source==this.mBarBodyTransparencySpinner) {
            if (null!=this.getTransparency()) {
                this.setBarBodyTransparentComponentEnabled(Integer.valueOf(this.getTransparency().intValue()));
            }
        } else if (source==this.mSymbolBodyTransparencySpinner) {
            if (null!=this.getSymbolInnerTransparency()) {
                this.setSymbolBodyTransparentComponentEnabled(Integer.valueOf(this.getSymbolInnerTransparency().intValue()));
            }
        }
        super.stateChanged(e);
    }

    /**
     * 
     * @return
     */
    public String getDataName() {
        return this.mNameField.getText();
    }

    /**
     * 
     * @param str
     * @return
     */
    public boolean setDataName(final String str) {
        this.mNameField.setText(str);
        return true;
    }

    /**
     * 
     * @return
     */
    public Boolean getLegendVisible() {
        return this.mLegendVisibleCheckBox.getSelected();
    }

    /**
     * 
     * @param b
     */
    public void setLegendVisible(final Boolean b) {
        this.mLegendVisibleCheckBox.setSelected(b);
    }

    //
    // Line
    //

    /**
     * 
     */
    public Boolean getLineVisible() {
        return this.mLineVisibleCheckBox.getSelected();
    }

    /**
     * 
     */
    public Number getLineWidth() {
        return this.mLineWidthSpinner.getNumber();
    }

    /**
     * 
     */
    public Integer getLineType() {
        final String typeName = (String) this.mLineTypeComboBox
                .getSelectedItem();
        final Integer num = SGDrawingElementLine.getLineTypeFromName(typeName);
        return num;
    }

    /**
     * 
     */
    public Color getLineColor() {
        return this.mLineColorButton.getColor();
    }

    /**
     * 
     */
    public boolean setLineVisible(final Boolean flag) {
        this.mLineVisibleCheckBox.setSelected(flag);
        this.setLineComponentsEnabled(flag);
        return true;
    }

    /**
     * 
     */
    public boolean setLineWidth(final Object obj) {
        return this.setValue(this.mLineWidthSpinner, obj);
    }

    /**
     * 
     */
    public boolean setLineType(final Integer type) {
        if (type != null) {
            final String typeName = SGDrawingElementLine.getLineTypeName(type
                    .intValue());
            this.mLineTypeComboBox.setSelectedItem(typeName);
        } else {
            this.mLineTypeComboBox.setSelectedItem(null);
        }

        return true;
    }

    /**
     * 
     */
    public boolean setLineColor(final Color cl) {
        this.mLineColorButton.setColor(cl);
        return true;
    }

    /**
     * Returns whether to connect all effective points.
     * 
     * @return true if connecting all effective points
     */
    public Boolean getLineConnection() {
        return this.mLineConnectCheckBox.getSelected();
    }
    
    /**
     * Sets whether to connect all effective points.
     * 
     * @param flag
     *           true to connect all effective points
     * @return true if succeeded
     */
    public boolean setLineConnection(final Boolean flag) {
        this.mLineConnectCheckBox.setSelected(flag);
        return true;
    }
    
    public Number getLineShiftX() {
        return this.getNumber(this.mLinePlacementShiftXTextField);
    }
    
    public Number getLineShiftY() {
        return this.getNumber(this.mLinePlacementShiftYTextField);
    }
    
    public boolean setLineShiftX(final Object obj) {
        return this.setValue(this.mLinePlacementShiftXTextField, obj);
    }
    
    public boolean setLineShiftY(final Object obj) {
        return this.setValue(this.mLinePlacementShiftYTextField, obj);
    }

    //
    // Symbol
    //

    /**
     * 
     */
    public Boolean getSymbolVisible() {
        return this.mSymbolVisibleCheckBox.getSelected();
    }

    /**
     * 
     */
    public Number getSymbolSize() {
        return this.mSymbolSizeSpinner.getNumber();
    }

    /**
     * 
     */
    public Integer getSymbolType() {
        final String typeName = (String) this.mSymbolTypeComboBox
                .getSelectedItem();
        final Integer num = SGDrawingElementSymbol
                .getSymbolTypeFromName(typeName);
        return num;
    }

    /**
     * 
     */
    public Number getSymbolLineWidth() {
        return this.mSymbolLineWidthSpinner.getNumber();
    }

    /**
     * 
     */
    public Color getSymbolInnerColor() {
        return this.mSymbolColorButton.getColor();
    }
    
    public Number getSymbolInnerTransparency() {
        return this.mSymbolBodyTransparencySpinner.getNumber();
    }
    
    public SGIPaint getSymbolInnerPaint() {
        SGFillPaint innerPaint = new SGFillPaint();
        innerPaint.setColor(this.getSymbolInnerColor());
        innerPaint.setTransparency(this.getSymbolInnerTransparency().intValue());
        return innerPaint;
    }

    /**
     * 
     */
    public Color getSymbolLineColor() {
        return this.mSymbolLineColorButton.getColor();
    }
    
    public Boolean getSymbolLineVisible() {
        return this.mSymbolLineVisibleCheckBox.getSelected();
    }

    /**
     * 
     */
    public boolean setSymbolVisible(final Boolean flag) {
        this.mSymbolVisibleCheckBox.setSelected(flag);
        this.setSymbolComponentsEnabled(flag);
        return true;
    }

    /**
     * 
     */
    public boolean setSymbolType(final Integer type) {
        if (type != null) {
            final String typeName = SGDrawingElementSymbol
                    .getSymbolTypeName(type.intValue());
            this.mSymbolTypeComboBox.setSelectedItem(typeName);
        } else {
            this.mSymbolTypeComboBox.setSelectedItem(null);
        }
        return true;
    }

    /**
     * 
     */
    public boolean setSymbolSize(final Object obj) {
        return this.setValue(this.mSymbolSizeSpinner, obj);
    }

    /**
     * 
     */
    public boolean setSymbolLineWidth(final Object obj) {
        return this.setValue(this.mSymbolLineWidthSpinner, obj);
    }

    /**
     * 
     */
    public boolean setSymbolInnerColor(final Color cl) {
        this.mSymbolColorButton.setColor(cl);
        return true;
    }
    
    public boolean setSymbolInnerTransparent(final Integer alpha) {
        setSymbolBodyTransparentComponentEnabled(alpha);
        return this.setValue(this.mSymbolBodyTransparencySpinner, Float.valueOf(alpha.floatValue()));
    }
    
    public boolean setSymbolInnerPaint(final SGIPaint paint) {
        if (paint instanceof SGFillPaint) {
            SGFillPaint fpaint = (SGFillPaint)paint;
            this.setSymbolInnerColor(SGFillPaint.getOpaqueColor((Color)fpaint.getPaint(null)));
            this.setSymbolInnerTransparent(Integer.valueOf(fpaint.getTransparencyPercent()));
            return true;
        } else {
            return false;
        }
    }
    
    private boolean setSymbolBodyTransparentComponentEnabled(final Integer alpha) {
        boolean b = true;
        Boolean visible = this.getSymbolVisible();
        if (visible != null) {
            if (visible.booleanValue() == false) {
                b = false;
            }
            if (Integer.valueOf(SGTransparentPaint.ALL_TRANSPARENT_VALUE).equals(alpha)) {
                b = false;
            }
        }
        this.mSymbolColorButton.setEnabled(b);
        this.mSymbolColorLabel.setEnabled(b);
        return true;
    }

    /**
     * 
     */
    public boolean setSymbolLineColor(final Color cl) {
        this.mSymbolLineColorButton.setColor(cl);
        return true;
    }

    public boolean setSymbolLineVisible(final Boolean flag) {
        this.mSymbolLineVisibleCheckBox.setSelected(flag);
        this.setSymbolLineComponentsEnabled(flag);
        return true;
    }
    
    //
    // Bar
    //

    /**
     * 
     */
    public Boolean getBarVisible() {
        return this.mBarVisibleCheckBox.getSelected();
    }

    /**
     * 
     */
    public Number getBarWidth() {
        return this.getNumber(this.mBarWidthValueTextField);
    }

    /**
     * 
     */
    public Number getBarEdgeLineWidth() {
        return this.mBarLineWidthSpinner.getNumber();
    }

    /**
     * 
     */
    public Number getBarBaselineValue() {
        return this.getNumber(this.mBarBaseLineTextField);
    }

    /**
     * 
     */
    public Color getBarEdgeLineColor() {
        return this.mBarLineColorButton.getColor();
    }
    
    public Boolean getBarEdgeLineVisible() {
        return this.mBarLineVisibleCheckBox.getSelected();
    }

    /**
     * 
     */
    public Color getBarBodyFillPaintColor() {
        return this.mBarInnerColorButton.getColor();
    }
    
    public SGPatternPaint getBarBodyPatternPaint() {
        return this.mBarBodyColorPatternPaintButton.getPatternPaint();
    }
    
    public SGGradationPaint getBarBodyGradationPaint() {
        return this.mBarBodyColorGradationColorButton.getGradationPaint();
    }
    
    public Integer getBarBodyColorStyle() {
        int style;
        if (this.mBarBodyColorFillRadioButton.isSelected()) {
            style = SGSelectablePaint.STYLE_INDEX_FILL;
        } else if (this.mBarBodyColorPatternRadioButton.isSelected()) {
            style = SGSelectablePaint.STYLE_INDEX_PATTERN;
        } else if (this.mBarBodyColorGradationRadioButton.isSelected()) {
            style = SGSelectablePaint.STYLE_INDEX_GRADATION;
        } else {
            style = SGSelectablePaint.STYLE_INDEX_FILL;
        }
        return Integer.valueOf(style);
    }
    
    public Number getTransparency() {
        return this.mBarBodyTransparencySpinner.getNumber();
    }
    
    public SGIPaint getBarBodyPaint() {
        SGSelectablePaint selectablePaint = new SGSelectablePaint();
        selectablePaint.setFillColor(this.getBarBodyFillPaintColor());
        selectablePaint.setPatternPaint(this.getBarBodyPatternPaint());
        selectablePaint.setGradationPaint(this.getBarBodyGradationPaint());
        selectablePaint.setSelectedPaintStyle(this.getBarBodyColorStyle().intValue());
        selectablePaint.setTransparency(this.getTransparency().intValue());
        return selectablePaint;
    }
    
    public Boolean isBarVertical() {
        return this.mBarVerticalCheckBox.getSelected();
    }
    
    public Number getBarInterval() {
        if (this.mBarPlacementIntervalTextField.isEnabled()) {
            return this.getNumber(this.mBarPlacementIntervalTextField);
        } else {
            return SGUtilityText.getDouble(this.mTemporaryBarIntervalText);
        }
    }
    
    public boolean setBarBodyFillPaintColor(final Color color) {
        this.mBarInnerColorButton.setColor(color);
        return true;
    }
    
    public boolean setBarBodyPatternPaint(final SGPatternPaint paint) {
        if (paint != null) {
            this.mBarBodyColorPatternPaintButton.setPatternPaint(paint);
            return true;
        } else {
            return false;
        }
    }
    
    public boolean setBarBodyGradationPaint(final SGGradationPaint paint) {
        if (paint != null) {
            this.mBarBodyColorGradationColorButton.setGradationPaint(paint);
            return true;
        } else {
            return false;
        }
    }
    
    public boolean setBarBodyColorStyle(final Object obj) {
        if (obj == null) {
            this.mNoBarBodyColorStyleSelectionRadioButton.setSelected(true);
            return false;
        }
        Integer style = null;
        try {
            style = Integer.valueOf(obj.toString());
        } catch (NumberFormatException ex) {
            return false;
        }

        switch (style.intValue()) {
        case SGSelectablePaint.STYLE_INDEX_FILL :
            this.mBarBodyColorFillRadioButton.setSelected(true);
            break;
        case SGSelectablePaint.STYLE_INDEX_PATTERN :
            this.mBarBodyColorPatternRadioButton.setSelected(true);
            break;
        case SGSelectablePaint.STYLE_INDEX_GRADATION : 
            this.mBarBodyColorGradationRadioButton.setSelected(true);
            break;
        default:
            throw new Error();
        }
        return true;
    }

    /**
     * 
     */
    public boolean setBarVisible(final Boolean flag) {
        this.mBarVisibleCheckBox.setSelected(flag);
        this.setBarComponentsEnabled(flag);
        return true;
    }

    /**
     * 
     */
    public boolean setBarWidth(final Object obj) {
        // return this.setValue( this.mBarWidthSpinner, obj );
        return this.setValue(this.mBarWidthValueTextField, obj);
    }

    /**
     * 
     */
    public boolean setBarEdgeLineWidth(final Object obj) {
        return this.setValue(this.mBarLineWidthSpinner, obj);
    }

    /**
     * 
     */
    public boolean setBarBaselineValue(final Object obj) {
        return this.setValue(this.mBarBaseLineTextField, obj);
    }

    public boolean setBarInnerPaint(final SGIPaint paint) {
        if (paint instanceof SGSelectablePaint) {
            SGSelectablePaint selectablePaint = (SGSelectablePaint)paint;
            this.setBarBodyColorStyle(selectablePaint.getSelectedStyle());
            this.setBarBodyFillPaintColor(SGFillPaint.getOpaqueColor(selectablePaint.getFillColor()));
            this.setBarBodyPatternPaint(selectablePaint.getPatternPaint());
            this.setBarBodyGradationPaint(selectablePaint.getGradationPaint());
            this.setBarBodyTransparent(Integer.valueOf(selectablePaint.getTransparencyPercent()));
            return true;
        } else if (paint instanceof SGFillPaint) {
            SGFillPaint fpaint = (SGFillPaint)paint;
            this.setBarBodyColorStyle(SGSelectablePaint.STYLE_INDEX_FILL);
            this.setBarBodyFillPaintColor(SGFillPaint.getOpaqueColor((Color)fpaint.getPaint(null)));
            this.setBarBodyTransparent(Integer.valueOf(fpaint.getTransparencyPercent()));
            return true;
        } else if (paint instanceof SGPatternPaint) {
            SGPatternPaint ppaint = (SGPatternPaint)paint;
            this.setBarBodyColorStyle(SGSelectablePaint.STYLE_INDEX_PATTERN);
            this.setBarBodyPatternPaint(ppaint);
            this.setBarBodyTransparent(Integer.valueOf(ppaint.getTransparencyPercent()));
            return true;
        } else if (paint instanceof SGGradationPaint) {
            SGGradationPaint gpaint = (SGGradationPaint)paint;
            this.setBarBodyColorStyle(SGSelectablePaint.STYLE_INDEX_GRADATION);
            this.setBarBodyGradationPaint(gpaint);
            this.setBarBodyTransparent(Integer.valueOf(gpaint.getTransparencyPercent()));
            return true;
        } else {
            return false;
        }
    }
    
    public boolean setBarBodyTransparent(final Integer alpha) {
        setBarBodyTransparentComponentEnabled(alpha);
        return this.setValue(this.mBarBodyTransparencySpinner, Float.valueOf(alpha.floatValue()));
    }
    
    private boolean setBarBodyTransparentComponentEnabled(final Integer alpha) {
        if (alpha.equals(Integer.valueOf(SGTransparentPaint.ALL_TRANSPARENT_VALUE))) {
            return setBarBodyTransparentComponentEnabled(Boolean.FALSE);
        } else {
            return setBarBodyTransparentComponentEnabled(Boolean.TRUE);
        }
    }

    private boolean setBarBodyTransparentComponentEnabled(final Boolean flag) {
        if (this.mBarBodyTransparentComponentGroup.isEnabled()!=flag.booleanValue()) {
            this.mBarBodyTransparentComponentGroup.setEnabled(flag.booleanValue());
        }
        return true;
    }
    
    /**
     * 
     */
    public boolean setBarEdgeLineColor(final Color cl) {
        this.mBarLineColorButton.setColor(cl);
        return true;
    }
    
    public boolean setBarEdgeLineVisible(final Boolean visible) {
        this.mBarLineVisibleCheckBox.setSelected(visible);
        this.setBarEdgeLineComponentsEnabled(visible);
        return true;
    }

    public boolean setBarVertical(final Boolean flag) {
        this.mBarVerticalCheckBox.setSelected(flag);
        return true;
    }
    
    public boolean setBarInterval(final Object obj) {
        return this.setValue(this.mBarPlacementIntervalTextField, obj);
    }
    
    public Number getBarShiftX() {
        return this.getNumber(this.mBarPlacementShiftXTextField);
    }
    
    public Number getBarShiftY() {
        return this.getNumber(this.mBarPlacementShiftYTextField);
    }
    
    public boolean setBarShiftX(final Object obj) {
        return this.setValue(this.mBarPlacementShiftXTextField, obj);
    }
    
    public boolean setBarShiftY(final Object obj) {
        return this.setValue(this.mBarPlacementShiftYTextField, obj);
    }

    //
    // Error Bar
    //

    /**
     * 
     */
    public Boolean getErrorBarVisible() {
        return this.mErrorBarVisibleCheckBox.getSelected();
    }

    /**
     * 
     */
    public Number getErrorBarSymbolSize() {
        return this.mErrorBarSymbolSizeSpinner.getNumber();
    }

    /**
     * 
     */
    public Number getErrorBarLineWidth() {
        return this.mErrorBarLineWidthSpinner.getNumber();
    }

    /**
     * 
     */
    public Color getErrorBarColor() {
        return this.mErrorBarColorButton.getColor();
    }

    /**
     * 
     */
    public String getErrorBarTypeName() {
        return (String) this.mErrorBarTypeComboBox.getSelectedItem();
    }

    /**
     * 
     */
    public Integer getErrorBarStyle() {
        int style = -1;
        if (this.mErrorBarBothsidesRadioButton.isSelected()) {
            style = SGIErrorBarConstants.ERROR_BAR_BOTHSIDES;
        } else if (this.mErrorBarUpsideRadioButton.isSelected()) {
            style = SGIErrorBarConstants.ERROR_BAR_UPSIDE;
        } else if (this.mErrorBarDownsideRadioButton.isSelected()) {
            style = SGIErrorBarConstants.ERROR_BAR_DOWNSIDE;
        } else {
            return null;
        }

        return Integer.valueOf(style);
    }
    
    public Boolean getErrorBarVertical() {
    	return this.mErrorBarVerticalCheckBox.getSelected();
    }
    
    public Boolean getErrorBarOnLinePosition() {
        return Boolean.valueOf(this.mErrorBarPositionLineRadioButton.isSelected());
    }

    /**
     * 
     */
    public boolean setErrorBarVisible(final Boolean flag) {
        this.mErrorBarVisibleCheckBox.setSelected(flag);
        this.setErrorBarComponentsEnabled(flag);
        return true;
    }

    /**
     * 
     */
    public boolean setErrorBarSymbolSize(final Object obj) {
        return this.setValue(this.mErrorBarSymbolSizeSpinner, obj);
    }

    /**
     * 
     */
    public boolean setErrorBarLineWidth(final Object obj) {
        return this.setValue(this.mErrorBarLineWidthSpinner, obj);
    }

    /**
     * 
     */
    public boolean setErrorBarColor(final Color cl) {
        this.mErrorBarColorButton.setColor(cl);
        return true;
    }

    /**
     * 
     */
    public boolean setErrorBarType(final String typeName) {
        this.mErrorBarTypeComboBox.setSelectedItem(typeName);
        return true;
    }

    /**
     * 
     */
    public boolean setErrorBarStyle(final Object obj) {
        if (obj == null) {
            this.mNoErrorBarStyleSelectionRadioButton.setSelected(true);
            return false;
        }
        Integer style = null;
        try {
            style = Integer.valueOf(obj.toString());
        } catch (NumberFormatException ex) {
            return false;
        }

        switch (style.intValue()) {
        case SGIErrorBarConstants.ERROR_BAR_BOTHSIDES: {
            this.mErrorBarBothsidesRadioButton.setSelected(true);
            break;
        }

        case SGIErrorBarConstants.ERROR_BAR_UPSIDE: {
            this.mErrorBarUpsideRadioButton.setSelected(true);
            break;
        }

        case SGIErrorBarConstants.ERROR_BAR_DOWNSIDE: {
            this.mErrorBarDownsideRadioButton.setSelected(true);
            break;
        }

        default: {
            throw new Error();
        }
        }

        return true;
    }
    
    public boolean setErrorBarVertical(final Boolean b) {
    	this.mErrorBarVerticalCheckBox.setSelected(b);
    	return true;
    }
    
    public boolean setErrorBarOnLinePosition(final Boolean b) {
        boolean flag = true;
        if (b == null) {
            this.mErrorBarPositionLineRadioButton.setSelected(true);
            this.mErrorBarPositionBarRadioButton.setSelected(false);
            return false;
        } else {
            flag = b.booleanValue();
        }
        
        this.mErrorBarPositionLineRadioButton.setSelected(flag);
        this.mErrorBarPositionBarRadioButton.setSelected(!flag);
        return true;
    }

    //
    // Tick Label
    //

    /**
     * 
     */
    public Boolean getTickLabelVisible() {
        return this.mTickLabelVisibleCheckBox.getSelected();
    }

    /**
     * 
     */
    public String getTickLabelFontName() {
        return (String) this.mTickLabelFontNameComboBox.getSelectedItem();
    }

    /**
     * 
     */
    public Number getTickLabelFontSize() {
        return this.mTickLabelFontSizeSpinner.getNumber();
    }

    /**
     * 
     */
    public Integer getTickLabelFontStyle() {
        final String name = (String) this.mTickLabelFontStyleComboBox
                .getSelectedItem();
        return SGUtilityText.getFontStyle(name);
    }

    public Number getTickLabelAngle() {
        return this.mTickLabelAngleSpinner.getNumber();
    }

    /**
     * 
     */
    public Color getTickLabelColor() {
        return this.mTickLabelColorButton.getColor();
    }
    
    public Number getTickLabelDecimalPlaces() {
        return this.mTickLabelDecimalPlacesSpinner.getNumber();
    }
    
    public Number getTickLabelExponent() {
        return this.mTickLabelExponentSpinner.getNumber();
    }

    public Boolean hasTickLabelHorizonalAlignment() {
    	return this.mTickLabelHorizontalAlignmentCheckBox.getSelected();
    }
    
    /**
     * 
     */
    public boolean setTickLabelVisible(final Boolean flag) {
        this.mTickLabelVisibleCheckBox.setSelected(flag);
        this.setTickLabelComponentsEnabled(flag);
        return true;
    }

    /**
     * Sets the tick label font name.
     * 
     * @param name
     *           the font name to set
     * @return true if succeeded
     */
    public boolean setTickLabelFontName(final String name) {
    	final String fName = SGUtility.findFontFamilyName(name);
        this.mTickLabelFontNameComboBox.setSelectedItem(fName);
        return true;
    }

    /**
     * 
     */
    public boolean setTickLabelFontSize(final Object obj) {
        return this.setValue(this.mTickLabelFontSizeSpinner, obj);
    }

    /**
     * 
     */
    public boolean setTickLabelFontStyle(final Object obj) {
        if (obj == null) {
            this.mTickLabelFontStyleComboBox.setSelectedItem(null);
            return false;
        }
        Integer style = null;
        try {
            style = Integer.valueOf(obj.toString());
        } catch (NumberFormatException ex) {
            return false;
        }
        this.mTickLabelFontStyleComboBox.setSelectedItem(SGUtilityText
                .getFontStyleName(style.intValue()));
        return true;
    }

    public boolean setTickLabelAngle(final Object obj) {
        return this.setValue(this.mTickLabelAngleSpinner, obj);
    }

    /**
     * 
     */
    public boolean setTickLabelColor(final Color cl) {
        this.mTickLabelColorButton.setColor(cl);
        return true;
    }
    
    public boolean setTickLabelDecimalPlaces(final Object obj) {
        return this.setValue(this.mTickLabelDecimalPlacesSpinner, obj);
    }
    
    public boolean setTickLabelExponent(final Object obj) {
        return this.setValue(this.mTickLabelExponentSpinner, obj);
    }

    public boolean setTickLabelHorizonalAlignment(final Boolean b) {
    	this.mTickLabelHorizontalAlignmentCheckBox.setSelected(b);
    	return true;
    }


    /**
     * 
     */
    public List<SGColorSelectionButton> getColorSelectionButtonsList() {
        List<SGColorSelectionButton> list = new ArrayList<SGColorSelectionButton>();
        list.add(this.mLineColorButton);
        list.add(this.mSymbolColorButton);
        list.add(this.mSymbolLineColorButton);
        list.add(this.mBarInnerColorButton);
        list.add(this.mBarLineColorButton);
        list.add(this.mErrorBarColorButton);
        list.add(this.mTickLabelColorButton);

        return list;
    }

    /**
     * 
     */
    public List getTextFieldComponentsList() {
        final List list = this.getFormattedTextFieldsListFromSpinners();
        list.addAll(this.getNumberTextFieldList());
        list.add(this.mNameField);
        return list;
    }

    /**
     * Returns a list of text fields to set number.
     * 
     * @return
     */
    public List<SGTextField> getNumberTextFieldList() {
        final List<SGTextField> list = new ArrayList<SGTextField>();
        list.add(this.mLinePlacementShiftXTextField);
        list.add(this.mLinePlacementShiftYTextField);
        list.add(this.mBarBaseLineTextField);
        list.add(this.mBarWidthValueTextField);
        list.add(this.mBarPlacementShiftXTextField);
        list.add(this.mBarPlacementShiftYTextField);
        list.add(this.mBarPlacementIntervalTextField);
        return list;
    }

    /**
     * 
     */
    public List getSpinnerList() {
        List list = new ArrayList();
        list.add(this.mLineWidthSpinner);
        list.add(this.mSymbolSizeSpinner);
        list.add(this.mSymbolLineWidthSpinner);
        list.add(this.mSymbolBodyTransparencySpinner);
        list.add(this.mBarWidthSpinner);
        list.add(this.mBarLineWidthSpinner);
        list.add(this.mBarBodyTransparencySpinner);
        list.add(this.mErrorBarLineWidthSpinner);
        list.add(this.mErrorBarSymbolSizeSpinner);
        list.add(this.mTickLabelFontSizeSpinner);
        list.add(this.mTickLabelAngleSpinner);
        list.add(this.mTickLabelDecimalPlacesSpinner);
        list.add(this.mTickLabelExponentSpinner);
        return list;
    }

    /**
     * 
     */
    public boolean setTabEnabled(final Component com, final boolean flag) {
        if (com == null) {
            return false;
        }
        final int index = this.mTabbedPane.indexOfComponent(com);
        if (index == -1) {
            return false;
        }

        this.mTabbedPane.setEnabledAt(index, flag);

        // // set enabled all components on the panel
        // this.setComponentsOnPanelEnabled(com,flag);

        return true;
    }

    /**
     * 
     * @param com
     * @return
     */
    public boolean isTabEnabled(final Component com) {
        if (com == null) {
            return false;
        }
        final int index = this.mTabbedPane.indexOfComponent(com);
        if (index == -1) {
            return false;
        }
        return this.mTabbedPane.isEnabledAt(index);
    }

    // /**
    // *
    // * @param p
    // * @return
    // */
    // protected boolean setComponentsOnPanelEnabled( final Component com, final
    // boolean flag )
    // {
    // if( com==null )
    // {
    // return false;
    // }
    //
    // if( com.equals( this.mLinePanel ) )
    // {
    // this.mLineVisibleCheckBox.setEnabled(flag);
    // this.setLineComponentsEnabled(flag&&this.mLineVisibleCheckBox.isSelected());
    // }
    // else if( com.equals( this.mSymbolPanel ) )
    // {
    // this.mSymbolVisibleCheckBox.setEnabled(flag);
    // this.setSymbolComponentsEnabled(flag&&this.mSymbolVisibleCheckBox.isSelected());
    // }
    // else if( com.equals( this.mBarPanel ) )
    // {
    // this.mBarVisibleCheckBox.setEnabled(flag);
    // this.setBarComponentsEnabled(flag&&this.mBarVisibleCheckBox.isSelected());
    // }
    // else if( com.equals( this.mErrorBarPanel ) )
    // {
    // this.mErrorBarVisibleCheckBox.setEnabled(flag);
    // this.setErrorBarComponentsEnabled(flag&&this.mErrorBarVisibleCheckBox.isSelected());
    // }
    // else if( com.equals( this.mTickLabelPanel ) )
    // {
    // this.mTickLabelVisibleCheckBox.setEnabled(flag);
    // this.setTickLabelComponentsEnabled(flag&&this.mTickLabelVisibleCheckBox.isSelected());
    // }
    //
    // return true;
    // }
    
    /**
     * 
     */
    public void actionPerformed(ActionEvent e) {

        super.actionPerformed(e);

        Object source = e.getSource();
        String command = e.getActionCommand();
        
        if (this.isVisible()) {
            if (source == this.mBarInnerColorButton) {
                this.mBarBodyColorFillRadioButton.setSelected(true);
            } else if (source == this.mBarBodyColorPatternPaintButton) {
                this.mBarBodyColorPatternRadioButton.setSelected(true);
            } else if (source == this.mBarBodyColorGradationColorButton) {
                this.mBarBodyColorGradationRadioButton.setSelected(true);
            }
        }
        
        if (source instanceof SGCheckBox) {
            if (source.equals(this.mLineVisibleCheckBox)) {
                this.setLineVisible(this.getLineVisible());
            } else if (source.equals(this.mSymbolVisibleCheckBox)) {
                this.setSymbolVisible(this.getSymbolVisible());
            } else if (source.equals(this.mSymbolLineVisibleCheckBox)) {
                this.setSymbolLineVisible(this.getSymbolLineVisible());
            } else if (source.equals(this.mBarVisibleCheckBox)) {
                this.setBarVisible(this.getBarVisible());
                this.updateBarVerticalCheckBox();
            } else if (source.equals(this.mBarLineVisibleCheckBox)) {
                this.setBarEdgeLineVisible(this.getBarEdgeLineVisible());
            } else if (source.equals(this.mErrorBarVisibleCheckBox)) {
                this.setErrorBarVisible(this.getErrorBarVisible());
            } else if (source.equals(this.mTickLabelVisibleCheckBox)) {
                this.setTickLabelVisible(this.getTickLabelVisible());
            } else if (source.equals(this.mLegendVisibleCheckBox)) {
                this.setLegendVisible(this.getLegendVisible());
            }
        } else if (source instanceof JButton) {
            if (source.equals(this.mLineEditButton)) {
                // this.showLineEditDialog();
            } else if (source.equals(this.mDataColumnSelectionButton)) {
                this.showDataColumnSelectionDialog();
            } else if (source.equals(this.mBarBodyColorPatternPaintButton)) {
                if (! this.mPatternPaintDialog.isVisible()) {
                    this.mPatternPaintDialog.setSelectedPatternPaint(this.mBarBodyColorPatternPaintButton.getPatternPaint());
                    this.mPatternPaintDialog.setLocation(
                            this.mBarBodyColorPatternPaintButton.getX() + 20,
                            this.mBarBodyColorPatternPaintButton.getY() + 20);
                    this.mPatternPaintDialog.setVisible(true);
                }
            } else if (source.equals(this.mBarBodyColorGradationColorButton)) {
                if (! this.mGradationPaintDialog.isVisible()) {
                    this.mGradationPaintDialog.setSelectedGradationPaint(this.mBarBodyColorGradationColorButton.getGradationPaint());
                    this.mGradationPaintDialog.setLocation(
                            this.mBarBodyColorGradationColorButton.getX() + 20,
                            this.mBarBodyColorGradationColorButton.getY() + 20);
                    this.mGradationPaintDialog.setVisible(true);
                }
            }
        } else if (source.equals(this.mDataColumnSelectionDialog)) {
            SGDataSetupDialog dg = (SGDataSetupDialog) source;
            if (OK_BUTTON_TEXT.equals(command)) {
                // get column types
            	SGDataColumnInfo[] colInfo = dg.getDataColumnInfoSet().getDataColumnInfoArray();
            	
                // set to the attribute
                this.mDataInfoArray = colInfo;
                
                // check selected tab
                boolean ebFlag = false;
                boolean tlFlag = false;
                for (int ii = 0; ii < colInfo.length; ii++) {
                    final String colType = colInfo[ii].getColumnType();
                    final String valueType = colInfo[ii].getValueType();
                    if (colType == null) {
                    	continue;
                    }
                    if (colType.startsWith(LOWER_ERROR_VALUE) 
                    		|| colType.startsWith(UPPER_ERROR_VALUE)
                    		|| colType.startsWith(LOWER_UPPER_ERROR_VALUE)) {
                        ebFlag = true;
                    } else if (colType.startsWith(TICK_LABEL)) {
                        tlFlag = true;
                    } else if (VALUE_TYPE_DATE.equals(valueType)) {
                    	if (X_VALUE.equals(colType) || Y_VALUE.equals(colType)) {
                    		tlFlag = true;
                    	}
                    }
                }
                this.setTabEnabled(this.mErrorBarPanel, ebFlag);
                this.setTabEnabled(this.mTickLabelPanel, tlFlag);
                Component cur = this.mTabbedPane.getSelectedComponent();
                if (!ebFlag) {
                    if (this.mErrorBarPanel.equals(cur)) {
                        this.mTabbedPane.setSelectedComponent(this.mLinePanel);
                    }
                }
                if (!tlFlag) {
                    if (this.mTickLabelPanel.equals(cur)) {
                        this.mTabbedPane.setSelectedComponent(this.mLinePanel);
                    }
                }
                
                SGISXYDataDialogObserver obs = (SGISXYDataDialogObserver) this.mPropertyDialogObserverList.get(0);
                SGData data = obs.getData();
                if (SGDataUtility.isNetCDFData(data)) {
                    // for netCDF data, changes the direction of error bars and tick labels 
                    // automatically.
                    // but if change whether Pickup column type exists, data and data type are
                    // converted and then must not be change bar vertical.
                    if (obs instanceof SGElementGroupSetInFigureElement) {
//                        SGDataColumnInfo[] beforeColumnInfo = ((SGElementGroupSetInFigureElement)obs).getDataColumnInfoArray();
//                        boolean pickupInBefore = SGDataUtility.isPickupColumnContained(beforeColumnInfo);
//                        boolean pickupInAfter = SGDataUtility.isPickupColumnContained(colInfo);
//                        if (pickupInBefore==pickupInAfter) {
//                            this.setupBarVerticalByChangingNetCDFDataColumn(colInfo, data, dg);
//                        }
                        this.setupBarVerticalByChangingNetCDFDataColumn(colInfo, data, dg);
                    }
                	
                } else {
                	// text data
                    this.setupBarVerticalByChangingTextDataColumn(colInfo, data);
                }
                
            }
        }
    }
    
    private void setupBarVerticalByChangingNetCDFDataColumn(
            SGDataColumnInfo[] colInfo, SGData data, SGDataSetupDialog dg) {
        
        SGNetCDFData ncData = (SGNetCDFData) data;
        SGNetCDFFile ncFile = ncData.getNetcdfFile();

        List<String> xNameList = new ArrayList<String>();
        List<String> yNameList = new ArrayList<String>();
        List<String> lNameList = new ArrayList<String>();
        List<String> uNameList = new ArrayList<String>();
        List<String> tNameList = new ArrayList<String>();
        List<String> timeNameList = new ArrayList<String>();
        List<String> indexNameList = new ArrayList<String>();

        if (SGDataUtility.isPickupColumnContained(colInfo)) {
            List<String> mNameList = new ArrayList<String>();
            if (!SGDataUtility.getSXYNetCDFColumnType(
                    colInfo, xNameList, yNameList,
                    lNameList, uNameList, tNameList, mNameList,
                    timeNameList, indexNameList)) {
                return;
            }
        } else {
            Map<String, String> lNameMap = new HashMap<String, String>();
            Map<String, String> uNameMap = new HashMap<String, String>();
            Map<String, String> tNameMap = new HashMap<String, String>();
            if (!SGDataUtility.getSXYNetCDFColumnType(
                    colInfo, xNameList, yNameList,
                    lNameMap, uNameMap, tNameMap,
                    timeNameList, indexNameList)) {
                return;
            }
            lNameList = new ArrayList<String>(lNameMap.keySet());
            tNameList = new ArrayList<String>(tNameMap.keySet());
        }

        // checks whether error bars must be vertical
        if (lNameList.size() != 0) {
//            boolean vertical = false;
//            SGVariable[] vars = ((SGSXYMultipleNetCDFData)data).getVariables();
//            String name = xNameList.get(0);
//            if (xNameList.size()>1) {
//                name = yNameList.get(0);
//            }
//            for (int i = 0; i < vars.length; i++) {
//                if (vars[i].getName().equals(name)) {
//                    if (vars[i].isCoordinateVariable()) {
//                        vertical = true;
//                    }
//                    break;
//                }
//            }
        	final boolean vertical = SGUtility.containsAll(yNameList, lNameList);
            this.setErrorBarVertical(vertical);
        }

        // checks whether tick labels must be aligned horizontally
        if (tNameList.size() != 0) {
            final boolean tickLabelAlignedHorizontally = SGUtility.containsAll(yNameList, tNameList);
            this.setTickLabelHorizonalAlignment(tickLabelAlignedHorizontally);
        }

        // checks whether bars must be vertical
        final String xName = xNameList.get(0);
        final String yName = yNameList.get(0);
        SGVariable xVar = ncFile.findVariable(xName);
        SGVariable yVar = ncFile.findVariable(yName);
        if (xVar.isCoordinateVariable() || yVar.isCoordinateVariable()) {
            final boolean barVertical = xVar.isCoordinateVariable();
            this.setBarVertical(barVertical);
        }

        // get multiple origin and step
        SGNetCDFDataSetupDialog ndg = (SGNetCDFDataSetupDialog) dg;
        Integer start = ndg.getMultipleDimensionStart();
        Integer end = ndg.getMultipleDimensionEnd();
        Integer step = ndg.getMultipleDimensionStep();

        // set to the attribute
        this.mMultipleDimensionStart = start;
        this.mMultipleDimensionEnd = end;
        this.mMultipleDimensionStep = step;
    }
    
    private void setupBarVerticalByChangingTextDataColumn(
            SGDataColumnInfo[] colInfo, SGData data) {
        
        List<Integer> xIndexList = new ArrayList<Integer>();
        List<Integer> yIndexList = new ArrayList<Integer>();
        Map<Integer, Integer> lIndexMap = new HashMap<Integer, Integer>();
        Map<Integer, Integer> uIndexMap = new HashMap<Integer, Integer>();
        Map<Integer, Integer> tIndexMap = new HashMap<Integer, Integer>();
        if (SGDataUtility.getSXYColumnType(
                colInfo, xIndexList, yIndexList,
                lIndexMap, uIndexMap, tIndexMap) == false) {
            return;
        }

        SGISXYData dataSXY = (SGISXYData) data;
        boolean directionChanged = false;

        // checks whether error bars must be vertical
        List<Integer> lIndexList = new ArrayList<Integer>(lIndexMap.keySet());
        if (lIndexList.size() != 0) {
            final boolean errorBarVertical = SGUtility.containsAll(yIndexList, lIndexList);
            this.setErrorBarVertical(errorBarVertical);
            if (!Boolean.valueOf(errorBarVertical).equals(dataSXY.isErrorBarVertical())) {
                directionChanged = true;
            }
        }

        // checks whether tick labels must be aligned horizontally
        if (null != dataSXY.isTickLabelHorizontal()) {
            List<Integer> tickIndexList = new ArrayList<Integer>(tIndexMap.keySet());
            final boolean tickLabelAlignedHorizontally;
            if (tickIndexList.size() != 0) {
                tickLabelAlignedHorizontally = SGUtility.containsAll(yIndexList, tickIndexList);
            } else {
                boolean b = false;
                for (int ii = 0; ii < colInfo.length; ii++) {
                    if (VALUE_TYPE_DATE.equals(colInfo[ii].getValueType())) {
                        b = xIndexList.contains(Integer.valueOf(ii));
                        break;
                    }
                }
                tickLabelAlignedHorizontally = b;
            }
            this.setTickLabelHorizonalAlignment(tickLabelAlignedHorizontally);
            if (!directionChanged) {
                if (!Boolean.valueOf(tickLabelAlignedHorizontally).equals(dataSXY.isTickLabelHorizontal())) {
                    directionChanged = true;
                }
            }
        }

        // sets bar direction according to error bars and tick labels
        if (directionChanged) {
            Boolean barVertical = this.isBarVertical();
            if (barVertical != null) {
                this.setBarVertical(!barVertical.booleanValue());
            }
        }
    }
    
    private boolean isOneXYColumn(SGIDataPropertyDialogObserver obs) {
        SGDataColumnInfo[] cols = obs.getDataColumnInfoArray();
        if (this.mDataInfoArray != null) {
            for (int ii = 0; ii < cols.length; ii++) {
                cols[ii] = this.mDataInfoArray[ii];
            }
        }
        
        int xcount = 0;
        int ycount = 0;
        for (int i = 0; i <  cols.length; i++) {
            if (SGIDataColumnTypeConstants.X_VALUE.equals(cols[i].getColumnType())) {
                xcount++;
            } else if (SGIDataColumnTypeConstants.Y_VALUE.equals(cols[i].getColumnType())) {
                ycount++;
            }
        }
        if (xcount>1 || ycount>1) {
            return false;
        } else {
            return true;
        }
    }
    
    private boolean getBarIntervalEnabledInMultipleSeriesBars() {
        SGIDataPropertyDialogObserver obs = (SGIDataPropertyDialogObserver) this.mPropertyDialogObserverList.get(0);
        String dataType = obs.getDataType();
        
        if (SGDataUtility.isSXYTypeData(dataType)==false) {
            return false;
        }
        
        if (SGDataUtility.isMultipleData(dataType)) {
            if (SGDataUtility.isNetCDFDimensionData(dataType)) {
                if (obs.getData() instanceof SGSXYMultipleDimensionNetCDFData) {
                    SGSXYMultipleDimensionNetCDFData ndata = (SGSXYMultipleDimensionNetCDFData)obs.getData();
                    if (ndata.getDimensionIndices().length>1) {
                        return true;
                    }
                }
            } else {
                if (this.isOneXYColumn(obs)==false) {
                    return true;
                }
            }
        }
        return false;
    }
    
//    protected void setDataToDialog(SGIDataPropertyDialogObserver obs) {
//    	super.setDataToDialog(obs);
//    	
//        SGData data = obs.getData();
//        if (SGDataUtility.isNetCDFData(data)) {
//            SGNetCDFDataSetupDialog dg = (SGNetCDFDataSetupDialog) this.mDataColumnSelectionDialog;
//            SGNetCDFData nData = (SGNetCDFData) data;
//            
//            // show or hide the panel for multiple dimension
//            if (nData instanceof SGSXYMultipleDimensionNetCDFData) {
//            	SGISXYDataDialogObserver oxy = (SGISXYDataDialogObserver) obs;
//            	int origin;
//            	if (this.mMultipleDimensionOrigin != null) {
//            		origin = this.mMultipleDimensionOrigin.intValue();
//            	} else {
//            		origin = oxy.getMultipleDimensionOrigin();
//            	}
//            	int step;
//            	if (this.mMultipleDimensionStep != null) {
//            		step = this.mMultipleDimensionStep.intValue();
//            	} else {
//            		step = oxy.getMultipleDimensionStep();
//            	}
//            	
//            	// set to the dialog
//            	dg.setMultipleDimensionOrigin(origin);
//            	dg.setMultipleDimensionStep(step);
//                dg.setMultipleDimensionPanelVisible(true);
//                
//            } else {
//                dg.setMultipleDimensionPanelVisible(false);
//            }
//        }
//    }

    /*
     * // a dialog to edit line stroke private SGStrokeDialog mStrokeDialog =
     * null;
     *  // shows a dialog to edit line stroke private void showLineEditDialog() {
     *  // set the location this.mStrokeDialog.setLocation(this.getLocation());
     *  // set visible this.mStrokeDialog.setVisible(true); }
     */
    /**
     * An error message which is shown when all elements are set to be
     * invisible.
     */
    private static final String ERRMSG_NOT_HIDE_ALL_ELEMENTS = "Lines, symbols and bars cannot be hidden at the same time.";

    /**
     * Returns whether this dialog has valid input values.
     * 
     * @return true if all input values are valid
     */
    protected boolean hasValidInputValues() {
    	
        boolean valid = true;
        if (super.hasValidInputValues() == false) {
            valid = false;
        }

        // if all drawing elements for any one data are hidden,
        // show an error message dialog
        if (this.isAnyElementsShown() == false) {
            this.setInputErrorMessage(ERRMSG_NOT_HIDE_ALL_ELEMENTS);
            valid = false;
        }

        // check the data name
        if (this.mNameField.hasValidText() == false) {
            this.addInputErrorDescription(this.mNameField.getDescription());
            valid = false;
        }
        
        if (this.hasValidNumber(this.mBarWidthValueTextField, 0.0, null) == false) {
        	valid = false;
        }
        if (this.hasValidNumber(this.mBarBaseLineTextField, null, null) == false) {
        	valid = false;
        }
        if (this.mBarPlacementIntervalTextField.isEnabled() &&
                this.hasValidNumber(this.mBarPlacementIntervalTextField, null, null) == false) {
            valid = false;
        }
        if (this.hasValidNumber(this.mLinePlacementShiftXTextField, null, null) == false) {
            valid = false;
        }
        if (this.hasValidNumber(this.mLinePlacementShiftYTextField, null, null) == false) {
            valid = false;
        }
        if (this.hasValidNumber(this.mBarPlacementShiftXTextField, null, null) == false) {
            valid = false;
        }
        if (this.hasValidNumber(this.mBarPlacementShiftYTextField, null, null) == false) {
            valid = false;
        }

        return valid;
    }

    private boolean isAnyElementsShown() {
        final Boolean line = this.getLineVisible();
        final Boolean symbol = this.getSymbolVisible();
        final Boolean bar = this.getBarVisible();

        List list = this.mPropertyDialogObserverList;
        for (int ii = 0; ii < list.size(); ii++) {
            SGISXYDataDialogObserver obs = (SGISXYDataDialogObserver) list
                    .get(ii);
            boolean lineVisible;
            boolean symbolVisible;
            boolean barVisible;

            if (line != null) {
                lineVisible = line.booleanValue();
            } else {
                lineVisible = obs.isLineVisible();
            }

            if (symbol != null) {
                symbolVisible = symbol.booleanValue();
            } else {
                symbolVisible = obs.isSymbolVisible();
            }

            if (bar != null) {
                barVisible = bar.booleanValue();
            } else {
                barVisible = obs.isBarVisible();
            }

            if (!lineVisible && !symbolVisible && !barVisible) {
                return false;
            }
        }

        return true;
    }

    /**
     * 
     * @param index
     */
    public boolean setSelectedIndex(final int index) {
        if (index < 0) {
            return false;
        }

        Component com = this.mTabbedPane.getComponent(index);

        int n = index;
        if (this.isTabEnabled(com) == false) {
            n = 0;
        }
        this.mTabbedPane.setSelectedIndex(n);

        return true;
    }

    /**
     * 
     * @return
     */
    public int getSelectedIndex() {
        return this.mTabbedPane.getSelectedIndex();
    }

    public static final String ERRMSG_BASELINE_VALUE_INVALID = "Baseline value is invalid.";
    
    
    /**
     * 
     */
    public boolean setPropertiesToListeners(SGIPropertyDialogObserver l) {
        SGISXYDataDialogObserver lxy = (SGISXYDataDialogObserver) l;

        // set the origin and step
        if (this.mMultipleDimensionStart != null) {
            lxy.setMultipleDimensionStart(this.mMultipleDimensionStart.intValue());
        }
        if (this.mMultipleDimensionEnd != null) {
            lxy.setMultipleDimensionEnd(this.mMultipleDimensionEnd.intValue());
        }
        if (this.mMultipleDimensionStep != null) {
            lxy.setMultipleDimensionStep(this.mMultipleDimensionStep.intValue());
        }
        
        // set data columns
        if (this.mDataInfoArray != null) {
            SGIDataPropertyDialogObserver obs = (SGIDataPropertyDialogObserver) this.mPropertyDialogObserverList
                    .get(0);
            if (obs.setColumnInfo(this.mDataInfoArray, this.mCommitActionStateMessage) == false) {
                return false;
            }
        }
        
        // set the related axes
        final int xLocation = this.mAxisPanel.getXAxisLocation();
        final int yLocation = this.mAxisPanel.getYAxisLocation();
        if (xLocation != -1) {
            lxy.setXAxisLocation(xLocation);
        }

        if (yLocation != -1) {
            lxy.setYAxisLocation(yLocation);
        }

        // data name
        String name = this.getDataName();
        if (name != null) {
            lxy.setName(name);
        }

        // visibility in legend
        Boolean legendVisible = this.getLegendVisible();
        if (legendVisible != null) {
            lxy.setVisibleInLegend(legendVisible.booleanValue());
        }

        //
        if (this.isTabEnabled(this.mLinePanel)) {
            if (this.setLineProperties(lxy) == false) {
                return false;
            }
            if (this.setSymbolProperties(lxy) == false) {
                return false;
            }
        }

        if (this.isTabEnabled(this.mBarPanel)) {
            if (this.setBarProperties(lxy) == false) {
                return false;
            }
        }

        if (this.isTabEnabled(this.mErrorBarPanel)) {
            if (this.setErrorBarProperties(lxy) == false) {
                return false;
            }
        }

        if (this.isTabEnabled(this.mTickLabelPanel)) {
            if (this.setTickLabelProperties(lxy) == false) {
                return false;
            }
        }
        
        return true;
    }


    private void setLineComponentsEnabled(Boolean flag) {
        boolean b = true;
        if (flag != null) {
            b = flag.booleanValue();
        }
        this.mLineColorButton.setEnabled(b);
        this.mLineColorLabel.setEnabled(b);
        this.mLineTypeLabel.setEnabled(b);
        this.mLineTypeComboBox.setEnabled(b);
        this.mLineWidthLabel.setEnabled(b);
        this.mLineWidthSpinner.setEnabled(b);
        this.mLineConnectCheckBox.setEnabled(b);
        
        this.setLinePlacementComponentsEnabled(b);
    }
    
    private void setLinePlacementComponentsEnabled(Boolean flag) {
        boolean b = true;
        Boolean lineVisible = this.getLineVisible();
        Boolean symbolVisible = this.getSymbolVisible();
        if (lineVisible != null && symbolVisible != null) {
            if (flag != null) {
                if (lineVisible.booleanValue() || symbolVisible.booleanValue()) {
                    b = true;
                } else {
                    b = false;
                }
            }
        }
        this.mLinePlacementLabel.setEnabled(b);
        this.mLinePlacementSeparator.setEnabled(b);
        this.mLinePlacementShiftXLabel.setEnabled(b);
        this.mLinePlacementShiftXTextField.setEnabled(b);
        this.mLinePlacementShiftYLabel.setEnabled(b);
        this.mLinePlacementShiftYTextField.setEnabled(b);
    }

    private void setSymbolComponentsEnabled(Boolean flag) {
        boolean b = true;
        if (flag != null) {
            b = flag.booleanValue();
        }
        this.mSymbolColorButton.setEnabled(b);
        this.mSymbolColorLabel.setEnabled(b);
        this.mSymbolLineColorButton.setEnabled(b);
        this.mSymbolLineColorLabel.setEnabled(b);
        this.mSymbolLineWidthLabel.setEnabled(b);
        this.mSymbolLineWidthSpinner.setEnabled(b);
        this.mSymbolLineVisibleCheckBox.setEnabled(b);
        this.mSymbolSizeLabel.setEnabled(b);
        this.mSymbolSizeSpinner.setEnabled(b);
        this.mSymbolTypeComboBox.setEnabled(b);
        this.mSymbolTypeLabel.setEnabled(b);
        this.mSymbolBodyLabel.setEnabled(b);
        this.mSymbolBodySeparator.setEnabled(b);
        this.mSymbolBodyTransparencyLabel.setEnabled(b);
        this.mSymbolBodyTransparencySpinner.setEnabled(b);
        this.mSymbolLineLabel.setEnabled(b);
        this.mSymbolLineSeparator.setEnabled(b);
        
        this.setLinePlacementComponentsEnabled(b);
    }
    
    private void setSymbolLineComponentsEnabled(Boolean flag) {
        boolean b = true;
        Boolean visible = this.getSymbolVisible();
        if (visible != null) {
            if (flag != null) {
                if (visible.booleanValue()) {
                    b = flag.booleanValue();
                } else {
                    b = false;
                }
            }
        }
        this.mSymbolLineColorButton.setEnabled(b);
        this.mSymbolLineColorLabel.setEnabled(b);
        this.mSymbolLineWidthLabel.setEnabled(b);
        this.mSymbolLineWidthSpinner.setEnabled(b);
    }

    private void setBarComponentsEnabled(Boolean flag) {
        boolean b = true;
        if (flag != null) {
            b = flag.booleanValue();
        }
        this.mBarBaseLineValueLabel.setEnabled(b);
        this.mBarBaseLineTextField.setEnabled(b);
        this.mBarColorLabel.setEnabled(b);
        this.mBarBodyColorFillRadioButton.setEnabled(b);
        this.mBarBodyColorPatternRadioButton.setEnabled(b);
        this.mBarBodyColorGradationRadioButton.setEnabled(b);
        this.mBarInnerColorButton.setEnabled(b);
        this.mBarBodyColorPatternPaintButton.setEnabled(b);
        this.mBarBodyColorGradationColorButton.setEnabled(b);
        this.mBarBodyTransparencyLabel.setEnabled(b);
        this.mBarBodyTransparencySpinner.setEnabled(b);
        this.mBarLineColorButton.setEnabled(b);
        this.mBarLineColorLabel.setEnabled(b);
        this.mBarLineWidthLabel.setEnabled(b);
        this.mBarLineWidthSpinner.setEnabled(b);
        this.mBarLineVisibleCheckBox.setEnabled(b);
        this.mBarWidthLabel.setEnabled(b);
        this.mBarLineWidthSpinner.setEnabled(b);
        this.mBarWidthSpinner.setEnabled(b);
        this.mBarWidthValueLabel.setEnabled(b);
        this.mBarWidthValueTextField.setEnabled(b);
        this.mBarVerticalCheckBox.setEnabled(b);
        this.mBarBodyLabel.setEnabled(b);
        this.mBarBodySeparator.setEnabled(b);
        this.mBarLineLabel.setEnabled(b);
        this.mBarLineSeparator.setEnabled(b);
        this.mBarPlacementLabel.setEnabled(b);
        this.mBarPlacementSeparator.setEnabled(b);
        this.mBarPlacementShiftXLabel.setEnabled(b);
        this.mBarPlacementShiftXTextField.setEnabled(b);
        this.mBarPlacementShiftYLabel.setEnabled(b);
        this.mBarPlacementShiftYTextField.setEnabled(b);
        this.mBarPlacementIntervalLabel.setEnabled(b);
        this.mBarPlacementIntervalTextField.setEnabled(b);
        
        this.setBarIntervalEnabled(this.getBarIntervalEnabledInMultipleSeriesBars());
    }
    
    private void setBarEdgeLineComponentsEnabled(Boolean flag) {
        boolean b = true;
        if (flag != null) {
        	Boolean visible = this.getBarVisible();
        	if (visible != null) {
                if (visible.booleanValue()) {
                    b = flag.booleanValue();
                } else {
                    b = false;
                }
        	}
        }
        this.mBarLineColorButton.setEnabled(b);
        this.mBarLineColorLabel.setEnabled(b);
        this.mBarLineWidthLabel.setEnabled(b);
        this.mBarLineWidthSpinner.setEnabled(b);
    }
    
    private String mTemporaryBarIntervalText = "";
    private void setBarIntervalEnabled(final boolean enabled) {
        if (enabled==false) {
            this.mTemporaryBarIntervalText = this.mBarPlacementIntervalTextField.getText();
            this.mBarPlacementIntervalLabel.setEnabled(enabled);
            this.mBarPlacementIntervalTextField.setEnabled(enabled);
            this.mBarPlacementIntervalTextField.setText("");
        }
    }

    private void setErrorBarComponentsEnabled(Boolean flag) {
        boolean b = true;
        if (flag != null) {
            b = flag.booleanValue();
        }
        this.mErrorBarBothsidesRadioButton.setEnabled(b);
        this.mErrorBarColorButton.setEnabled(b);
        this.mErrorBarColorLabel.setEnabled(b);
        this.mErrorBarDownsideRadioButton.setEnabled(b);
        this.mErrorBarLineWidthLabel1.setEnabled(b);
        this.mErrorBarLineWidthLabel2.setEnabled(b);
        this.mErrorBarLineWidthSpinner.setEnabled(b);
        this.mErrorBarSymbolSizeLabel.setEnabled(b);
        this.mErrorBarSymbolSizeSpinner.setEnabled(b);
        this.mErrorBarTypeComboBox.setEnabled(b);
        this.mErrorBarTypeLabel.setEnabled(b);
        this.mErrorBarUpsideRadioButton.setEnabled(b);
        this.mErrorBarVerticalCheckBox.setEnabled(b);
        this.mErrorBarSymbolLabel.setEnabled(b);
        this.mErrorBarSymbolSeparator.setEnabled(b);
        this.mErrorBarStyleLabel.setEnabled(b);
        this.mErrorBarStyleSeparator.setEnabled(b);
        this.mErrorBarPositionLabel.setEnabled(b);
        this.mErrorBarPositionSeparator.setEnabled(b);
        this.mErrorBarPositionLineRadioButton.setEnabled(b);
        this.mErrorBarPositionBarRadioButton.setEnabled(b);
    }

    private void setTickLabelComponentsEnabled(Boolean flag) {
        boolean b = true;
        if (flag != null) {
            b = flag.booleanValue();
        }
        this.mTickLabelAngleLabel.setEnabled(b);
        this.mTickLabelAngleSpinner.setEnabled(b);
        this.mTickLabelFontNameLabel.setEnabled(b);
        this.mTickLabelFontNameComboBox.setEnabled(b);
        this.mTickLabelFontLabel.setEnabled(b);
        this.mTickLabelFontSizeLabel.setEnabled(b);
        this.mTickLabelFontSizeSpinner.setEnabled(b);
        this.mTickLabelFontStyleLabel.setEnabled(b);
        this.mTickLabelFontStyleComboBox.setEnabled(b);
        this.mTickLabelColorButton.setEnabled(b);
        this.mTickLabelColorLabel.setEnabled(b);
        this.mTickLabelFormatLabel.setEnabled(b);
        this.mTickLabelDecimalPlacesLabel.setEnabled(b);
        this.mTickLabelDecimalPlacesSpinner.setEnabled(b);
        this.mTickLabelExponentLabel.setEnabled(b);
        this.mTickLabelExponentBaseLabel.setEnabled(b);
        this.mTickLabelExponentSpinner.setEnabled(b);
        this.mTickLabelHorizontalAlignmentCheckBox.setEnabled(b);
    }

    /**
     * 
     * @return
     */
    public boolean setDialogProperty() {
        List lList = this.mPropertyDialogObserverList;
        final int len = lList.size();

        // column selection button
        final boolean single = (len == 1);
        this.mDataColumnSelectionButton.setEnabled(single);

        // axes
        if (this.mAxisPanel.setSelected(lList) == false) {
            return false;
        }

        // data name
        String name = this.getDataNameFromObservers();
        this.setDataName(name);

        // visible in legend
        Boolean legendVisible = this.getLegendVisibleFromObservers();
        this.setLegendVisible(legendVisible);

        // set properties of lines, symbols, bars, error-bars and tick-labels
        if (this.setLineProperties(lList) == false) {
            return false;
        }

        if (this.setSymbolProperties(lList) == false) {
            return false;
        }

        if (this.setBarProperties(lList) == false) {
            return false;
        }

        if (this.setErrorBarProperties(lList) == false) {
            return false;
        }

        if (this.setTickLabelProperties(lList) == false) {
            return false;
        }

        int index = -1;
        for (int ii = 0; ii < len; ii++) {
            SGISXYDataDialogObserver l = (SGISXYDataDialogObserver) lList
                    .get(ii);
            final int num = l.getSelectedTabIndex();
            if (num != -1) {
                index = num;
                break;
            }
        }
        if (index == -1) {
            index = 0;
        }
        if (index == 1) {     // line tab contains symbol parameters.
            index = 0;
        } else if (index == 2) {
            index = 1;
        } else if (index == 3) {
            index = 2;
        } else if (index == 4) {
            index = 3;
        }
        this.mTabbedPane.setSelectedIndex(index);

        return true;
    }

    // set line properties
    private boolean setLineProperties(final List<SGISXYDataDialogObserver> list) {
        // System.out.println("<< setLineProperties >>");

        if (list == null) {
            return false;
        }
        if (list.size() == 0) {
            return false;
        }

        boolean solidLineFlag = false;

        SGISXYDataDialogObserver g0 = (SGISXYDataDialogObserver) list.get(0);
        final boolean visible0 = g0.isLineVisible();
        final float lineWidth0 = g0.getLineWidth(pt);
        final int lineType0 = g0.getLineType();
        final Color color0 = g0.getLineColor();
        final boolean connect0 = g0.isLineConnectingAll();
        final double lineShiftX0 = g0.getLineShiftX();
        final double lineShiftY0 = g0.getLineShiftY();

        if (lineType0 == SGILineConstants.LINE_TYPE_SOLID) {
            solidLineFlag = true;
        }

        Boolean visible = Boolean.valueOf(visible0);
        Float width = Float.valueOf(lineWidth0);
        Integer type = Integer.valueOf(lineType0);
        Color color = color0;
        Boolean connect = Boolean.valueOf(connect0);
        Double shiftx = Double.valueOf(lineShiftX0);
        Double shifty = Double.valueOf(lineShiftY0);

        if (list.size() > 1) {
            for (int ii = 1; ii < list.size(); ii++) {
                SGISXYDataDialogObserver g1 = (SGISXYDataDialogObserver) list
                        .get(ii);
                final boolean visible1 = g1.isLineVisible();
                if (visible0 != visible1) {
                    visible = null;
                    break;
                }
            }
            for (int ii = 1; ii < list.size(); ii++) {
                SGISXYDataDialogObserver g1 = (SGISXYDataDialogObserver) list
                        .get(ii);
                final float lineWidth1 = g1.getLineWidth(pt);
                if (lineWidth0 != lineWidth1) {
                    width = null;
                    break;
                }
            }
            for (int ii = 1; ii < list.size(); ii++) {
                SGISXYDataDialogObserver g1 = (SGISXYDataDialogObserver) list
                        .get(ii);
                final int lineType1 = g1.getLineType();
                if (lineType0 != lineType1) {
                    type = null;
                    break;
                }
            }
            if (!solidLineFlag) {
                for (int ii = 1; ii < list.size(); ii++) {
                    SGISXYDataDialogObserver g1 = (SGISXYDataDialogObserver) list
                            .get(ii);
                    final int lineType1 = g1.getLineType();
                    if (lineType1 == SGILineConstants.LINE_TYPE_SOLID) {
                        solidLineFlag = true;
                    }
                }
            }
            for (int ii = 1; ii < list.size(); ii++) {
                SGISXYDataDialogObserver g1 = (SGISXYDataDialogObserver) list
                        .get(ii);
                final Color color1 = g1.getLineColor();
                if (color0.equals(color1) == false) {
                    color = null;
                    break;
                }
            }
            for (int ii = 1; ii < list.size(); ii++) {
                SGISXYDataDialogObserver g1 = (SGISXYDataDialogObserver) list
                        .get(ii);
                final boolean connect1 = g1.isLineConnectingAll();
                if (connect0 != connect1) {
                    connect = null;
                    break;
                }
            }
            for (int ii = 1; ii < list.size(); ii++) {
                SGISXYDataDialogObserver g1 = (SGISXYDataDialogObserver) list
                        .get(ii);
                final double lineShiftX1 = g1.getLineShiftX();
                if (lineShiftX0 != lineShiftX1) {
                    shiftx = null;
                    break;
                }
            }
            for (int ii = 1; ii < list.size(); ii++) {
                SGISXYDataDialogObserver g1 = (SGISXYDataDialogObserver) list
                        .get(ii);
                final double lineShiftY1 = g1.getLineShiftY();
                if (lineShiftY0 != lineShiftY1) {
                    shifty = null;
                    break;
                }
            }
        }

        this.setLineVisible(visible);
        this.setLineWidth(width);
        this.setLineType(type);
        this.setLineColor(color);
        this.setLineConnection(connect);
        
        this.setLineShiftX(shiftx);
        this.setLineShiftY(shifty);
        
        /*
         * // enable or disable the stroke dialog button // When solid lines are
         * selected, the button is set disabled.
         * this.mLineEditButton.setEnabled(!solidLineFlag); if (!solidLineFlag) { //
         * set properties of the stroke dialog if
         * (this.mStrokeDialog.setDialogProperty() == false) { return false; } }
         */
        return true;
    }

    /**
     * 
     * @param group
     * @return
     */
    private boolean setSymbolProperties(final List<SGISXYDataDialogObserver> list) {
        // System.out.println("<< setSymbolProperties >>");

        if (list == null) {
            return false;
        }
        if (list.size() == 0) {
            return false;
        }

        SGISXYDataDialogObserver g0 = (SGISXYDataDialogObserver) list.get(0);
        final boolean visible0 = g0.isSymbolVisible();
        final float size0 = g0.getSymbolSize(cm);
        final float lineWidth0 = g0.getSymbolLineWidth(pt);
        final int type0 = g0.getSymbolType();
        final SGIPaint innerPaint0 = g0.getSymbolInnerPaint();
        final Color lineColor0 = g0.getSymbolLineColor();
        final boolean lineVisible0 = g0.isSymbolLineVisible();

        Boolean visible = Boolean.valueOf(visible0);
        Float size = Float.valueOf(size0);
        Float lineWidth = Float.valueOf(lineWidth0);
        Integer type = Integer.valueOf(type0);
        SGIPaint innerPaint = innerPaint0;
        Color lineColor = lineColor0;
        Boolean lineVisible = Boolean.valueOf(lineVisible0);

        if (list.size() > 1) {
            for (int ii = 1; ii < list.size(); ii++) {
                SGISXYDataDialogObserver g1 = (SGISXYDataDialogObserver) list
                        .get(ii);
                final boolean visible1 = g1.isSymbolVisible();
                if (visible0 != visible1) {
                    visible = null;
                    break;
                }
            }
            for (int ii = 1; ii < list.size(); ii++) {
                SGISXYDataDialogObserver g1 = (SGISXYDataDialogObserver) list
                        .get(ii);
                final float size1 = g1.getSymbolSize(cm);
                if (size0 != size1) {
                    size = null;
                    break;
                }
            }
            for (int ii = 1; ii < list.size(); ii++) {
                SGISXYDataDialogObserver g1 = (SGISXYDataDialogObserver) list
                        .get(ii);
                final float lineWidth1 = g1.getSymbolLineWidth(pt);
                if (lineWidth0 != lineWidth1) {
                    lineWidth = null;
                    break;
                }
            }
            for (int ii = 1; ii < list.size(); ii++) {
                SGISXYDataDialogObserver g1 = (SGISXYDataDialogObserver) list
                        .get(ii);
                final int type1 = g1.getSymbolType();
                if (type0 != type1) {
                    type = null;
                    break;
                }
            }
//            for (int ii = 1; ii < list.size(); ii++) {
//                SGISXYDataDialogObserver g1 = (SGISXYDataDialogObserver) list
//                        .get(ii);
//                final Color innerColor1 = g1.getSymbolInnerColor();
//                if (innerColor0.equals(innerColor1) == false) {
//                    innerColor = null;
//                    break;
//                }
//            }
            for (int ii = 1; ii < list.size(); ii++) {
                SGISXYDataDialogObserver g1 = (SGISXYDataDialogObserver) list
                        .get(ii);
                final SGIPaint innerPaint1 = g1.getSymbolInnerPaint();
                if (innerPaint0.equals(innerPaint1) == false) {
                    innerPaint = null;
                    break;
                }
            }
            for (int ii = 1; ii < list.size(); ii++) {
                SGISXYDataDialogObserver g1 = (SGISXYDataDialogObserver) list
                        .get(ii);
                final Color lineColor1 = g1.getSymbolLineColor();
                if (lineColor0.equals(lineColor1) == false) {
                    lineColor = null;
                    break;
                }
            }
            for (int ii = 1; ii < list.size(); ii++) {
                SGISXYDataDialogObserver g1 = (SGISXYDataDialogObserver) list
                        .get(ii);
                final boolean lineVisible1 = g1.isSymbolLineVisible();
                if (lineVisible0 != lineVisible1) {
                    lineVisible = null;
                    break;
                }
            }

        }

        this.setSymbolVisible(visible);
        this.setSymbolSize(size);
        this.setSymbolLineWidth(lineWidth);
        this.setSymbolType(type);
        this.setSymbolInnerPaint(innerPaint);
        this.setSymbolLineColor(lineColor);
        this.setSymbolLineVisible(lineVisible);

        return true;
    }

    /**
     * 
     * @param group
     * @return
     */
    private boolean setBarProperties(final List<SGISXYDataDialogObserver> list) {

        if (list == null) {
            return false;
        }
        if (list.size() == 0) {
            return false;
        }

        SGISXYDataDialogObserver g0 = (SGISXYDataDialogObserver) list.get(0);
        final boolean visible0 = g0.isBarVisible();
        final double width0 = g0.getBarWidthValue();
        final float edgeLineWidth0 = g0.getBarEdgeLineWidth(pt);
        final double baseline0 = g0.getBarBaselineValue();
        final SGIPaint innerPaint0 = g0.getBarInnerPaint();
        final Color edgeLineColor0 = g0.getBarEdgeLineColor();
        final boolean vertical0 = g0.isBarVertical();
        final boolean edgeLineVisible0 = g0.isBarEdgeLineVisible();
        final double shiftx0 = g0.getBarShiftX();
        final double shifty0 = g0.getBarShiftY();
        final double interval0 = g0.getBarInterval();

        Boolean visible = Boolean.valueOf(visible0);
        Double width = Double.valueOf(width0);
        Float edgeLineWidth = Float.valueOf(edgeLineWidth0);
        Double baseline = Double.valueOf(baseline0);
        SGIPaint innerPaint = innerPaint0;
        Color lineColor = edgeLineColor0;
        Boolean vertical = Boolean.valueOf(vertical0);
        Boolean edgeLineVisible = Boolean.valueOf(edgeLineVisible0);
        Double shiftX = Double.valueOf(shiftx0);
        Double shiftY = Double.valueOf(shifty0);
        Double interval = Double.valueOf(interval0);

        if (list.size() > 1) {
            for (int ii = 1; ii < list.size(); ii++) {
                SGISXYDataDialogObserver g1 = (SGISXYDataDialogObserver) list
                        .get(ii);
                final boolean visible1 = g1.isBarVisible();
                if (visible0 != visible1) {
                    visible = null;
                    break;
                }
            }
            for (int ii = 1; ii < list.size(); ii++) {
                SGISXYDataDialogObserver g1 = (SGISXYDataDialogObserver) list
                        .get(ii);
                final double width1 = g1.getBarWidthValue();
                if (width0 != width1) {
                    width = null;
                    break;
                }
            }
            for (int ii = 1; ii < list.size(); ii++) {
                SGISXYDataDialogObserver g1 = (SGISXYDataDialogObserver) list
                        .get(ii);
                final float edgeLineWidth1 = g1.getBarEdgeLineWidth(pt);
                if (edgeLineWidth0 != edgeLineWidth1) {
                    edgeLineWidth = null;
                    break;
                }
            }
            for (int ii = 1; ii < list.size(); ii++) {
                SGISXYDataDialogObserver g1 = (SGISXYDataDialogObserver) list
                        .get(ii);
                final double baseline1 = g1.getBarBaselineValue();
                if (baseline0 != baseline1) {
                    baseline = null;
                    break;
                }
            }
            for (int ii = 1; ii < list.size(); ii++) {
                SGISXYDataDialogObserver g1 = (SGISXYDataDialogObserver) list
                        .get(ii);
                final SGIPaint innerPaint1 = g1.getBarInnerPaint();
                if (innerPaint0.equals(innerPaint1) == false) {
                    innerPaint = null;
                    break;
                }
            }
            for (int ii = 1; ii < list.size(); ii++) {
                SGISXYDataDialogObserver g1 = (SGISXYDataDialogObserver) list
                        .get(ii);
                final Color edgeLineColor1 = g1.getBarEdgeLineColor();
                if (edgeLineColor0.equals(edgeLineColor1) == false) {
                    lineColor = null;
                    break;
                }
            }
            for (int ii = 1; ii < list.size(); ii++) {
                SGISXYDataDialogObserver g1 = (SGISXYDataDialogObserver) list
                        .get(ii);
                final boolean vertical1 = g1.isBarVertical();
                if (vertical0 != vertical1) {
                    vertical = null;
                    break;
                }
            }
            for (int ii = 1; ii < list.size(); ii++) {
                SGISXYDataDialogObserver g1 = (SGISXYDataDialogObserver) list
                        .get(ii);
                final boolean edgeLineVisible1 = g1.isBarEdgeLineVisible();
                if (edgeLineVisible0 != edgeLineVisible1) {
                    edgeLineVisible = null;
                    break;
                }
            }
            for (int ii = 1; ii < list.size(); ii++) {
                SGISXYDataDialogObserver g1 = (SGISXYDataDialogObserver) list
                        .get(ii);
                final double shiftx1 = g1.getBarShiftX();
                if (shiftx0 != shiftx1) {
                    shiftX = null;
                    break;
                }
            }
            for (int ii = 1; ii < list.size(); ii++) {
                SGISXYDataDialogObserver g1 = (SGISXYDataDialogObserver) list
                        .get(ii);
                final double shifty1 = g1.getBarShiftY();
                if (shifty0 != shifty1) {
                    shiftY = null;
                    break;
                }
            }
            for (int ii = 1; ii < list.size(); ii++) {
                SGISXYDataDialogObserver g1 = (SGISXYDataDialogObserver) list
                        .get(ii);
                final double interval1 = g1.getBarInterval();
                if (interval0 != interval1) {
                    interval = null;
                    break;
                }
            }
        }

        this.setBarVisible(visible);
        this.setBarWidth(width);
        this.setBarEdgeLineWidth(edgeLineWidth);
        this.setBarBaselineValue(baseline);
        this.setBarInnerPaint(innerPaint);
        this.setBarEdgeLineColor(lineColor);
        this.setBarVertical(vertical);
        this.setBarEdgeLineVisible(edgeLineVisible);
        this.setBarShiftX(shiftX);
        this.setBarShiftY(shiftY);
        this.setBarInterval(interval);

        this.setBarIntervalEnabled(this.getBarIntervalEnabledInMultipleSeriesBars());

        this.updateBarVerticalCheckBox();
        
        return true;
    }
    
    // update the visibility of vertical check box
    private void updateBarVerticalCheckBox() {
        Boolean barVisible = this.mBarVisibleCheckBox.getSelected();
        if (barVisible != null && barVisible.booleanValue()) {
        	Boolean verticalEnabled = null;
        	for (SGIPropertyDialogObserver g : this.mPropertyDialogObserverList) {
        		SGISXYDataDialogObserver gxy = (SGISXYDataDialogObserver) g;
                SGData data = (SGData) gxy.getData();
                final boolean b;
                if (SGDataUtility.isArrayData(data)) {
                	b = true;
                } else {
                	SGVariable xVar = null;
                	SGVariable yVar = null;
                	if (data instanceof SGSXYMultipleVariableNetCDFData) {
                		SGSXYMultipleVariableNetCDFData sxyData = (SGSXYMultipleVariableNetCDFData) data;
                		SGVariable[] xVars = sxyData.getXVariables();
                		SGVariable[] yVars = sxyData.getYVariables();
                		xVar = xVars[0];
                		yVar = yVars[0];
                	} else if (data instanceof SGSXYMultipleDimensionNetCDFData) {
                		SGSXYMultipleDimensionNetCDFData sxyData = (SGSXYMultipleDimensionNetCDFData) data;
                		xVar = sxyData.getXVariable();
                		yVar = sxyData.getYVariable();
                	}
                	if (xVar == null || yVar == null) {
                		throw new Error("Invalid column selection.");
                	}
                    b = (!xVar.isCoordinateVariable() && !yVar.isCoordinateVariable());
                }
                if (verticalEnabled == null) {
                	verticalEnabled = Boolean.valueOf(b);
                } else {
                    if (b != verticalEnabled.booleanValue()) {
                    	verticalEnabled = Boolean.valueOf(false);
                    	break;
                    }
                }
        	}
        	if (verticalEnabled != null) {
                this.mBarVerticalCheckBox.setEnabled(verticalEnabled.booleanValue());
        	}
        }
    }
    
    /**
     * 
     * @param group
     * @return
     */
    private boolean setErrorBarProperties(final List<SGISXYDataDialogObserver> list) {

        if (list == null) {
            return false;
        }
        if (list.size() == 0) {
            return false;
        }

        boolean available = true;
        for (int ii = 0; ii < list.size(); ii++) {
            SGISXYDataDialogObserver g = (SGISXYDataDialogObserver) list
                    .get(ii);
            if (g.isErrorBarAvailable() == false) {
                available = false;
                break;
            }
        }
        this.setTabEnabled(this.mErrorBarPanel, available);

        SGISXYDataDialogObserver g0 = (SGISXYDataDialogObserver) list.get(0);
        final boolean visible0 = g0.isErrorBarVisible();
        final float lineWidth0 = g0.getErrorBarLineWidth(pt);
        final float headSize0 = g0.getErrorBarHeadSize(cm);
        final int style0 = g0.getErrorBarStyle();
        final int type0 = g0.getErrorBarHeadType();
        final Color color0 = g0.getErrorBarColor();
        final boolean vertical0 = g0.isErrorBarVertical();
        final boolean isLinePosition0 = g0.isErrorBarOnLinePosition();

        Boolean visible = Boolean.valueOf(visible0);
        Float lineWidth = Float.valueOf(lineWidth0);
        Float headSize = Float.valueOf(headSize0);
        Integer style = Integer.valueOf(style0);
        Integer type = Integer.valueOf(type0);
        Color color = color0;
        Boolean vertical = Boolean.valueOf(vertical0);
        Boolean isLinePosition = Boolean.valueOf(isLinePosition0);

        if (list.size() > 1) {
            for (int ii = 1; ii < list.size(); ii++) {
                SGISXYDataDialogObserver g1 = (SGISXYDataDialogObserver) list
                        .get(ii);
                final boolean visible1 = g1.isErrorBarVisible();
                if (visible0 != visible1) {
                    visible = null;
                    break;
                }
            }
            for (int ii = 1; ii < list.size(); ii++) {
                SGISXYDataDialogObserver g1 = (SGISXYDataDialogObserver) list
                        .get(ii);
                final float lineWidth1 = g1.getErrorBarLineWidth(pt);
                if (lineWidth0 != lineWidth1) {
                    lineWidth = null;
                    break;
                }
            }
            for (int ii = 1; ii < list.size(); ii++) {
                SGISXYDataDialogObserver g1 = (SGISXYDataDialogObserver) list
                        .get(ii);
                final float headSize1 = g1.getErrorBarHeadSize(cm);
                if (headSize0 != headSize1) {
                    headSize = null;
                    break;
                }
            }
            for (int ii = 1; ii < list.size(); ii++) {
                SGISXYDataDialogObserver g1 = (SGISXYDataDialogObserver) list
                        .get(ii);
                final int style1 = g1.getErrorBarStyle();
                if (style0 != style1) {
                    style = null;
                    break;
                }
            }
            for (int ii = 1; ii < list.size(); ii++) {
                SGISXYDataDialogObserver g1 = (SGISXYDataDialogObserver) list
                        .get(ii);
                final int type1 = g1.getErrorBarHeadType();
                if (type0 != type1) {
                    type = null;
                    break;
                }
            }
            for (int ii = 1; ii < list.size(); ii++) {
                SGISXYDataDialogObserver g1 = (SGISXYDataDialogObserver) list
                        .get(ii);
                final Color color1 = g1.getErrorBarColor();
                if (color0.equals(color1) == false) {
                    color = null;
                    break;
                }
            }
            for (int ii = 1; ii < list.size(); ii++) {
                SGISXYDataDialogObserver g1 = (SGISXYDataDialogObserver) list
                        .get(ii);
                final boolean vertical1 = g1.isErrorBarVertical();
                if (vertical0 != vertical1) {
                    visible = null;
                    break;
                }
            }
            for (int ii = 1; ii < list.size(); ii++) {
                SGISXYDataDialogObserver g1 = (SGISXYDataDialogObserver) list
                        .get(ii);
                final boolean isLinePosition1 = g1.isErrorBarOnLinePosition();
                if (isLinePosition0 != isLinePosition1) {
                    visible = null;
                    break;
                }
            }
        }

        this.setErrorBarVisible(visible);
        if (headSize != null) {
            headSize = Float.valueOf(headSize.floatValue());
        }
        String typeName = null;
        if (type != null) {
            typeName = SGDrawingElementErrorBar.getHeadTypeName(type.intValue());
        }
        this.setErrorBarLineWidth(lineWidth);
        this.setErrorBarSymbolSize(headSize);
        this.setErrorBarStyle(style);
        this.setErrorBarType(typeName);
        this.setErrorBarColor(color);
        this.setErrorBarVertical(vertical);
        this.setErrorBarOnLinePosition(isLinePosition);

//        // set visible or invisible the check box
//        SGData data = (SGData) g0.getData();
//        final boolean cbVisible = SGDataUtility.isArrayData(data);
//        this.mErrorBarVerticalCheckBox.setVisible(cbVisible);

        return true;
    }

    /**
     * 
     * @param group
     * @return
     */
    private boolean setTickLabelProperties(final List<SGISXYDataDialogObserver> list) {

        if (list == null) {
            return false;
        }
        if (list.size() == 0) {
            return false;
        }

        boolean available = true;
        for (int ii = 0; ii < list.size(); ii++) {
            SGISXYDataDialogObserver g = (SGISXYDataDialogObserver) list
                    .get(ii);
            if (g.isTickLabelAvailable() == false) {
                available = false;
                break;
            }
        }
        this.setTabEnabled(this.mTickLabelPanel, available);
        
        SGISXYDataDialogObserver g0 = (SGISXYDataDialogObserver) list.get(0);
        final boolean visible0 = g0.isTickLabelVisible();
        final float fontSize0 = g0.getTickLabelFontSize(pt);
        final int style0 = g0.getTickLabelFontStyle();
        final String name0 = g0.getTickLabelFontName();
        final float angle0 = g0.getTickLabelAngle();
        final Color color0 = g0.getTickLabelColor();
        final int decimalPlaces0 = g0.getTickLabelDecimalPlaces();
        final int exponent0 = g0.getTickLabelExponent();
        final boolean horizontalAlignment0 = g0.hasTickLabelHorizontalAlignment();

        Boolean visible = Boolean.valueOf(visible0);
        Float fontSize = Float.valueOf(fontSize0);
        Integer style = Integer.valueOf(style0);
        String name = name0;
        Float angle = Float.valueOf(angle0);
        Color color = color0;
        Integer decimalPlaces = Integer.valueOf(decimalPlaces0);
        Integer exponent = Integer.valueOf(exponent0);
        Boolean horizontalAlignment = Boolean.valueOf(horizontalAlignment0);

        if (list.size() > 1) {
            for (int ii = 1; ii < list.size(); ii++) {
                SGISXYDataDialogObserver g1 = (SGISXYDataDialogObserver) list
                        .get(ii);
                final boolean visible1 = g1.isTickLabelVisible();
                if (visible0 != visible1) {
                    visible = null;
                    break;
                }
            }
            for (int ii = 1; ii < list.size(); ii++) {
                SGISXYDataDialogObserver g1 = (SGISXYDataDialogObserver) list
                        .get(ii);
                final float fontSize1 = g1.getTickLabelFontSize(pt);
                if (fontSize0 != fontSize1) {
                    fontSize = null;
                    break;
                }
            }
            for (int ii = 1; ii < list.size(); ii++) {
                SGISXYDataDialogObserver g1 = (SGISXYDataDialogObserver) list
                        .get(ii);
                final int style1 = g1.getTickLabelFontStyle();
                if (style0 != style1) {
                    style = null;
                    break;
                }
            }
            for (int ii = 1; ii < list.size(); ii++) {
                SGISXYDataDialogObserver g1 = (SGISXYDataDialogObserver) list
                        .get(ii);
                final String name1 = g1.getTickLabelFontName();
                if (name0.equals(name1) == false) {
                    name = null;
                    break;
                }
            }
            for (int ii = 1; ii < list.size(); ii++) {
                SGISXYDataDialogObserver g1 = (SGISXYDataDialogObserver) list
                        .get(ii);
                final float angle1 = g1.getTickLabelAngle();
                if (angle0 != angle1) {
                    angle = null;
                    break;
                }
            }
            for (int ii = 1; ii < list.size(); ii++) {
                SGISXYDataDialogObserver g1 = (SGISXYDataDialogObserver) list
                        .get(ii);
                final Color color1 = g1.getTickLabelColor();
                if (color0.equals(color1) == false) {
                    color = null;
                    break;
                }
            }
            for (int ii = 1; ii < list.size(); ii++) {
                SGISXYDataDialogObserver g1 = (SGISXYDataDialogObserver) list
                        .get(ii);
                final int decimalPlaces1 = g1.getTickLabelDecimalPlaces();
                if (decimalPlaces0 != decimalPlaces1) {
                    decimalPlaces = null;
                    break;
                }
            }
            for (int ii = 1; ii < list.size(); ii++) {
                SGISXYDataDialogObserver g1 = (SGISXYDataDialogObserver) list
                        .get(ii);
                final int exponent1 = g1.getTickLabelExponent();
                if (exponent0 != exponent1) {
                    exponent = null;
                    break;
                }
            }
            for (int ii = 1; ii < list.size(); ii++) {
                SGISXYDataDialogObserver g1 = (SGISXYDataDialogObserver) list
                        .get(ii);
                final boolean horizontalAlignment1 = g1.hasTickLabelHorizontalAlignment();
                if (horizontalAlignment0 != horizontalAlignment1) {
                	horizontalAlignment = null;
                    break;
                }
            }
        }

        this.setTickLabelVisible(visible);
        this.setTickLabelFontSize(fontSize);
        this.setTickLabelFontStyle(style);
        this.setTickLabelFontName(name);
        this.setTickLabelAngle(angle);
        this.setTickLabelColor(color);
        this.setTickLabelDecimalPlaces(decimalPlaces);
        this.setTickLabelExponent(exponent);
        this.setTickLabelHorizonalAlignment(horizontalAlignment);
        
        return true;
    }

    /**
     * 
     */
    private boolean setLineProperties(SGISXYDataDialogObserver l) {
        final Boolean visible = this.getLineVisible();
        if (visible != null) {
            l.setLineVisible(visible.booleanValue());
        }

        final Number lineWidth = this.getLineWidth();
        if (lineWidth != null) {
            l.setLineWidth(lineWidth.floatValue(), pt);
        }

        final Integer type = this.getLineType();
        if (type != null) {
            l.setLineType(type.intValue());
        }

        final Color color = this.getLineColor();
        if (color != null) {
            l.setLineColor(color);
        }
        
        final Boolean connect = this.getLineConnection();
        if (connect != null) {
            l.setLineConnectingAll(connect.booleanValue());
        }
        
        final Number lineShiftX = this.getLineShiftX();
        if (lineShiftX != null) {
            l.setLineShiftX(lineShiftX.doubleValue());
        }
        
        final Number lineShiftY = this.getLineShiftY();
        if (lineShiftY != null) {
            l.setLineShiftY(lineShiftY.doubleValue());
        }

        return true;
    }

    /**
     * 
     */
    private boolean setSymbolProperties(SGISXYDataDialogObserver l) {

        final Boolean visible = this.getSymbolVisible();
        if (visible != null) {
            l.setSymbolVisible(visible.booleanValue());
        }

        final Number size = this.getSymbolSize();
        if (size != null) {
            l.setSymbolSize(size.floatValue(), cm);
        }

        final Integer type = this.getSymbolType();
        if (type != null) {
            l.setSymbolType(type.intValue());
        }

        final SGIPaint innerPaint = this.getSymbolInnerPaint();
        if (innerPaint != null) {
            l.setSymbolInnerPaint(innerPaint);
        }

        final Number lineWidth = this.getSymbolLineWidth();
        if (lineWidth != null) {
            l.setSymbolLineWidth(lineWidth.floatValue(), pt);
        }

        final Color lineColor = this.getSymbolLineColor();
        if (lineColor != null) {
            l.setSymbolLineColor(lineColor);
        }

        final Boolean lineVisible = this.getSymbolLineVisible();
        if (lineVisible != null) {
            l.setSymbolLineVisible(lineVisible.booleanValue());
        }
        
        final Number shiftX = this.getLineShiftX();
        if (shiftX != null) {
            l.setSymbolShiftX(shiftX.doubleValue());
        }
        
        final Number shiftY = this.getLineShiftY();
        if (shiftY != null) {
            l.setSymbolShiftY(shiftY.doubleValue());
        }
        
        return true;
    }

    /**
     * 
     */
    private boolean setBarProperties(SGISXYDataDialogObserver l) {

        final Boolean visible = this.getBarVisible();
        if (visible != null) {
            l.setBarVisible(visible.booleanValue());
        }

        final SGIPaint innerPaint = this.getBarBodyPaint();
        if (innerPaint != null) {
            l.setBarInnerPaint(innerPaint);
        }

        Number barWidth = this.getBarWidth();
        if (barWidth != null) {
            l.setBarWidthValue(barWidth.doubleValue());
        }

        Number edgeLineWidth = this.getBarEdgeLineWidth();
        if (edgeLineWidth != null) {
            l.setBarEdgeLineWidth(edgeLineWidth.floatValue(), pt);
        }

        Color lineColor = this.getBarEdgeLineColor();
        if (lineColor != null) {
            l.setBarEdgeLineColor(lineColor);
        }
        
        Boolean lineVisible = this.getBarEdgeLineVisible();
        if (lineVisible != null) {
            l.setBarEdgeLineVisible(lineVisible.booleanValue());
        }

        Number value = this.getBarBaselineValue();
        if (value != null) {
            l.setBarBaselineValue(value.doubleValue());
        }
        
        Boolean vertical = this.isBarVertical();
        if (vertical != null) {
        	l.setBarVertical(vertical.booleanValue());
        }
        
        Number shiftx = this.getBarShiftX();
        if (shiftx != null) {
            l.setBarShiftX(shiftx.doubleValue());
        }
        
        Number shifty = this.getBarShiftY();
        if (shifty != null) {
            l.setBarShiftY(shifty.doubleValue());
        }
        
        Number interval = this.getBarInterval();
        if (interval != null) {
            l.setBarInterval(interval.doubleValue());
        }

        return true;
    }

    /**
     * 
     */
    private boolean setErrorBarProperties(SGISXYDataDialogObserver l) {

        final Boolean visible = this.getErrorBarVisible();
        if (visible != null) {
            l.setErrorBarVisible(visible.booleanValue());
        }

        final Color cl = this.getErrorBarColor();
        if (cl != null) {
            l.setErrorBarColor(cl);
        }

        final Number lineWidth = this.getErrorBarLineWidth();
        if (lineWidth != null) {
            l.setErrorBarLineWidth(lineWidth.floatValue(), pt);
        }

        final Number headSize = this.getErrorBarSymbolSize();
        if (headSize != null) {
            l.setErrorBarHeadSize(headSize.floatValue(), cm);
        }

        final Integer style = this.getErrorBarStyle();
        if (style != null) {
            l.setErrorBarStyle(style.intValue());
        }

        final String headSymbolTypeName = this.getErrorBarTypeName();
        final Integer type = SGDrawingElementErrorBar
                .getHeadTypeFromName(headSymbolTypeName);
        if (type != null) {
            l.setErrorBarHeadType(type.intValue());
        }
        
        final Boolean vertical = this.getErrorBarVertical();
        if (vertical != null) {
        	l.setErrorBarVertical(vertical.booleanValue());
        }
        
        final Boolean isLinePositionUsed = this.getErrorBarOnLinePosition();
        if (isLinePositionUsed != null) {
            l.setErrorBarOnLinePosition(isLinePositionUsed.booleanValue());
        }

        return true;
    }

    /**
     * 
     */
    private boolean setTickLabelProperties(SGISXYDataDialogObserver l) {

        Boolean visible = this.getTickLabelVisible();
        if (visible != null) {
            l.setTickLabelVisible(visible.booleanValue());
        }

        final Color cl = this.getTickLabelColor();
        if (cl != null) {
            l.setTickLabelColor(cl);
        }

        final String fontName = this.getTickLabelFontName();
        if (fontName != null) {
            l.setTickLabelFontName(fontName);
        }

        final Number fontSize = this.getTickLabelFontSize();
        if (fontSize != null) {
            l.setTickLabelFontSize(fontSize.floatValue(), pt);
        }

        final Integer fontStyle = this.getTickLabelFontStyle();
        if (fontStyle != null) {
            l.setTickLabelFontStyle(fontStyle.intValue());
        }

        final Number angle = this.getTickLabelAngle();
        if (angle != null) {
            l.setTickLabelAngle(angle.floatValue());
        }
        
        final Number decimalPlaces = this.getTickLabelDecimalPlaces();
        if (decimalPlaces != null) {
            l.setTickLabelDecimalPlaces(decimalPlaces.intValue());
        }
        
        final Number exponent = this.getTickLabelExponent();
        if (exponent != null) {
            l.setTickLabelExponent(exponent.intValue());
        }
        
        final Boolean horizontalAlignment = this.hasTickLabelHorizonalAlignment();
        if (horizontalAlignment != null) {
        	l.setTickLabelHorizontalAlignment(horizontalAlignment.booleanValue());
        }

        return true;
    }

    /**
     * Add a property dialog observer.
     * @param l  property dialog observer.
     * @return  true:succeeded, false:failed
     */
    /*	
     public boolean addPropertyDialogObserver(final SGIPropertyDialogObserver l) {
     if (super.addPropertyDialogObserver(l) == false) {
     return false;
     }
     return this.mStrokeDialog.addPropertyDialogObserver(l);
     }
     */
    /**
     * Remove a property dialog observer.
     * @param l  property dialog observer.
     * @return  true:succeeded, false:failed
     */
    /*	
     public boolean removePropertyDialogObserver(final SGIPropertyDialogObserver l) {
     if (super.removePropertyDialogObserver(l) == false) {
     return false;
     }
     return this.mStrokeDialog.removePropertyDialogObserver(l);
     }
     */
    /**
     * Remove all property dialog observers.
     * @return  true:succeeded, false:failed
     */
    /*	
     public boolean removeAllPropertyDialogObserver() {
     if (super.removeAllPropertyDialogObserver() == false) {
     return false;
     }
     return this.mStrokeDialog.removeAllPropertyDialogObserver();
     }
     */

    /**
     * Returns the OK button.
     * @return
     *        the OK button
     */
    protected JButton getOKButton() {
        return this.mOKButton;
    }
    
    /**
     * Returns the cancel button.
     * @return
     *        the cancel button
     */
    protected JButton getCancelButton() {
        return this.mCancelButton;
    }
    
    /**
     * Returns the preview button.
     * @return
     *        the preview button
     */
    protected JButton getPreviewButton() {
        return this.mPreviewButton;
    }
    
    /**
     * Overrode to clear an attribute.
     * 
     * @return true if succeeded
     */
    protected boolean onOK() {
        if (super.onOK() == false) {
            return false;
        }
        this.mMultipleDimensionStart = null;
        this.mMultipleDimensionEnd = null;
        this.mMultipleDimensionStep = null;
        return true;
    }
    
    /**
     * Overrode to clear an attribute.
     * 
     * @return true if succeeded
     */
    protected boolean onCanceled() {
        if (super.onCanceled() == false) {
            return false;
        }
        this.mMultipleDimensionStart = null;
        this.mMultipleDimensionEnd = null;
        this.mMultipleDimensionStep = null;
        return true;
    }

}
